#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : Board.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package Board;

#======================================================================
require 5.005;

use strict;
use vars qw(@ISA $VERSION $AUTOLOAD);
use CGI;
use Setup qw($CONFIG);
use CH::BoardClass;
use CH::Getform;
use CH::DBUtil;
use Member;

#----------------------------------------------------------------------
#
	@ISA = qw(CH::BoardClass);

	$MEMBER = Member->new();
	$SESSION = Login->new();
#----------------------------------------------------------------------
#
#
sub new {
	my $this = shift;
	my $class = ref($this) || $this;
	my $self = $class->SUPER::new;

	$self->{VERSION} = $VERSION;
	bless $self, $class;

	$HTTP_HEADER = 0;
	$self->_initialize(@_);
	return $self;
}

#----------------------------------------------------------------------
#
#
sub _initialize {
	my $self = shift;
	my %r_hash = @_;
	my $query = new CGI;

	$HTTP_HEADER = 0;
	$MEMBER = Member->new();
	$SESSION = Login->new();

	undef $IN;

	$self->{IN} = $IN;
	foreach ($query->param) {
		$IN->{$_} = $query->param($_);
	}

	#  ÷    ˾Ƴ  FileType ִ´.
	if ($IN->{AttachFile}) {
		$IN->{FileType} = $query->uploadInfo($IN->{AttachFile})->{'Content-Type'};
	}
	
#	(exists($r_hash{do})) ? $self->{do} = $r_hash{do} : $self->{do} = "i";
#	print "Content-type: text/html\n\n";
#	print $self->{do};

	if (defined($ENV{SCRIPT_NAME})) { $self->www_start() }
	else {
		print " Ʈ ڳݻ󿡼 Ͻ  ϴ.\n";
		exit(-1);
	}

}

#----------------------------------------------------------------------
#
#
sub www_start {
	my $self = shift;
	my $member_id = 0;
	my $session_id = 0;

	my $do = $IN->{do};
	$do = "" if (!defined $do);

	my $password = "";
	$password = $IN->{password} if (defined $IN->{password});

	return if (lc($do) eq "REGISTER");

	my $q = new CGI;
	if ($do eq "member_check") {
		$member_id = $IN->{member_id};
		my $good_member = $self->member_login($member_id, $password);

		if ($good_member) {
			$SESSION = Login->new($good_member);
			$MEMBER	= Member->new($good_member);
			my $s = $MEMBER->SESSION_ID();
			
			unless (-e "$CONFIG->{session_path}/$s") {
				my $tmp = {};
				DB->_dumper("$CONFIG->{session_path}/$s", $tmp);
			}

			$self->write_cookie($q, $good_member, $s);
		
		} else {
			$SESSION = Login->new($member_id);
		}

	} elsif ($do eq "logout") {
		($member_id, $session_id) = $self->read_cookie($q);
		$SESSION = Login->new($member_id);
		$SESSION->clear($ENV{'REMOTE_ADDR'});

		my $session_file = "$CONFIG->{member_directory}/online/$member_id";
		
		# who's online  .
		if (-e $session_file) {
			unlink ($session_file, "$session_file.location");
		}
		
		$member_id = "";
		$self->write_cookie($q, $member_id);
		$MEMBER = Member->new($member_id);
	
	} else {
		($member_id, $session_id) = $self->read_cookie($q);
		$self->_init_session($member_id, $session_id);
	}
}

sub _init_session {
	my ($self, $uid, $sid) = @_;
	my $user = $self->member_data($uid);
	
	if ($uid and $user->{STATUS}) {
		$MEMBER = Member->new($uid);
		$SESSION = Login->new($uid);
		
		if ($MEMBER->login_name()) {
			$SESSION->clear(DB->current_date(), $ENV{'REMOTE_ADDR'});
		}
	}
	else {
		$MEMBER = Member->new();
		$SESSION = Login->new();
		$sid = 0;
	}

	if ($sid and length($sid < 21)) {
		$SESSION->SESSION($sid);
	}
}

#----------------------------------------------------------------------
#
#
sub save_session {
	my ($self, $user_id, $pkg) = @_;

	$user_id = $ENV{REMOTE_ADDR} unless $user_id;

	my $CurrentDate = DB->date_time();
	my $session = "$CONFIG->{member_directory}/online/$user_id";
	my $date = DB->date_format( DB->y2k($CurrentDate->{date}) );
	
	if (-f "$session.location") {
		open (NEW, ">$session.location");
			flock(NEW, 2);
			print NEW $pkg;
		close NEW;
	}
	unless (-e $session) {
		open (FH, ">$session");
			flock(FH, 2);
			print FH $date . ", " . $CurrentDate->{time};
		close FH;
		open (FH, ">$session.location");
			flock(FH, 2);
			print FH $pkg;
		close FH;
	}
}

#----------------------------------------------------------------------
#
#
sub _read_session {
	my $self = shift;
	my $dir = "$CONFIG->{member_directory}/online";
	my @tmp = ();

	opendir(DIR, $dir);
		@tmp = readdir(DIR);
	close DIR;
	
	my @session_list = grep { /[^.location]$/o; } @tmp;
	my @session_file = ();
	
	foreach (@session_list) {
		if (-f "$dir/$_" and -M "$dir/$_" > .01) {
			unlink "$dir/$_", "$dir/$_.location";

			my $uid = DB->get_data($CONFIG->{users});
			$SESSION->clear($_) if exists $uid->{$_};
		}
		else { push @session_file, $_ }
	}
	
	return \@session_file;
}

#----------------------------------------------------------------------
#
#
sub whois_online {
	my $self = shift;
	my $session = $self->_read_session;
	my (@members, @guest, $output, @tmp);

	foreach (@$session) {
		if ($_ =~ /(\d+).(\d+).(\d+).(\d+)/) { push @guest, $_; }
		else { push @members, $_ };
	}

	my $member_num = scalar @members;
	my $guest_num = scalar @guest;
	$member_num ||= 0;
	$guest_num ||= 0;
	
	my $font = qq|font size="$CONFIG->{msg_font_size}" 
		color="$CONFIG->{msg_font_color}" face="$CONFIG->{msg_font_face}"|;
	
	my $font_header = qq|font size="$CONFIG->{msg_font_size}" 
		color="$CONFIG->{header_font_color}" face="$CONFIG->{msg_font_face}"|;
	
	my $table = qq|table border="0" cellpadding="$CONFIG->{table_cellpadding}" 
		cellspacing="$CONFIG->{table_border_width}" width="100%"|;

	$output = qq|
	<table width="$CONFIG->{table_width}" border="0" cellpadding="0" cellspacing="0">
		<tr>
		<td bgcolor="$CONFIG->{table_border_color}">
	<$table>
	<tr><td bgcolor="$CONFIG->{msg_box_color}">
		<$font>12    ȸ Դϴ.</font>
	</td></tr></table>
	</td></tr></table><BR>

	<$table>
	<tr><td bgcolor="$CONFIG->{forum_bgcolor}" align="center">
		<$font>ȸ : <b>$member_num</b> .</font>
	</table>
	<table width="$CONFIG->{table_width}" border="0" cellpadding="0" cellspacing="0">
		<tr>
		<td bgcolor="$CONFIG->{table_border_color}">
	<$table>
	<tr bgcolor="$CONFIG->{table_header_color}">
		<th>
		<$font_header>ȸ ID</font>
		</th>
		<th>
		<$font_header>ȸ з</font>
		</th>
		<th>
		<$font_header>ۼ</font>
		</th>
		<th width="33%">
		<$font_header> ð</font>
		</th>
		<th align="left" width="34%">
		<$font_header> ġ</font>
		</th>
	</tr>|;
	if (@members) {
		my $idx = 0;
		my ($member, $member_id, $post, $level, $login_time, $location, $bgcolor);
		
		foreach (@members) {
			$member = $MEMBER->new($_);
			$member_id = $member->MEMBER_ID;
			$post = $member->POST;
			$level = $self->member_level($member->LEVEL);
			($login_time, $location);

			open (TMP, "$CONFIG->{member_directory}/online/$_");
				flock(TMP, 1);
				$login_time = <TMP>;
			close TMP;
			open (TMP, "$CONFIG->{member_directory}/online/$_.location");
				flock(TMP, 1);
				$location = <TMP>;
			close TMP;

			$location = $self->_location($location);
			$bgcolor = DB->color($idx);
		
			$output .= qq|
			<tr $bgcolor>
			<td align="center"><$font>
			<b><a href=\"index.cgi?ch=Member&do=member_profile&ID=$_\">$member_id</a></b></font>
			</td><td align="center">
				<$font>$level</font>
			</td><td align="center">
				<$font>$post</font>
			</td><td align="center">
				<$font>$login_time</font>
			</td><td>
				<$font>$location</font>
			</td></tr>|;
			$idx++;
		}
	}
	else {
		$output .= qq|
		<tr bgcolor="white">
		<td colspan="5" align="center">
			<$font> </font>
		</td></tr>|;
	}

	$output .= qq|
		</table>
		</td></tr></table>
		<BR>
	<$table>
	<tr><td bgcolor="$CONFIG->{forum_bgcolor}" align="center">
		<$font>͸ : <b>$guest_num</b> .</font>
	</td></tr>
	</table>
	<table width="$CONFIG->{table_width}" border="0" cellpadding="0" cellspacing="0">
		<tr>
		<td bgcolor="$CONFIG->{table_border_color}">
	<$table>
	<tr bgcolor="$CONFIG->{table_header_color}">
		<td width="33%">
		<$font_header><b>͸ </b></font>
		</td>
		<td width="33%">
		<$font_header><b> ð</b></font>
		</td>
		<td width="34%">
		<$font_header><b> ġ</b></font>
		</td>
	</tr>|;

	if (@guest) {
		my ($login_time, $location, $bgcolor);
		my $idx = 0;
		
		foreach (@guest) {

			open (TMP, "$CONFIG->{member_directory}/online/$_");
				flock(TMP, 1);
				($login_time, $location) = split /\Q$CONFIG->{db_delim}\E/, <TMP>;
			close TMP;
			open (TMP, "$CONFIG->{member_directory}/online/$_.location");
				flock(TMP, 1);
				$location = <TMP>;
			close TMP;

			$location = $self->_location($location);
			$bgcolor = DB->color($idx);

			$output .= qq|
			<tr $bgcolor>
			<td>
				<$font><b>$_</b></font>
			</td><td>
				<$font>$login_time</font>
			</td><td>
				<$font>$location</font>
			</td></tr>|;
			$idx++;
		}
	}
	else {
		$output .= qq|
		<tr bgcolor="white">
		<td colspan="3" align="center">
			<$font> </font>
		</td></tr>|;
	}
	$output .= "</table></td></tr></table>";

	return $output;
}

#----------------------------------------------------------------------
#
#
sub _location {
	my ($self, $target) = @_;
	my %location;

	%location = (
		Home		=> 'ó ȭ ֽϴ.',
		WhoisOnline	=> '   ֽϴ.',
		PostList	=> '   ֽϴ.',
		member		=> 'α Դϴ.',
		SearchForm	=> ' ˻ Դϴ.',
		register_form	=> 'ȸ  Դϴ.',
		ReadPost	=> ' а ֽϴ.',
		Help		=> ' а ֽϴ.',
		NewTopic	=> '  ۼ Դϴ.',
		NewReply	=> '亯 ۼ Դϴ.',
		NewEdit		=> ' ϰ ֽϴ.',
		member_profile	=> 'ȸ   ֽϴ.',
		Sendmail	=> 'ȸ   ֽϴ.',
		Pds			=> 'ڷ ̿ Դϴ.',
	);

	return $location{$target};
}

#----------------------------------------------------------------------
#
#
sub member_login {
	my ($self, $member_id, $password) = @_;

	if (!$member_id || !$password) { return 0 }

	my $list = DB->get_data($CONFIG->{users});
	$password = DB->encrypt($password);

	foreach (keys %{$list}) {
		if ($list->{$_} eq $member_id) {
			my $member_file = $self->member_data($_);
			if ($member_file->{'PASSWORD'} eq $password) {
				$MEMBER = Member->new($_);
				return $_;
			}
		}
	}
	return 0;
}

#----------------------------------------------------------------------
#
#  Ѵ.
#
#----------------------------------------------------------------------
sub output {
	my $self = shift;
	
	if (@_) {
		if (defined ($ENV{SCRIPT_NAME})) {
			$self->html_header();
		}
		print @_;
	}
	
	exit(-1);
}

#----------------------------------------------------------------------
#
#
sub main {
	my ($self, $module) = @_;
	my $html_output = '';
	
	if ( exists($IN->{ch}) ) {
		if ($IN->{ch} eq "Forum") {
			$html_output = $self->plugin($module);
		}
		elsif ($IN->{ch} eq "Admin") {
			if ($MEMBER->login_name() and $MEMBER->LEVEL == 9) {
				$html_output = $self->$module();
			}
			else { 
				my $uid = $MEMBER->MEMBER_ID();
				$uid = 'ȸ' unless $uid;
				
				my $msg = "<b>$uid     Ͻ  ϴ.</b>";
				$html_output = $self->error_msg(" !", $msg) }
		}
		else { $html_output = $self->$module(); }
	}
	else { 
		$html_output = $self->plugin($module); 
	}
	
	$html_output ? $self->output($html_output) : exit;
}

#======================================================================
#
#			   ---  ε ---
#
#======================================================================
sub plugin {
	my ($self, $module) = @_;

	$self->save_session($MEMBER->USER_ID, $module);
	my $module = "Plugins::$module";
	use base qw(CH::Base);
	use CH::Base;

	my $params = defined $_[0] && UNIVERSAL::isa($_[0], 'HASH') ?
		shift : {@_};

	return undef unless $self->load($module);
	return $module->new($params) ||
		$self->error_msg("÷  ε  : ", $module->error);
}

#----------------------------------------------------------------------
#
# Ѿ  require Ͽ εѴ.
#
#----------------------------------------------------------------------
sub load {
	my ($self, $module) = @_;
	$module =~ s,::,/,g;
	$module .= '.pm';
	eval { require $module; };
}

#----------------------------------------------------------------------
#
# write_cookie()  Ű  д´.
#
#----------------------------------------------------------------------
sub read_cookie {
	my ($self, $q) = @_;
	my $user_id = $q->cookie('user_id');
	my $session = $q->cookie('session');

	return ($user_id, $session);
}

#----------------------------------------------------------------------
#
# write_cookie()  Ű  д´.
#
#----------------------------------------------------------------------
sub write_cookie {
	my $self = shift;
	my ($q, $user_id, $s) = @_;

	my $c1 = $q->cookie(
				-name 		=> 'user_id',
				-value		=> "$user_id",
				-path		=> '/',
				-expires	=> '+6M',
			);
	my $c2 = $q->cookie(
				-name		=> 'session',
				-value		=> "$s",
				-path		=> '/',
				-expires	=> '+6M',
			);
	my %cookie_hash = (-cookie=>[$c1, $c2]);
	$self->html_header(\%cookie_hash);

	return 1;
}


#----------------------------------------------------------------------
#
#
sub menu {
	my $self = shift;
	my $menu;
	my $target = $self->target();

	# ȭ α׾ƿ , $target óȭ Ѵ.
	if ($target =~ /do=logout/) { $target = 'index.cgi'; }

	if ( $MEMBER->login_name() ) {

		# óȭ  'ó/ڷ' ޴ .
		unless (! $ENV{QUERY_STRING}) {
			$menu .= "<a href=\"$target\">ڷ</a> | ";
		}
		
		if ($MEMBER->LEVEL == 9) {
			$menu .= "<a href=\"index.cgi?ch=Admin\"></a> | ";
		}
		
		$menu .= "<a href=\"index.cgi?ch=Forum&do=WhoisOnline\">ȸ</a> | ";
		$menu .= "<a href=\"index.cgi?ch=Member&do=members_list&sort=ALL\">ȸ</a> | ";
		
		if ($IN->{do} eq 'PostList') {
			$menu .= "<a href=\"index.cgi?ch=Forum&do=NewTopic&cid=$IN->{cid}&b=$IN->{b}\">۾</a> | ";
		}

		$menu .= "<a href=\"index.cgi?ch=Member&do=edit_profile\"></a> | ";
		$menu .= "<a href=\"index.cgi?ch=Forum&do=SearchForm\">˻</a> | ";
		$menu .= "<a href=\"index.cgi?ch=Login&do=logout\">ħ</a>";
	} else {

		# óȭ Ǵ α ƿ   'ó/ڷ' ޴ .
		unless ((!$ENV{QUERY_STRING}) || $IN->{do} eq 'logout') {
			$menu .= "<a href=\"$target\">ڷ</a> | ";
		}
		unless ($IN->{do} eq 'member') {
			$menu .= qq~ <a href="index.cgi?ch=Login&do=member"></a> | ~;
		}
		$menu .= "<a href=\"index.cgi?ch=Forum&do=WhoisOnline\">ȸ</a> | ";
		$menu .= "<a href=\"index.cgi?ch=Member&do=members_list&sort=ALL\">ȸ</a> | ";
		if ($IN->{do} eq 'PostList') {
			$menu .= "<a href=\"index.cgi?ch=Forum&do=NewTopic&cid=$IN->{cid}&b=$IN->{b}\">۾</a> | ";
		}
		$menu .= "<a href=\"index.cgi?ch=Forum&do=SearchForm\">˻</a> ";
		
		if ($CONFIG->{auth_allow_registration}) {
			$menu .= qq~ | <a href="index.cgi?ch=Member&do=register_form">ȸ</a> ~;
		}
	}
	$menu .= " | <a href=\"index.cgi?ch=Forum&do=Help\"></a>";
	
	my $output .= qq|
		<table border="0" width="$CONFIG->{table_width}" cellpadding="0" cellspacing="0">
		<tr><td align="center"><$VARS->{font}><B>$CONFIG->{title}</B><p>$menu</font>
		$VARS->{table_bottom}<BR>|;

	return $output;
}

#----------------------------------------------------------------------
#
#
sub login_msg {
	my $self = shift;
	my $name = $MEMBER->login_name();
	my $output;

	if ($name) {
		$output = "ȳϼ? <b>$name</b> .";
	} else {
		$output = "<a href=\"index.cgi?ch=Login&do=member\"></a>Ͽ ֽʽÿ.";
	}
}

#----------------------------------------------------------------------
#
#
sub forum_type {
	my ($self, $type) = @_;
	my %r = (
		'0'	=> '',
		'1'	=> 'ȸ',
		'9'	=> ''
	);
	return $r{$type};
}

#----------------------------------------------------------------------
#
#
sub member_level {
	my ($self, $level) = @_;
	my %r = (
		'0'	=> 'մ',
		'1'	=> 'ȸ',
		'2'	=> 'ȸ',
		'3'	=> '',
		'9'	=> ''
	);
	return $r{$level};
}

#----------------------------------------------------------------------
#
#
sub member_icon {
	my ($self, $member_level) = @_;
	my %team_icon = (
			3 => 'team',
			9 => 'admin'
		);
	my $s = "<IMG SRC=\"$CONFIG->{images_url}/$team_icon{$member_level}.gif\" BORDER=\"0\" ALIGN=\"ABSMIDDLE\">";
}

#----------------------------------------------------------------------
#   ȸ  ´.
#----------------------------------------------------------------------
sub read_member {
	my $self = shift;

	if ($MEMBER->USER_ID) {
		my $user_id = $MEMBER->USER_ID;
		my $r_data = DB->get_data("$CONFIG->{member_directory}/$user_id.cgi");
		return $r_data;
	}
	return 0;
}

#----------------------------------------------------------------------
#
#
sub member_data {
	my ($self, $user_id) = @_;
	my $r_data = DB->get_data("$CONFIG->{member_directory}/$user_id.cgi");

	return $r_data;
}

#----------------------------------------------------------------------
# forum.info  ȸ  Ͽ Եȴ.
#----------------------------------------------------------------------
sub license_msg {
	my $self = shift;
	my $DateTime = DB()->date_time;
	my $msg = <<MESSAGE;
#======================================================================
# CHBoard  -  ۷ Ʈ
#
#       : âȣ
#   Ȩ  : www.koinweb.co.kr
#         : contact\@koinweb.co.kr
#   ϰ  : $DateTime->{date}, $DateTime->{time}
#
# Copyright (c) 2001 Koinweb. All Rights Reserved.
#======================================================================

MESSAGE

	return $msg;
}

#----------------------------------------------------------------------
#
#
sub topic_def {
	my ($self, $subject) = @_;
	my $db_cols = {
			ID		=> [ 0, 0 ],
			SORT		=> [ 1, DB->sort_time() ],
			SUBJECT		=> [ 2, $subject ],
		};
}

#----------------------------------------------------------------------
#
#
sub field_name { [ qw(ID SORT SUBJECT) ]; }


#----------------------------------------------------------------------
#
#
sub threads_def {
	my ($self, $IN) = @_;
	my $CurrentDate = DB->date_time();
	my $db_cols = {
			TR			=> [ 0, '' ],
			THREADNO	=> [ 1, 0 ],
			SUBJECT		=> [ 2, $IN->{Subject} ],
			MESSAGE		=> [ 3, $IN->{Message} ],
			AUTHOR		=> [ 4, $IN->{Author} ],
			DATE		=> [ 5, DB->date_format( DB->y2k($CurrentDate->{date}) ) ],
			TIME		=> [ 6, $CurrentDate->{time} ],
			IP			=> [ 7, DB->get_ip() ],
			MSG_ICON	=> [ 8, $IN->{icon} ],
			REPLIES		=> [ 9, 0 ],
			USER_ID		=> [ 10, $IN->{UserID} ],
			VIEW		=> [ 11, 0 ],
			ATTACH		=> [ 12, '' ],
			ATTACH_SIZE	=> [ 13, '' ],
			ATTACH_TYPE	=> [ 14, '' ],
			FILENAME	=> [ 15, '' ],
			CLOSED		=> [ 16, 0 ],
			MODERATOR	=> [ 17, 0 ],
			MAIL		=> [ 18, $IN->{Mailer} ]
	};
}

#----------------------------------------------------------------------
#
#
sub readpost_field {
	[ qw( TR THREADNO SUBJECT MESSAGE AUTHOR DATE TIME IP 
		MSG_ICON USER_ID ATTACH ATTACH_SIZE ATTACH_TYPE FILENAME ) ]
}

#----------------------------------------------------------------------
#
#
sub display_system {
	my $self = shift;

	my $output = $self->shell ("޸ ", "\/usr\/bin\/free");
	$output .= $self->shell ("Ƽ", "\/bin\/df");
	$output .= $self->shell ("Ÿ", "\/usr\/bin\/uptime");
	$output .= $self->shell ("", "\/usr\/bin\/top\ -b\ -n 1");
	$output .= $self->shell ("μ", "\/bin\/ps\ aux");
	$output .= $self->shell ("Ʈũ Ʈ", "\/bin\/netstat\ -a");
	$output .= $self->shell ("Ʈũ ", "\/bin\/netstat\ -i");
	$output .= $self->shell ("Ʈũ Ʈ", "\/sbin\/route");
	$output .= $self->shell ("Ʈ", "\/bin\/dmesg");
	$output .= $self->shell ("Ϸ!", "");
}

#----------------------------------------------------------------------
#
#
sub shell {
	my ($self, $title, $val) = @_;
	my $s = "";
	my $tmp = "";

	$s .= qq~<table width="100%" cellpadding="2" cellspacing="0" border="0">
		<tr bgcolor=#cccccc>
			<td><$VARS->{font}><b>$title</b></font>
			</td>
		</tr></table>~;

	if ($val) {
		$tmp = "<PRE>";
		open (INPUT, "$val |");
			while (my $line = <INPUT>) {
				$line =~ s/</\&lt/g;
				$line =~ s/>/\&gt/g;
				$tmp .= $line;
			}
		$tmp .= "</PRE>";
		close INPUT;
	}
	return $s . $tmp;
}

#----------------------------------------------------------------------
#
#
sub _check {
	my $self = shift;
	my $check = FormCheck->new;

	$check->verify_multi(
			[
				{
					-name		=> 'Subject',
				  	-msg_name	=> ' ',
				  	-value		=> $IN->{Subject},
				  	-type		=> 'subject'
				},
				{	-name		=> 'Message',
					-msg_name	=> ' ',
					-value		=> $IN->{Message},
					-type		=> 'message'
				},
				{	-name		=> 'Author',
					-msg_name	=> '۾ ̸',
					-value		=> $IN->{Author},
					-type		=> 'name'
				}

			]
		);

	if ($check->errors) {
		$self->error_msg("۾     ߻Ͽϴ.", $check->errors);
	}
	else { 
		return 1; 
	}
}

#----------------------------------------------------------------------
#
#
sub error_msg {
	my $self = shift;
	my ($msg, $err) = @_;
	my $target = $self->target();

	$self->{TEMPLATE} = DB->load_template("error.html");
	$self->{TEMPLATE}->param( DB->style_vars(" ߻Ͽϴ.") );
	$self->{TEMPLATE}->param(
				msg			=> $msg,
				err			=> $err,
				goback		=> $target,
				target		=> "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5; URL=$target\">",
			);
	$self->html_header();
	print $self->{TEMPLATE}->output;
	exit(-1);
}

#----------------------------------------------------------------------
#
#
sub navigation_bar {
	my ($self, $pkg, $cid, $location) = @_;
	my $output = ();
	
	$pkg =~ s/^(.+)::(.+)$/$2/;
	
	my $cat = DB->get_data($CONFIG->{cat_file});
	my $dir = "<IMG SRC=\"$CONFIG->{images_url}/arrow.gif\" ALIGN=\"ABSMIDDLE\">";
	my $homeimg = "<IMG SRC=\"$CONFIG->{images_url}/home.gif\" ALIGN=\"ABSMIDDLE\">";
	
	if ($pkg eq "PostList") {
		$output = "$homeimg <a href=\"index.cgi\">ó</a>" .
			" $dir " .
			"<a href=\"index.cgi?ch=Forum&cid=$cid\">$cat->{$cid}->{Name} ۷</a>" .
			" $dir " .
			$location;
	}
	elsif ( $pkg =~ /ReadPost|NewTopic|WritePost|WriteReply|NewReply|EditPost|
			WriteEdit|RemoveThreads|RemoveSuccess|MoveTopic|Pds/ ) {
		my $forum = DB->forum_data($location);
		$output = "$homeimg <a href=\"index.cgi\">ó</a>" .
			" $dir " .
			"<a href=\"index.cgi?ch=Forum&cid=$cid\">$cat->{$cid}->{Name} ۷</a>" .
			" $dir " .
			"<a href=\"index.cgi?ch=Forum&do=PostList&cid=$cid&b=$location\">$forum->{Name}" .
			" (" . $self->forum_type($forum->{Type}) . ")</a>" .
			" $dir ";
	}		
	else { $output = "$homeimg <a href=\"index.cgi\">ó</a> $dir $pkg"; }
	
	return $output;
}

#----------------------------------------------------------------------
#
#
sub target { $ENV{HTTP_REFERER} }

#----------------------------------------------------------------------
#
#
sub redirect_login {
	my $self = shift;
	my $q = CGI->new;
	my $target = $q->url(-relative => 1, -query => 1);
	$target =~ s/;/&/g;

	return $target;
}

sub redirect {
	my ($self, $location) = @_;
	my $q = new CGI;
	
	$CONFIG->{script_url} =~ s/\/$//;
	$location = $CONFIG->{script_url} . "/$location" if ($location !~ m,^http://,);
	
	print $q->redirect($location);
	
	exit 0;
}

#----------------------------------------------------------------------
#
#
sub forum_permission {
	my ($self, $forum_name) = @_;
	my $forum = DB->forum_data($forum_name);
	my $acl;

	unless ($forum->{Type}) { $acl = 1; }
	elsif ($forum->{Type} == 1 and $MEMBER->login_name()) { $acl = 1; }
	elsif ($forum->{Type} == 9 and $MEMBER->login_name() and $MEMBER->LEVEL > 1) { $acl = 1; }
	else { $acl = 0; }

	return $acl;
}

#----------------------------------------------------------------------
#
#
sub private_permission {
	my ($self, $forum_name) = @_;
	my $forum = DB->forum_data($forum_name);
	my $acl;

	unless ($forum->{Type}) { $acl = 1; }
	elsif ($forum->{Type} == 9 and $MEMBER->LEVEL > 1) { $acl = 1; }
	elsif ($forum->{Type} == 1) { $acl = 1; }
	else { $acl = 0; }

	return $acl;
}

#----------------------------------------------------------------------
#
#
sub edit_permission {
	my ($self, $forum_name) = @_;
	my $forum = DB->forum_data($forum_name);
	my $acl = 0;
	
	foreach (@{$forum->{Moderator}}) {
		$MEMBER->USER_ID() == $_ and $acl = 1 and last;
	}
	$acl = 1 if $MEMBER->LEVEL() == 9;

	return $acl;
}

sub goforum {
	my $self = shift;
	my ($forum, $forum_type, $output);
	
	my $category = DB->get_data($CONFIG->{cat_file});
	
	$output = qq|<form name="drop_down" method="post">
		<font size="2"> ̵:</font>
		<select name="go" onChange="go_forum()">
		<option value="index.cgi"> ó\n|;

	CATEGORY:
	foreach my $cat (sort { ${$category->{$a}}{ID} <=> ${$category->{$b}}{ID} } keys %$category) {
		next CATEGORY if $category->{$cat}->{Status} eq "Off";
		
		if (@{$category->{$cat}->{ForumList}}) {
			$output .= "<option value=\"index.cgi?ch=Forum&cid=$cat\">$category->{$cat}->{Name} ۷";
		}

		FORUM:
		foreach (sort @{$category->{$cat}->{ForumList}}) {
			$forum = DB->forum_data($_);
			next FORUM if $forum->{Status} eq "Off";
			next FORUM if ($forum->{Type} == 9 and $CONFIG->{hidden_private} and $MEMBER->LEVEL < 2);
			
			$forum_type = $self->forum_type($forum->{Type});
			
			$output .= "<option value=\"index.cgi?ch=Forum&do=PostList&cid=$cat&b=$_\"";
			$output .= " selected" if $IN->{b} eq $_;
			$output .= ">&nbsp;&nbsp;|--$forum->{Name} ($forum_type)\n";
		}
	}
	$output .= "</select></form>";

	return $output;
}

sub js_goforum {
	my $self = shift;
	my $s = "<SCRIPT LANGUAGE=\"JavaScript\">\n" .
		"<!--\n" .
		"function go_forum() {\n" .
		"	var number = document.drop_down.go.selectedIndex;\n" .
		"	var url = document.drop_down.go.options[number].value;\n" .
		"	if (url != \"Shortcuts\") {;\n" .
		"		location.href = url;\n" .
		"	}\n" .
		"}\n";
	$s .= 	"//-->\n</SCRIPT>";
	return $s;
}

#----------------------------------------------------------------------
1;
