#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : DBUtil.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package CH::DBUtil;

#----------------------------------------------------------------------
#
use strict;
use Setup qw/$CONFIG $VARS/;
use vars qw/@EXPORT @ISA $DATA $VERSION $AUTOLOAD/;
require Exporter;

	@ISA = qw/Exporter Board/;
	@EXPORT = qw/DB/;

	my $DB = bless {}, __PACKAGE__;

	$VERSION = sprintf("%s.%02s", q$Revision: 0.71 $ =~ /:\s*(\d+)\.(\d+)/);

sub DB() { return $DB }

#----------------------------------------------------------------------
#
#
sub load_template {
	my $self = shift;
	my $file = shift;
	my $open = quotemeta('<%');
	my $close = quotemeta('%>');

	my $filter = sub {
			my $text_ref = shift;
			${$text_ref} =~ s/$open\s*(.*?)\s*$close/<TMPL_$1>/g;
		};
	require CH::Template;
	my $template = new CH::Template (
				'filename'		=> $file,
				'path'			=> $CONFIG->{template_path},
				'option'		=> 'value',
				'filter'		=> $filter,
				'chche'			=> 1,
				'die_on_bad_params'	=> 0,
				@_
			);
}

#----------------------------------------------------------------------
#
#
sub style_vars {
	my ($self, $title) = @_;
	my $header = sub {
		my $tpl = $self->load_template("header.html");
		$tpl->param( 
				site_title 	=> $CONFIG->{site_title},
				title		=> $CONFIG->{title} . " :: " . $title,
				css		=> "$CONFIG->{public_url}/style.css",
				html_bgcolor	=> $CONFIG->{forum_bgcolor},
			);
			return $tpl->output;
		};
	
	my $footer = sub {
		my $tpl = $self->load_template("footer.html");
		$tpl->param(
				homepage 	=> $CONFIG->{site_url},
				contact_us 	=> $CONFIG->{contact_email},
				version 	=> $VERSION,
				copyright	=> $CONFIG->{copyright},
			);
			return $tpl->output;
		};
	
	my $vars = {	
			menu		=> $self->menu(),
			header		=> &$header,
			footer		=> &$footer,
			today		=> $self->current_date . " ($CONFIG->{time_zone})",
		};
	while ( my ($key, $val) = each %{$VARS} ) {
		$vars->{$key} = $val;
	}
	
	return $vars;
}

sub insert_tpl {
	my ($self, $data, $file) = @_;
	my $tpl = $self->load_template($file);
	
	while ( my ($key, $val) = each %$data) {
		$tpl->param( $key => $val );
	}

	return $tpl->output;
}

#----------------------------------------------------------------------
#
#
sub data_rows {
	my $self = shift;
	my $data_cols = shift;
	my $data_row = [];
	
	foreach ( sort { $data_cols->{$a}[0] <=> $data_cols->{$b}[0] } keys %{$data_cols} ) {
		push (@{$data_row}, $data_cols->{$_}[1]);
	}
	
	return $data_row;
}

#----------------------------------------------------------------------
#
#
sub append_data {
	my $self = shift;
	my ($file, $data_line) = @_;
	
	$self->_lock($file);
	open (FH, $file) or $self->error_msg("$file    ϴ. $!\n");
	open (NEW, ">$file.tmp") or $self->error_msg("$file.tmp    ϴ. $!\n");
		print NEW "$data_line\n";
		print NEW  while (<FH>);
	close NEW;
	close FH;
	
	if (-s "$file.tmp" > 0) {
		if (! rename ("$file.tmp", $file)) {
			open (NEW, ">$file");
			open (FH, "$file.tmp");
				print NEW while (<FH>);
			close FH;
			close NEW;
		}
	}
	$self->_unlock($file);
}

#----------------------------------------------------------------------
#
#
sub read_data {
	my $self = shift;
	my ($sort, $forum, $db_file, $view, $structure) = @_;
	my ($r_data, $content) = [];
	
	$sort ||= "date";
	my $date = (DB->sort_time() - $view);
	my $data = $self->read_file("$CONFIG->{forum_path}/$forum/$db_file");

	foreach (@$data) {
		chomp;
		my @tmp = split /\Q$CONFIG->{db_delim}\E/;
		$tmp[1] >= $date ? push @$content, $_ : next;
	}

	@$r_data = $self->_make_list_of_hash($sort, $content, $structure);
	$r_data;
}

#----------------------------------------------------------------------
#
#
sub read_threads {
	my $proto = shift;
	my ($forum, $db_file, $structure) = @_;
	my $r_data = [];
	
	my $data = $proto->read_file("$CONFIG->{forum_path}/$forum/$db_file");
	
	LINE: foreach (@$data) {
		chomp;
		next LINE if /^TOPIC/;
		push @$r_data, { $proto->array_to_hash($_, @$structure) };
	}
	
	$r_data;
}

sub read_file {
	my ($self, $file) = @_;
	my $r_data = [];
	
	$self->_lock($file);
	open (FH, "<$file") or $self->error_msg(" б ", "$file   ϴ. $!");
		@$r_data = <FH>;
	close FH;
	$self->_unlock($file);
	
	$r_data;
}

sub write_file {
	my ($self, $file, $data) = @_;
	
	$self->_lock($file);
	open (FH, ">$file") or $self->error_msg("  ", "$file   ϴ. $!");
		print FH @$data;
	close FH;

	chmod 0666, $file;
	$self->_unlock($file);
}

sub _dumper {
	my $self = shift;
	my ($file, $data) = @_;
	
	$self->_lock($file);
	open (FH, ">$file") or $self->error_msg(" ", "$file   ϴ. $!");
		print FH $self->license_msg;
		print FH CH::Dumper->dump( data => $data, var => '' );
	close FH;

	chmod 0666, $file;
	$self->_unlock($file);

}

sub data_split {
	my @r_data = split (/\Q$CONFIG->{db_delim}\E/, $_[1]);
}

#----------------------------------------------------------------------
#
#
sub insert_data {
	my ($self, $forum, $id) = @_;
	my @status = ();
	my $TopicLine = {};
	my $data = $self->read_file("$CONFIG->{forum_path}/$forum/$id.cgi");

	foreach (@$data) {
		/^REPLY/ and last;
		chomp;
		@status = $self->data_split($_);
	}
	
	$TopicLine = {
		SUBJECT		=> $status[1],
		AUTHOR		=> $status[2],
		DATE		=> "<$VARS->{font}>$status[3]</font>",
		TIME		=> "<$VARS->{font_time}>$status[4]</font>",
		MSG_ICON	=> "<IMG SRC=\"$CONFIG->{images_url}/icons/$status[5].gif\" ALIGN=\"ABSMIDDLE\"> ",
		REPLIES 	=> "<$VARS->{font}>$status[6]</font>",
		USER_ID		=> $status[7],
		VIEW		=> "<$VARS->{font}>$status[8]</font>",
		ATTACH		=> $status[9],
		ATTACH_SIZE	=> $status[10],
		ATTACH_TYPE	=> $status[11],
		CLOSE		=> $status[13],
		MODERATOR	=> $status[14]
	};
	

	return $TopicLine;
}

#----------------------------------------------------------------------
#
#
sub _make_list_of_hash {
	my ($proto, $sort, $content, $structure) = @_;
	chomp @$content;

	my @data = ();
	foreach (@$content) {
		push @data, { $proto->array_to_hash($_, @$structure) };
	}
	
	# , ð  .
	if ($sort eq "subject") {			
		return sort { 
			$a->{SUBJECT} cmp $b->{SUBJECT} ||
			$b->{SORT} <=> $a->{SORT}
			} @data;
	} 
	
	# ð,   .
	else {
		return sort { 
			$b->{SORT} <=> $a->{SORT} ||
			$a->{SUBJECT} cmp $b->{SUBJECT}
			} @data;
	}
}

#----------------------------------------------------------------------
#
#
sub array_to_hash {
	my ($proto, $data_row, @keys) = @_;
	my @data = ();

	chomp $data_row;
	@data =  split(/\Q$CONFIG->{db_delim}\E/, $data_row);
	
	my $idx;
	return map { $keys[$idx] => $data[ 0 * ($#keys + 1) + $idx++ ],  } @data;
}

#---------------------------------------------------------------------
#
#
sub span_page {
	my $proto = shift;
	my ($start, $end, $total, $PerPage, $IN) = @_;
	my ($HyperLinks, $TotalPage, $idx, $link, $uri, @AllLinks) = ();
	my ($vars, $key, $CurrentPage, $PrevPage, $NextPage, $page) = ();

	unless ($total) { return "<B>ϱ </B>"; }
	
	$TotalPage = int (($total - 1) / $PerPage) + 1;
	return 0 if $TotalPage == 1;
	
	$CurrentPage = $IN->{page};
	
	delete $IN->{page};
	
	for $key (keys %{$IN}) {
		$vars .= $proto->url_encode($key) . "=" . $proto->url_encode($IN->{$key}) . '&amp;';
	}
	
	my $StartPage = $CurrentPage - 5;
	my $EndPage = $CurrentPage + 5;
	
	if ($StartPage < 0) {
		$EndPage = $EndPage - $StartPage;
		$StartPage = 0;
	}
	if ($EndPage > $TotalPage) {
		$EndPage = $TotalPage;
		$StartPage = $EndPage - 10;
	}
	
	$StartPage = 0 if $StartPage < 0;
	
	for ($idx = $StartPage; $idx <= $EndPage - 1; $idx++) {
		$page = $idx + 1;
		$uri = "index.cgi?$vars" . "page=$page";
		$link = ($CurrentPage == $page) ? "<B>$page</B>" : "<a href=\"$uri\"><b>$page</b></a>";
		push @AllLinks, $link;
	}

	$HyperLinks = join(" ", @AllLinks);
	
	if ($CurrentPage > 1) {
		$page = $CurrentPage - 1;
		$uri = "index.cgi?$vars" . "page=$page";
		$PrevPage = "[<a href=\"$uri\"></a>] ";
	} 
	else { $PrevPage = ""; }

	if ($CurrentPage < $TotalPage) {
		$page = $CurrentPage + 1;
		$uri = "index.cgi?$vars" . "page=$page";
		$NextPage = " [<a href=\"$uri\"></a>]";
	} 
	else { $NextPage = ""; }
	
	my $LastPage; my $FirstPage;
	if (10 < $TotalPage && $CurrentPage != $TotalPage) {
		$uri = "index.cgi?$vars" . "page=$TotalPage";
		$LastPage = "[<a href=\"$uri\"></a>]";
	}
	if (10 < $TotalPage && $CurrentPage > 1) {
		$uri = "index.cgi?$vars" . "page=1";
		$FirstPage = "[<a href=\"$uri\">ó</a>]";
	}

	return ": $FirstPage$PrevPage $HyperLinks $NextPage$LastPage";
}

#----------------------------------------------------------------------
#
#
sub url_encode {
	my $proto = shift;
	my ($string) = shift;
	my ($str, $c, $c1, $c2, $char) = ();
	my @hex = ('A'..'F');

	while ($string =~ m,(.),g) {
	$char = $1;
		if ($char !~ /([\w\. ])/) {
			$c = ord $char;
			$c1 = $c % 16;
			if ($c1 > 9) { $c1 = $hex[$c1 - 10]; }
			$c2 = int($c / 16);
			if ($c2 > 9) { $c2 = $hex[$c2 - 10]; }
			
			$char = "%$c2$c1";
		}
		$str .= $char;
	}
	$str =~ s/ /+/g;
	return $str;
}

#----------------------------------------------------------------------
#
#  ڸ   ̸̻ ߶󳽴.
# ѱ Ǵ ڰ ٸ ߸ óѴ.
#
#----------------------------------------------------------------------

sub trim_text {
	my ($proto, $s, $string_length) = @_;
	
	if ($string_length < length($s)) {
		$s = unpack("A$string_length", $s);	
		chop $s if ($s =~ y/[\xA1-\xFE][\xA1-\xFE]//) % 2 != 0;
		$s .= "...";
			
	}

	return $s;
}

#----------------------------------------------------------------------
#			-- flock function --
#----------------------------------------------------------------------

sub _lock {
	my $max_sleep = 30;
	my $lock_loc = "$CONFIG->{data_directory}/temp";
	my $time = time;

	my @path = split("/", $_[1]);
	my $lock_file = pop @path;
	my $lock_path = "$lock_loc/$lock_file.lock";

	open (LOCK, $lock_path);
		my $opened = <LOCK>;
	close LOCK;

	my $how_long = $time - $opened;

	if ($how_long <= 60) {
		my $sleep_count = undef;
		while (-e $lock_path || $how_long >= 60) {
			$sleep_count++;
			sleep 1;
			
			if ($sleep_count == $max_sleep) {
				$! = "ٸ  ͸  Դϴ.";
				return 0;
			}
		}
	}

	if (open (LOCK, ">$lock_path")) {
		print LOCK $time;
		close LOCK;
	}
	else { return 0; }
}

#----------------------------------------------------------------------
#			-- unlock function --
#----------------------------------------------------------------------

sub _unlock {
	my ($proto, $file) = @_;
	my $max_sleep = 15;
	my $lock_loc = "$CONFIG->{data_directory}/temp";
	my $pid = $$;

	my @path = split("/", $file);
	my $lock_file = pop @path;
	my $lock_path = "$lock_loc/$lock_file.lock";

	return (unlink $lock_path);
}

sub read_directory {
	my $proto = shift;
	my ($dir, $format) = @_;

	opendir(DIR, $dir);
		my @files_list = sort(readdir(DIR));
	close(DIR);

	my @return_list = grep { s/\.$format$//; } @files_list;
}

#----------------------------------------------------------------------
# 丮 Ѵ. , 丮 ȿ   ,
#    , 丮 Ѵ.
#----------------------------------------------------------------------
sub remove_directory {
	
	opendir(DIR, $_[1]) or die("$_[1] 丮   ϴ: $!\n");
		while ( defined(my $file = readdir(DIR)) ) {
			$file =~ /^\.\.?$/ and next;
			unlink("$_[1]/$file") or 
				die("$_[1]/$file    ϴ: $!\n");
		}
	closedir(DIR);
	
	rmdir($_[1]);
}

sub pds {
	my ($proto, $attach_id, $attach_file) = @_;
	my ($attach, $filesize, $filename, $file_ext);
	my %attach_file = ();
	
	$attach = CH::AttachFile->new($attach_file);
	$filename = $attach->orig_filename;
	
	if (! ($filesize = $attach->save_as("$CONFIG->{public_directory}/pds/tmp/$attach_id.file")) ) {
		
		return $attach_file{filesize};
	} 
	else {
		%attach_file = (
			filesize => $filesize,
			filename => $filename,
			);
		
		return \%attach_file;
	}
}

sub attach_file {
	my ($proto, $attach_id, $attach_file) = @_;
	my ($attach, $filesize, $filename, $file_ext);
	my %attach_file = ();
	
	$attach = CH::AttachFile->new($attach_file);
	$filename = $attach->orig_filename;
	
	if (! ($filesize = $attach->save_as("$CONFIG->{upload}/$attach_id.file")) ) {
		
		return $attach_file{filesize};
	} 
	else {
		%attach_file = (
			filesize => $filesize,
			filename => $filename,
			);
		
		return \%attach_file;
	}
}

#//////////////////////////////////////////////////////////////////////
#
#
sub date_time {
	my $proto = shift;
	my ($adjust_time, $js_time, $sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst);
	my $get_time = {};
	
	if ($CONFIG->{time_zone_offset}) {
		if ($CONFIG->{time_zone_offset} ne '0') {
			$adjust_time = time() + ($CONFIG->{time_zone_offset} * 3600);
		}
		else { 
			$adjust_time = time(); 
		}
		($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($adjust_time);
	}
	else {
		($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
	}
	
	$mon++;
	$get_time->{month} = $mon;
	$get_time->{year} = $year + 1900;
	$get_time->{last_login_date} = $proto->jday($get_time->{year}, $get_time->{month}, $mday);
	
	$hour = sprintf("%2d", $hour) and $hour =~ tr/ /0/;
	$min = sprintf("%2d", $min) and $min =~ tr/ /0/;
	$sec = sprintf("%2d", $sec) and $sec =~ tr/ /0/;
	
	$get_time->{sec} = $sec;
	$js_time = ("$hour" . "$min");
	
	$get_time->{last_login_j} = ($get_time->{last_login_date} + ($js_time * 0.0001));
	$get_time->{search} = ("$get_time->{last_login_date}" . "-$js_time$get_time->{sec}");
	
	($get_time->{ampm}, $get_time->{ampm_hour}) = $proto->normal_time($hour);
	
	$get_time->{min} = sprintf("%2d", $min) and $get_time->{min} =~ tr/ /0/;
	$get_time->{mon} = sprintf("%2d", $mon) and $get_time->{mon} =~ tr/ /0/;
	$get_time->{mday} = sprintf("%2d", $mday) and $get_time->{mday} =~ tr/ /0/;
	
	$get_time->{date} = ($get_time->{year} . "-" . $get_time->{mon} . "-" . $get_time->{mday});
	$get_time->{time} = ($get_time->{ampm} . " " . $get_time->{ampm_hour} . ":" . $get_time->{min});
	
	return $get_time;
}

#----------------------------------------------------------------------
#
#
sub convert_to_24 {
	my $proto = shift;
	my ($this_ampm, $this_hour, $this_min);
	if ($_[0] eq '') {
		if ($_[1] < 12) { 
			$this_hour = ($_[1] + 12);
		}
		else { $this_hour = $_[1]; }
	}
	if ($_[0] eq '') {
		if ($_[1] == 12) {
			$this_hour = '0';
		}
		else {
			$this_hour = $_[1];
		}
	}

	$this_hour = sprintf("%2d", $this_hour) and $this_hour =~ tr/ /0/;
	$this_min = sprintf("%2d", $_[2]) and $this_min =~ tr/ /0/;

	return ("$this_hour$this_min");
}

#----------------------------------------------------------------------
#
#
sub normal_time {
	my ($ampm, $hour);
	if ($_[1] < 12) {
		$ampm = ''; $hour = $_[1];
	}
	elsif ($_[1] > 12) { 
		$hour = $_[1] - 12; $ampm = '';
	}
	else {
		$ampm = ''; $hour = $_[1];
	}

	if ($hour == 0) {
		$hour = '12';
	}
	$hour = sprintf("%2d", $hour) and $hour =~ tr/ /0/;
	return ($ampm, $hour);
}

#----------------------------------------------------------------------
#
#
sub date_format {
	my ($year, $mon, $mday) = split(/-/, $_[1]);
	my @months = ("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12");

	if ($CONFIG->{date_format} eq 'DT_FORMAT1') {
		$year .= '';
		$mday .= '';
		return "$year $months[$mon-1] $mday";
	}
	elsif ($CONFIG->{date_format} eq 'DT_FORMAT2') {
		return "$year-$mon-$mday";
	}
	elsif ($CONFIG->{date_format} eq 'DT_FORMAT3') {
		$year = substr($year, 2);
		$year .= '';
		$mday .= '';
		return "$year $months[$mon-1] $mday";
	}
	elsif ($CONFIG->{date_format} eq 'DT_FORMAT4') {
		$year = substr($year, 2);
		return "$year-$mon-$mday";
	}
	else {
		return "$year/$mon/$mday";
	}
}

#----------------------------------------------------------------------
#
#
sub jdate {
	my $proto = shift;
	my ($jd) = @_;
	my ($jdate_tmp);
	my ($m, $d, $y, $wkday);

	$wkday = ($jd + 1) % 7;
	$jdate_tmp = $jd - 1721119;
	$y = int((4 * $jdate_tmp - 1) / 146097);
	$jdate_tmp = 4 * $jdate_tmp - 1 - 146097 * $y;
	$d = int($jdate_tmp / 4);
	$jdate_tmp = int((4 * $d + 3) / 1461);
	$d = 4 * $d + 3 - 1461 * $jdate_tmp;
	$d = int(($d + 4) / 4);
	$m = int((5 * $d - 3) / 153);
	$d = 5 * $d -3 -153 * $m;
	$d = int(($d + 5) / 5);
	$y = 100 * $y + $jdate_tmp;

	if ($m < 10) {
	$m += 3;
	}
	else {
		$m -= 9;
		++$y;
	}
	return ($y, $m, $d, $wkday);
}

#----------------------------------------------------------------------
#
#
sub jday {
	my $proto = shift;
	my ($y, $m, $d) = @_;
	my ($ya, $c, $jd);

	$y = (localtime(time))[5] + 1900 if ($y eq '');

	if ($m > 2) {
		$m -= 3;
	}
	else {
		$m += 9;
		--$y;
	}

	$c = int($y / 100);
	$ya = $y - (100 * $c);
	$jd = int((146097 * $c) / 4) + int((1461 * $ya) / 4) + int((153 * $m + 2) / 5) + $d + 1721119;
	return $jd;
}

#----------------------------------------------------------------------
#
#
sub is_jday {
	my $proto = shift;
	my ($is_jday) = 0;
	$is_jday = 1 if ($_[0] > 1721119);
}

#----------------------------------------------------------------------
#
#
sub month_name {
	my $proto = shift;
	my ($n, $m) = @_;
	my (@names) = ('1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12');

	if ($m ne '') {
		substr($names[$n-1], 0, $m);
	}
	else {
		$names[$n-1];
	}
}

#----------------------------------------------------------------------
#
#
sub month_num {
	my $proto = shift;
	my ($name) = @_;
	my %names = (
		'JAN' => 1,
		'FEB' => 2,
		'MAR' => 3,
		'APR' => 4,
		'MAY' => 5,
		'JUN' => 6,
		'JUL' => 7,
		'AUG' => 8,
		'SEP' => 9,
		'OCT' => 10,
		'NOV' => 11,
		'DEC' => 12
	);
	$name =~ tr/a-z/A-Z/;
	$name = substr($name, 0, 3);
	$names{$name};
}

#----------------------------------------------------------------------
#
#
sub weekday {
	my $proto = shift;
	my ($wd) = @_;
	("Ͽ", "", "ȭ", "", "", "ݿ", "")[$wd];
}

#----------------------------------------------------------------------
#
#
sub today {
	my $proto = shift;
	my (@today) = localtime(time);
	my ($d) = $today[3];
	my ($m) = $today[4];
	my ($y) = $today[5];
	$m += 1;
	$y += 1900;

	$proto->jday($y, $m, $d);
}

#----------------------------------------------------------------------
#
#
sub y2k {
	my ($year, $check_length);
	$check_length = length($_[1]);
	if ($check_length < 4) {
		if ($check_length == 2) {
			$year = ("19" . "$_[1]");
		}
		else {
			$year = $_[1] - 100;
			$year = sprintf("%2d", $year);
			$year =~ tr/ /0/;
			$year = ("20" . "$year");
		}
	}
	else {
		$year = $_[1];
	}
	return ($year);
}

#----------------------------------------------------------------------
#
#
sub current_date {
	my $proto = shift;
	my $date = $proto->date_time();
	my @date_array = split(/-/, $date->{date});
	my $year = $proto->y2k($date_array[0]);
	my $date_ok = "$year-$date_array[1]-$date_array[2]";
	my $this_date = $proto->date_format($date_ok);
	my $c_time = "<font color=\"$CONFIG->{time_font_color}\">$date->{time}</font>";
	return ($this_date .= " " . $c_time);
}

#----------------------------------------------------------------------
#
#
sub sort_time {
	my $proto = shift;
	my $date = $proto->date_time();
	my ($y, $m, $d) = split(/-/, $date->{date});
	my ($h, $min) = split(/:/, $date->{time});
	my $am_pm;
	($am_pm, $h) = split(/ /, $h);
	chomp $h;

	my $m_time = $proto->convert_to_24($am_pm, $h, $min);
	
	$y = $proto->y2k($y);
	my $post_date = $proto->jday($y, $m, $d);

	my $sort_date = ($post_date + ($m_time * 0.0001));
	$sort_date = sprintf("%7.4f", $sort_date);
	$sort_date =~ tr/ /0/;
	
	return $sort_date;
}

#//////////////////////////////////////////////////////////////////////
#----------------------------------------------------------------------
#
#
sub encrypt {
	use CH::MD5;
	my $self = shift;
	my $password = shift;
	my $ctx = CH::MD5->new;
	
	$ctx->add($password);
	$password = $ctx->hexdigest;
}

#----------------------------------------------------------------------
#
#
sub message_check {
	my ($proto, $s) = @_;
	
	$s =~ s/&/&amp;/gso;
	$s =~ s/\"/&quot;/gso;
	
	
	if ($CONFIG->{use_chcode}) { # chbode  ± ȯ.
	$s =~ s/</&lt;/gso;
	$s =~ s/>/&gt;/gso;
		
	$s =~ s,(\[[bB]\])(.+?)(\[/[bB]\]),<B>$2</B>,isg;
	$s =~ s,(\[[iI]\])(.+?)(\[/[iI]\]),<I>$2</I>,isg;
	$s =~ s,(\[[lL][iI]\])(.+?)(\[/[lL][iI]\]),<LI>$2</LI>,isg;
	$s =~ s,(\[[iI][mM][gG]\])(\S+?)(\[/[iI][mM][gG]\]),<IMG SRC="$2">,isg;
	$s =~ s,(\[[qQ][uU][oO][tT][eE]\])(.+?)(\[/[qQ][uU][oO][tT][eE]\]),<BLOCKQUOTE>ο<HR>$2<HR></BLOCKQUOTE>,isg;
	$s =~ s,(\[[uU][rR][lL]=)(http|https|ftp)(\://\S+?)(\])(.+?)(\[/[uU][rR][lL]\]),<A HREF="$2$3" TARGET=_BLANK>$5</A>,isg;
	$s =~ s,(\[[rR][uU][rR][lL]\])(http|https|ftp)(\://\S+?)(\[/[rR][uU][rR][lL]\]),
	<B> Ʈ:</B><BR><IFRAME FRAMEBORDER="1" WIDTH="98%" HEIGHT="300" ALIGN="CENTER" SRC="$2$3" SCROLLING="YES"></IFRAME>,isg;
	$s =~ s,(\[[uU][rR][lL]\])(http|https|ftp)(\://\S+?)(\[/[uU][rR][lL]\]),<A HREF="$2$3" TARGET=_BLANK>$2$3</A>,isg;
	$s =~ s#(\[[cC][oO][dD][eE]\])(.+?)(\[/[cC][oO][dD][eE]\])#<PRE><FONT SIZE="2" FACE="COURIER NEW, COURIER, ">$2</FONT></PRE>#isg;
	$s =~ s,(\[[eE][mM][aA][iI][lL]\])(\S+\@\S+?)(\[/[eE][mM][aA][iI][lL]\]),<A HREF="MAILTO:$2">$2</A>,isg;

	} 
	else { $s =~ s/\s{2,}/ /g; }; # chcode ƴ  2 ̻  ڸ ϳ.
	
	$s =~ s/'/&#39;/gso;
	$s =~ s/\|/&#0124;/sg;
	$s =~ s/\n\r\n/<P>/g;
	$s =~ s/\n/<BR>/g;
	$s =~ s/\r//g;
	$s =~ s/\cM//ig;
	$s =~ s/(<P>){2,}/<P>/ig;
	$s =~ s/(<BR>){4,}/<BR>/ig;
	$s =~ s/(<UL.*?>)(<BR>)/$1/ig;
	
	$s =~ s,(^|\s)(http://\S+), <A HREF="$2" TARGET=_BLANK>$2</A>,isg;
	$s =~ s,(^|\s)(www\.\S+), <A HREF="http://$2" TARGET=_BLANK>$2</A>,isg;

# ǥ.
	my %eicons = $proto->eicons();
	for (keys %eicons) {
		$s =~ s,\Q$eicons{$_}\E,<IMG SRC="$CONFIG->{images_url}/emotion/$_.gif">,isg;
	}
	
	return $s;
}

#----------------------------------------------------------------------
# ǥ  ؽ ̺.
#----------------------------------------------------------------------

sub eicons {
	my %eicons = (
		smile		=> ';-)',
		tongue		=> ':-P',
		mad			=> ';-(',
		cool		=> '8-)',
		eek			=> '8=)',
		redface		=> '8-(',
		rolleyes	=> '8=(',
		wink		=> 'P-)',
		confused	=> '?-(',
		frown		=> 'K-('
	);
}

#----------------------------------------------------------------------
#
#
sub msg_to_form {
	my ($self, $s) = @_;
	
	$s =~ s,&#0124;,|,sg;
	$s =~ s,<P>,\n\n,ig;
	$s =~ s,<BR>,\n,ig;

# ǥ.
	my %eicons = $self->eicons();
	
	for (keys %eicons) {
		$s =~ s,<IMG SRC="$CONFIG->{images_url}/emotion/$_.gif">,$eicons{$_},igs;
	}
	
	if ($CONFIG->{use_chcode}) {
		$s =~ s/(<IMG SRC=")(\S+?)(">)/\[IMG\]$2\[\/IMG\]/ig;
		$s =~ s/(<BLOCKQUOTE>)(.+?)(<\/BLOCKQUOTE>)/\[QUOTE\]$2\[\/QUOTE\]/igs;
		$s =~ s/(<PRE>)(.+?)(<\/PRE>)/\[CODE\]$2\[\/CODE\]/igs;
		$s =~ s/</\[/ig;
		$s =~ s/>/\]/ig;
		$s =~ s,&lt;,<,ig;
		$s =~ s/&gt;/>/ig;
	}
	
	$s =~ s,&quot;,",ig;
	$s =~ s,&amp;,&,ig;


	return $s;
}

#----------------------------------------------------------------------
#
#
sub text_trim {
	my $self = shift;
	my $s = shift;

	$s =~ s/^\s+//g;
	$s =~ s/\s+$//g;
	$s =~ s/\s{2,}/ /g;
	$s =~ s/&/&amp;/gso;
	$s =~ s/</&lt;/gso;
	$s =~ s/>/&gt;/gso;
	$s =~ s/\|/&#0124;/gso;
	$s =~ s/"/&quot;/gso;
	
	return $s;
}

sub search_text {
	my $self = shift;
	my $s = shift;
	my $query = shift;
	
	$s =~ s,$query,<FONT COLOR=RED><B>$query</B></FONT>,gso;
	return $s;
}

#----------------------------------------------------------------------
#
#
sub escape_map {
	my ($self, $data) = @_;
	my %ESCAPE_MAP;
	unless (exists($ESCAPE_MAP{chr($data)})) {
		for (0 .. 255) {
			$ESCAPE_MAP{chr($_)} = sprintf('%%%02X', $_);
		}
	}
	$data =~ s,([^a-zA-Z0-9_.\-]), $ESCAPE_MAP{!1},g;
	return $data;
}
#//////////////////////////////////////////////////////////////////////
# JavaScript  ƾ.
#
sub JSEmotion_CHCode {
	my $self = shift;
	my $s = "<SCRIPT LANGUAGE=\"JavaScript\">\n" .
		"<!--\n" .
		"function action() { return; }\n" .
		"function emotion_icon(add_emotion) {\n" .
		"	var add_emotion;\n" .
		"	var newMessage;\n" .
		"	var currentMessage = document.WritePost.Message.value;\n" .
		"	newMessage = currentMessage + add_emotion;\n" .
		"	document.WritePost.Message.value = newMessage;\n" .
		"	document.WritePost.Message.focus();\n" .
		"	return;\n" .
		"}\n";
	
	if ($CONFIG->{use_chcode}) {
		$s .= 	"function chcode(action) {\n" .
			"	var newMessage;\n" .
			"	var currentMessage = document.WritePost.Message.value;\n\n" .
			"	if (action == \"url\") {\n" .
			"	var URL = prompt(\" URL ԷϽʽÿ.\", \"http://\");\n" .
			"	var Title = prompt(\" URL  ԷϽʽÿ.\", \"Ʈ \");\n" .
			"	var chcode = \"[URL=\"+URL+\"]\"+Title+\"[/URL]\";\n" .
			"	newMessage = currentMessage + chcode;\n" .
			"	document.WritePost.Message.value = newMessage;\n" .
			"	document.WritePost.Message.focus();\n" .
			"	return;\n" .
			"	}\n\n" .
			"	if (action == \"rurl\") {\n" .
			"	var RURL = prompt(\" Ʈ URL ԷϽʽÿ.\", \"http://\");\n" .
			"	var chcode = \"[RURL]\"+RURL+\"[/RURL]\";\n" .
			"	newMessage = currentMessage + chcode;\n" .
			"	document.WritePost.Message.value = newMessage;\n" .
			"	document.WritePost.Message.focus();\n" .
			"	return;\n" .
			"	}\n\n" .
			"	if (action == \"email\") {\n" .
			"	var EMAIL = prompt(\"EMail ּҸ ԷϽʽÿ\", \"\");\n" .
			"	var chcode = \"[EMAIL]\"+EMAIL+\"[/EMAIL]\";\n" .
			"	newMessage = currentMessage + chcode;\n" .
			"	document.WritePost.Message.value = newMessage;\n" .
			"	document.WritePost.Message.focus();\n" .
			"	return;\n" .
			"	}\n\n" .
			"	if (action == \"bold\") {\n" .
			"	var BOLD = prompt(\"ü ǥ ڸ ԷϽʽÿ.\", \"\");\n" .
			"	var chcode = \"[B]\"+BOLD+\"[/B]\";\n" .
			"	newMessage = currentMessage + chcode;\n" .
			"	document.WritePost.Message.value = newMessage;\n" .
			"	document.WritePost.Message.focus();\n" .
			"	return;\n" .
			"	}\n\n" .
			"	if (action == \"image\") {\n" .
			"	var IMAGE = prompt(\"̹ URL ԷϽʽÿ.\", \"http://\");\n" .
			"	var chcode = \"[IMG]\"+IMAGE+\"[/IMG]\";\n" .
			"	newMessage = currentMessage + chcode;\n" .
			"	document.WritePost.Message.value = newMessage;\n" .
			"	document.WritePost.Message.focus();\n" .
			"	return;\n" .
			"	}\n\n" .
			"	if (action == \"quote\") {\n" .
			"	var chcode = \"[QUOTE] [/QUOTE]\";\n" .
			"	newMessage = currentMessage + chcode;\n" .
			"	document.WritePost.Message.value = newMessage;\n" .
			"	document.WritePost.Message.focus();\n" .
			"	return;\n" .
			"	}\n\n" .
			"	if (action == \"code\") {\n" .
			"	var chcode = \"[CODE] [/CODE]\";\n" .
			"	newMessage = currentMessage + chcode;\n" .
			"	document.WritePost.Message.value = newMessage;\n" .
			"	document.WritePost.Message.focus();\n" .
			"	return;\n" .
			"	}\n\n" .
			"	if (action == \"italics\") {\n" .
			"	var chcode = \"[I] [/I]\";\n" .
			"	newMessage = currentMessage + chcode;\n" .
			"	document.WritePost.Message.value = newMessage;\n" .
			"	document.WritePost.Message.focus();\n" .
			"	return;\n" .
			"	}\n" .
			"}\n";
	}
		$s .= 	"//-->\n</SCRIPT>";
			
	return $s;
}

#----------------------------------------------------------------------
#
#
sub message_icon {
	my $self = shift;
	my $format = shift;
	my (@the_icons, $value, $output, $i);
	
	@the_icons = $self->read_directory("$CONFIG->{public_directory}/images/icons", $format);
	
	my $break = 7;
	my $icons_row = scalar @the_icons / $break;
	
	for ($i = 0; $#the_icons >= $i; $i++) {
		($value, undef) = split /\./, $the_icons[$i];
		
		$output .= "<input type=\"RADIO\" name=\"icon\" value=\"$value\"";
		$output .= " checked" if $i == 0;
		$output .= "> <img src=\"$CONFIG->{images_url}/icons/$the_icons[$i]\">&nbsp;&nbsp;";
		
		for (1..$icons_row) {
			$output .= "<BR>" if (($_ * $break) - 1) == $i; 
		}
	}
	return $output;
}

#----------------------------------------------------------------------
#
#
sub emotion_chcode {
	my $self = shift;
	my @chcode = qw(url rurl email bold code quote image italics);
	my $s = "<TABLE BORDER=\"0\" CELLPADDING=\"0\" CELLSPACING=\"0\"><TR><TD>\n";
	
	my %eicons = $self->eicons();
	for (sort keys %eicons) {
		$s .= "<a href=\"JavaScript: action()\" onClick=\"emotion_icon(' $eicons{$_} ')\">";
		$s .= "<img src=\"$CONFIG->{images_url}/emotion/$_.gif\" border=\"0\"></a>&nbsp;&nbsp;\n";
	}
	
	$s .= "</TD></TR><TR><TD><BR>\n";

	if ($CONFIG->{use_chcode}) {
		for (my $idx = 0; $#chcode >= $idx; $idx++) {
			$s .= "<a href=\"JavaScript: action()\" onClick=\"chcode('$chcode[$idx]')\">";
			$s .= "<img src=\"$CONFIG->{images_url}/chcode/$chcode[$idx].gif\" border=\"0\"></a>&nbsp;";
			$s .= "<BR>\n" if $idx == 3;
		}
	}
	$s .= "</TD></TR></TABLE>\n";
}

#----------------------------------------------------------------------
#
#
sub forum_data {
	$_[0]->get_data("$CONFIG->{forum_path}/$_[1].info");
}

#----------------------------------------------------------------------
#
#
sub get_data {
	my $data = do $_[1];
	$data = $_[0]->data_vars($data);
}

#----------------------------------------------------------------------
#
#
sub data_vars {
	my $call = caller;

	no strict 'refs';
	*{$call . '::DATA'} = \$_[1];
	
	return $DATA;
}

#----------------------------------------------------------------------
#
#
sub color {
	my $color1 = "bgcolor=\"$CONFIG->{list_color1}\"";
	my $color2 = "bgcolor=\"$CONFIG->{list_color2}\"";
	
	my $bgcolor = $_[1] % 2;
	my $tb_bgcolor = $bgcolor ? $color2 : $color1;
}

#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : Dumper.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package CH::Dumper;

use strict;
use vars qw /$DEBUG @EXPORT $TAB/;
use Exporter;

$TAB        = '    ';
@EXPORT     = qw(Dumper);

sub new {
    	my $this  = shift;
    	my $class = ref $this || $this;
    	my $self  = bless {}, $class;
    	
	$self->_init (@_) if (@_ > 0);
}

sub _init {
    	my $self = shift;
    	my $opt  = {};
    	
	if (defined $_[0] and not @_ % 2) { 
		$opt = {@_} 
	} elsif (ref $_[0] and ref $_[0] eq 'HASH') { 
		$opt = shift 
	}
    
    	for (qw/code var data sort order/) { 
		$self->{$_} = $opt->{$_} if (exists $opt->{$_}) 
	}
   	 return $self;   
}

sub Dumper {
    	my $self;
    	
	if (@_ == 1) {
        	if (ref $_[0] eq 'CH::Dumper') {
            	$self = shift;
        	} else {
            		$self = CH::Dumper->new (
                        		var  => '$VAR',
                        		data => shift
                        		);
        	}
    	} elsif (@_ == 2) {
        	if ($_[0] eq 'CH::Dumper') {
            		$self = CH::Dumper->new (
                        		var  => '$VAR',
                            		data => $_[1]
                        		);
        	} else {
            		$self = shift;
            		$self->{data} = shift;
            		$self->{var} ||= '$VAR';
        	}
    	} else {
        	die "μ !";
    	}
    	
	return $self->dump;
}

sub dump {
    	my $this  = shift;

    	my $self;
    	
	if (!ref $this) {
        	$self = $this->new (@_);
    	} elsif (@_ > 0) {
        	$self = $this;
        	$self->init (@_);
    	} else {
        	$self = $this;
	}
    
   	my $level = 0;
    	my $ret;
    	my $code  = ref ($self->{code}) eq 'CODE' ? $self->{code} : sub { $ret .= $_[0] };
    
    	$code->("$self->{var} = ") unless defined $self->{var} and $self->{var} eq '';
    	$self->_dump_value ($level + 1, $self->{data}, $code);
    	$code->(";\n");
    	
	return $ret ? $ret : 1;
}

sub _dump_value {
    	my ($self, $level, $val, $code, $n) = @_;
    	my $was;
    	
	if (ref $val eq 'HASH') {                        
		$self->_dump_hash($level + 1, $val, $code) 
	
	} elsif (ref $val eq 'ARRAY') {                       
		$self->_dump_array($level + 1, $val, $code) 
	
	} elsif (ref $val and $val =~ /=/) {                  
		$self->_dump_obj($level + 1, $val, $code) 
	
	} elsif (ref $val eq 'SCALAR' or ref $val eq 'REF') { 
		$self->_dump_scalar($level + 1, $val, $code) 
	
	} else {
        	$val = _escape ($val);
        	($level == 1) ? $code->($val) : $code->("$val,");
    	}
   	
	return 1;
}

sub _dump_scalar {
    	my ($self, $level, $val, $code, $n) = @_;
    	my $v = $$val;
    	
	$code->('\\');
    	$self->_dump_value ($level + 1, $v, $code, 1);
    	return 1;
}

sub _dump_hash {
    	my ($self, $level, $hash_ref, $code) = @_;
    	$code->("{\n");

    	if ($self->{sort}) { 
        	for (sort { ref ($self->{order}) eq 'CODE' ? $self->{order}->($a, $b) : $a cmp $b } keys %{$hash_ref}) {
            		my $key = _escape($_);
            		$code->($TAB x ($level / 2));
            		$code->( "$key => ");
            		$self->_dump_value ($level + 1, $hash_ref->{$_}, $code, 1);
            		$code->("\n");
        	}

    	} else {
        	for (sort keys %{$hash_ref}) {
            		my $key = _escape($_);
            		$code->($TAB x ($level / 2));
            		$code->( "$key => ");
            		$self->_dump_value ($level + 1, $hash_ref->{$_}, $code, 1);
            		$code->("\n");
        	}
    	}
	
    	$code->("\n");
    	$code->($TAB x (($level - 1) / 2));
    	($level == 2) ? $code->("}") : $code->("},\n");
    	return 1;
}

sub _dump_array {
    	my ($self, $level, $array_ref, $code) = @_;
    	$code->("[\n");
    	
	if ($self->{sort}) {
        	for (sort { ref ($self->{order}) eq 'CODE' ? $self->{order}->($a, $b) : $a cmp $b } @{$array_ref}) {
            		$code->($TAB x ($level / 2));
            		$self->_dump_value ($level + 1, $_, $code, 1);
            		$code->("\n");
        	}
    
   	 } else {
        	for (@{$array_ref}) {
            		$code->($TAB x ($level / 2));
            		$self->_dump_value ($level + 1, $_, $code, 1);
            		$code->("\n");
        	}
    	}
    	
	$code->($TAB x (($level - 1) / 2));
    	($level == 2) ? $code->("]") : $code->("],\n");
    	return 1;
}

sub _dump_obj {
    	my ($self, $level, $obj, $code) = @_;
    	my $class = ref $obj;
    
    	$code->("new $class (\n");
    	if ($obj =~ /ARRAY/) { 
    		$self->_dump_array ($level + 1, \@{$obj}, $code) 
	} elsif ($obj =~ /HASH/) { 
		$self->_dump_hash  ($level + 1, \%{$obj}, $code) 
	} elsif ($obj =~ /SCALAR/ or $obj =~ /REF/) { 
		$self->_dump_value ($level + 1, $$obj, $code)
	}
    	
	$code->($TAB x (($level - 1) / 2));
    	($level == 2) ? $code->(")") : $code->("),\n");
    	
	return 1;
}


sub _escape {
    my ($val) = @_;
    defined ($val) or return 'undef';
    $val =~ s/(['\\])/\\$1/g;
    return "'$val'";
}

#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : AttachFile.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package CH::AttachFile;
#===============================================================
#  ε .
# ̸, ̸ , ũ,  , ϰ,
# ϶ б .
#
use strict;
use IO::Handle;
use IO::File;
use vars qw /@ISA @EXPORT/;
require Exporter;
require AutoLoader;

@ISA = qw/Exporter AutoLoader/;
@EXPORT = qw//;

sub new {
	my $this = shift;
	my $self = { '_ufile' => shift };
	my $fh = new IO::Handle->fdopen(fileno($self->{'_ufile'}), "r");
	
	$self->{'_fh'} = $fh;
	$self->{'_deny_ext'} = ['cgi'];
	$self->{'_file_ext'} = [];
	$self->{'_allow_char'} = ['\w', '\-', '\.'];
	
	bless $self, $this;
}

sub _allow_char() 	{ $_[0]->{'_allow_char'} }
sub _deny_ext() 	{ $_[0]->{'_deny_ext'} }

sub allow_char(;@) {
	return @{$_[0]->_allow_char} unless @_ > 1;
	my ($self) = shift;
	
	push(@{$self->_allow_char}, @_);
	$self->allow_char;
}

sub deny_ext(;@) {
	return @{$_[0]->_deny_ext} unless @_ > 1;
	my ($self) = shift;
	map { my $ext = $_; $ext =~ s/^\.//g; push(@{$self->_deny_ext}, $ext) } @_;

	$self->deny_ext;
}

sub _file_ext() { $_[0]->{'_file_ext'} }

sub fh() 	{ $_[0]->{'_fh'} }
sub get_line() 	{ $_[0]->fh->getline }
sub get_lines() { $_[0]->fh->getlines }
sub get_pos() 	{ tell($_[0]->fh) }

sub is_filename_allowed($) {
	my ($chars) = join("", @{$_[0]->_allow_char});
	return ($_[1] =~ /^[$chars]+$/) ? 1 : 0;
}

sub is_ext_denied($) {
	my ($exts) = join("|", @{$_[0]->_deny_ext});
	return 1 if $_[1] =~ /\.($exts)$/i;
	return 0;
}

sub orig_filename() {
	my $path = $_[0]->orig_filepath;
	$path =~ s/^.*[\\\/]([^\\\/]+)$/$1/g;

	return scalar($path);
}

sub orig_filepath() 	{ scalar($_[0]->ufile) }
sub save() 		{ $_[0]->save_as($_[0]->orig_filename) }

sub save_as($) {
	my $self = shift;
	my $newfilename = shift;
	my ($currpos, $newfh, $buffer, $total, $n, $n2);

	$total = $n = $n2 = 0;
	$buffer = undef;
	$newfh = undef;
	$currpos = $self->get_pos;
	$self->set_pos(0);

	($! = 2, return 0) unless $newfilename;
	($! = 22, return 0) if ($self->is_ext_denied($newfilename));
	#($! = 22, return 0) unless $self->is_filename_allowed($newfilename);

	$newfh = new IO::File $newfilename, "w";
	return 0 unless $newfh;

	if ($^O =~ /Win32/) {
		binmode($newfh);
		binmode($self->fh);
	}
	while (($n = read($self->fh, $buffer, 1024))) {
		$n2 = syswrite($newfh, $buffer, $n);
		$total += $n2;
	}

	$newfh->close;
	$self->set_pos($currpos);

	return $total;
}

sub set_pos($) 	{ seek($_[0]->fh, $_[1], 0) }
sub size() 	{ scalar((stat($_[0]->fh))[7]) }
sub ufile() 	{ $_[0]->{'_ufile'}; }

#===================================================================
#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : ToggleColor.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#===================================================================

package CH::ToggleColor;
#======================================================================

use strict;
use Setup qw($CONFIG);
use vars qw (@ISA $COUNTER);
require Exporter;

@ISA = qw(Exporter);

$COUNTER = 0;

sub color {
		my $color1 = "bgcolor=\"$CONFIG->{list_color1}\"";
		my $color2 = "bgcolor=\"$CONFIG->{list_color2}\"";
		
		$COUNTER++;
		
		my $bgcolor = $COUNTER % 2;
		my $tb_bgcolor = $bgcolor ? $color1 : $color2;
}

#----------------------------------------------------------------------
#			-- end of source code --
#----------------------------------------------------------------------

1; 	# :    ʽÿ.
__END__
