#       	    --------------------------
#           	             CHBoard
#		    --------------------------
#
#     : âȣ.
#       : contact@koinweb.co.kr
#   Ȩ: http://www.koinweb.co.kr
#       : 1.1
#       : Mailer.pm
#
# Copyright (C) 2001 Koinweb - All rights reserved.
#  α׷  Ǿ   ϰų  
# Ǹ  ϴ.
#
#   Eryq(eryq@zeegee.com)  MIME Lite  Դϴ.
# URL: http://www.zeegee.com 
#  ̺귯  CHBoard Ϻκν ̼ ȣ ޽ϴ.
#===================================================================

package CH::Mailer;
#-------------------------------------------------------------------
use Carp;
use FileHandle;
use Setup qw($CONFIG);
use strict;
use vars qw($VERSION $QUIET $PARANOID $VANILLA);

$VERSION = substr q$Revision: 1.135 $, 10;
$QUIET = undef;
$PARANOID = 0;
$VANILLA = 0;

	my $Sender     = "sendmail";
	my %SenderArgs = (
    			"sendmail" => ["$CONFIG->{sendmail_path} -t"],
    			"smtp"     => ["$CONFIG->{smtp}"],
    			"sub"      => [],
			);

	my $BCount = 0;

	my %KnownField = map {$_=>1} 

	qw(
   	bcc         cc          comments      date          encrypted 
   	from        keywords    message-id    mime-version  organization
   	received    references  reply-to      return-path   sender        
   	subject     to
   	);

	my @Uses;

sub fold {
    my $str = shift;
    $str =~ s/^\s*|\s*$//g;
    $str =~ s/\n/\n /g;      
    $str;
}

sub gen_boundary {
    return ("_----------=_".($VANILLA ? '' : int(time).$$).$BCount++);
}


sub known_field {
    my $field = lc(shift);
    $KnownField{$field} or ($field =~ m{^(content|resent|x)-.});
}

sub is_mime_field {
    $_[0] =~ /^(mime\-|content\-)/i;
}

if (!$PARANOID and eval "require MIME::Base64") {
    import MIME::Base64 qw(encode_base64);
    push @Uses, "B$MIME::Base64::VERSION";
}
else {
    eval q{
		sub encode_base64 {
    		my $res = "";
    		my $eol = "\n";

    		pos($_[0]) = 0;
    			while ($_[0] =~ /(.{1,45})/gs) {
					$res .= substr(pack('u', $1), 1);
					chop($res);
    			}
    		$res =~ tr|` -_|AA-Za-z0-9+/|;

    		my $padding = (3 - length($_[0]) % 3) % 3;
    		$res =~ s/.{$padding}$/'=' x $padding/e if $padding;

    		$res =~ s/(.{1,76})/$1$eol/g if (length $eol);
    		return $res;
			} 
  		} 
	} 


if (!$PARANOID and eval "require MIME::QuotedPrint") {
    import MIME::QuotedPrint qw(encode_qp);
    push @Uses, "Q$MIME::QuotedPrint::VERSION";
}
else {
    eval q{

sub encode_qp {
    my $res = shift;
    $res =~ s/([^ \t\n!-<>-~])/sprintf("=%02X", ord($1))/eg; 
    $res =~ s/([ \t]+)$/
      join('', map { sprintf("=%02X", ord($_)) }
	           split('', $1)
      )/egm; 

    my $brokenlines = "";
    $brokenlines .= "$1=\n" while $res =~ s/^(.{70}([^=]{2})?)//;
    $brokenlines =~ s/=\n$// unless length $res; 
    "$brokenlines$res";
} 
  }
} 

sub encode_8bit {
    my $str = shift;
    $str =~ s/^.{990}/$&\n/mg;
    $str;
}

sub encode_7bit {
    my $str = shift;
    $str =~ s/[\x80-\xFF]//eg; 
    $str =~ s/^.{990}/$&\n/mg;
    $str;
}


sub new {
    	my $class = shift;
    	my $self = {
		Attrs 	=> {},
		Header 	=> [],	# ޽ 
		Parts 	=> [],	# 迭
    	};    
    	bless $self, $class;

    	return (@_ ? $self->build(@_) : $self);
}

sub file_attachment {
    	my $self = shift;

    	my $part1 = ((@_ == 1) ? shift : ref($self)->new(Top=>0, @_));

    	if ($self->attr('content-type') !~ m{^multipart/}i) {

		my $part0 = ref($self)->new;

		foreach (qw(Attrs Data Path FH)) {
	    		$part0->{$_} = $self->{$_}; delete($self->{$_});
		}
		$part0->top_level(0);    

		$self->{Attrs} ||= {};          
		$self->attr('content-type'              => 'multipart/mixed');
		$self->attr('content-type.boundary'     => gen_boundary());
		$self->attr('content-transfer-encoding' => '7bit');
		$self->top_level(1);     

		push @{$self->{Parts}}, $part0;
    	}

    	push @{$self->{Parts}}, $part1;
    	$part1;
}

sub build {
    	my $self = shift;
   	my %params = @_;
    	my @params = @_;
    	my $key;

    	(defined($params{Data})+defined($params{Path})+defined($params{FH}) <= 1)
	or croak "supply exactly zero or one of (Data|Path|FH).\n";

    	ref($self) or $self = $self->new;

    	my $type = ($params{Type} || 'TEXT');
    	($type eq 'TEXT')   and $type = 'text/plain';
    	($type eq 'HTML')   and $type = 'text/html';
    	($type eq 'BINARY') and $type = 'application/octet-stream';
    	$type = lc($type);
    	$self->attr('content-type' => $type);
   
    	my $is_multipart = ($type =~ m{^(multipart)/}i);

    	if ($is_multipart) {
		my $boundary = gen_boundary();
		$self->attr('content-type.boundary' => $boundary);
    	}

    	if (defined($params{Data})) {
		$self->data($params{Data});
    	
	} elsif (defined($params{Path})) {
		$self->path($params{Path});       
		$self->read_now if $params{ReadNow};
    	
	} elsif (defined($params{FH})) {
		$self->fh($params{FH});
		$self->read_now if $params{ReadNow};  
    	}
    
    	if (defined($params{Filename})) {
		$self->filename($params{Filename});
    	}
  

    	my $enc = $params{Encoding} || 'binary'; 
    	$self->attr('content-transfer-encoding' => lc($enc));
	
    	if ($type =~ m{^(multipart|message)/}) {
		($enc =~ m{^(7bit|8bit|binary)\Z}) or 
	    	croak " MIME:$type  $enc  ڵ  ϴ!";
    	}

    	my $disp = ($params{Disposition} or ($is_multipart ? undef : 'inline'));
    	$self->attr('content-disposition' => $disp);

    	my $length;
    	if (exists($params{Length})) {   
		$self->attr('content-length' => $params{Length});
    	} else {                          
		$self->get_length;
    	}
    
    	$self->top_level(defined($params{Top}) ? $params{Top} : 1);

    	my @paramz = @params;
    	my $field;
    	
	while (@paramz) {
		my ($tag, $value) = (shift(@paramz), shift(@paramz));

		if ($tag =~ /^\-/) { $field = lc($'); }
		elsif ($tag =~ /:$/) { $field = lc($`); }
		elsif (known_field($field = lc($tag))) {}
		else { next; }
		
		$self->add($field, $value);
    	}
    	$self;
}

sub top_level {
    	my ($self, $onoff) = @_;	
    	if ($onoff) {
		$self->attr('MIME-Version' => '1.0');
		my $uses = (@Uses ? ("(" . join("; ", @Uses) . ")") : '');
		$self->replace('X-Mailer' => "CHMailer Ver 1.1 - (http://www.koinweb.co.kr)")
	    	unless $VANILLA;
    	
	} else {
		$self->attr('MIME-Version' => undef);
		$self->delete('X-Mailer');
    	}
}

sub add {
    my $self = shift;
    my $tag = lc(shift);
    my $value = shift;

    carp "Ͻ MIME  ʵ ($tag)()   Դϴ:\n".
	 "   attr()  Ͻʽÿ.\n"
	if (is_mime_field($tag) && !$QUIET);

    my @vals = ref($value) ? @{$value} : ($value);
    map { s/\n/\n /g } @vals;

    foreach (@vals) {
	push @{$self->{Header}}, [$tag, $_];
    }
}

sub attr {
    my ($self, $attr, $value) = @_;
    $attr = lc($attr);

    my ($tag, $subtag) = split /\./, $attr;
    defined($subtag) or $subtag = '';

    if (@_ > 2) {   # set:
	$self->{Attrs}{$tag} ||= {};            
	delete $self->{Attrs}{$tag}{$subtag};  
	if (defined($value)) {                
	    $value =~ s/[\r\n]//g;           
	    $self->{Attrs}{$tag}{$subtag} = $value;
	}
    }
	
    $self->{Attrs}{$tag}{$subtag};
}

sub delete {
    my $self = shift;
    my $tag = lc(shift);

    my $hdr = [];
    my $field;
    foreach $field (@{$self->{Header}}) {
	push @$hdr, $field if ($field->[0] ne $tag);
    }
    $self->{Header} = $hdr;
    $self;
}

sub fields {
    my $self = shift;
    my @fields;
    
    my %explicit = map { $_->[0] => 1 } @{$self->{Header}};
    
    my $tag;
    foreach $tag (sort keys %{$self->{Attrs}}) {	

	next if ($explicit{$tag});         

	my @subtags = keys %{$self->{Attrs}{$tag}}; 
	@subtags or next;

	my $value;
	defined($value = $self->{Attrs}{$tag}{''}) or next;
	foreach (sort @subtags) {
	    next if ($_ eq '');
	    $value .= qq{; $_="$self->{Attrs}{$tag}{$_}"};
	}
	
	push @fields, [$tag, $value];
    }
    
    foreach (@{$self->{Header}}) {
	push @fields, [@{$_}];
    }

    # Ϸ !
    return \@fields;
}

sub filename {
    my ($self, $filename) = @_;
    if (@_ > 1) {
	$self->attr('content-type.name' => $filename);
	$self->attr('content-disposition.filename' => $filename);
    }
    $self->attr('content-disposition.filename');
}

sub get {
    my ($self, $tag, $index) = @_;
    $tag = lc($tag); 
    croak "MIME ʵ带   ϴ.\n" if is_mime_field($tag);
    
    my @all = map { ($_->[0] eq $tag) ? $_->[1] : ()} @{$self->{Header}};
    (defined($index) ? $all[$index] : (wantarray ? @all : $all[0]));
}

sub get_length {
    my $self = shift;

    my $is_multipart = ($self->attr('content-type') =~ m{^multipart/}i);
    my $enc = lc($self->attr('content-transfer-encoding') || 'binary');
    my $length;
    if (!$is_multipart && ($enc eq "binary")){ 
	if    (defined($self->{Data})) { 
	    $length = length($self->{Data});
	}
	elsif (defined($self->{FH})) { 
	}
	elsif (-e $self->{Path}) { 
	    $length = (-s $self->{Path});
	}
    }
    $self->attr('content-length' => $length);
    return $length;
}

sub replace {
    my ($self, $tag, $value) = @_;
    $self->delete($tag);
    $self->add($tag, $value) if defined($value);
}

sub binmode {
    my $self = shift;
    $self->{Binmode} = shift if (@_); 
    return (defined($self->{Binmode}) 
	    ? $self->{Binmode}
	    : ($self->attr("content-type") !~ m{^(text|message)/}i));
}

sub data {
    my $self = shift;
    if (@_) {
	$self->{Data} = ((ref($_[0]) eq 'ARRAY') ? join('', @{$_[0]}) : $_[0]);
	$self->get_length;
    }
    $self->{Data};
}


sub path {
    my $self = shift;
    if (@_) {

	$self->{Path} = shift;

	my $filename;
	if ($self->{Path} and ($self->{Path} !~ /\|$/)) { 
	    ($filename = $self->{Path}) =~ s/^<//;    
	    ($filename) = ($filename =~ m{([^\/]+)\Z});
	}
	$self->filename($filename);

	$self->get_length;
    }
    $self->{Path};
}

sub fh {
    my $self = shift;
    $self->{FH} = shift if @_;
    $self->{FH};
}


sub resetfh {
    my $self = shift;
    seek($self->{FH},0,0);
}

sub read_now {
    my $self = shift;
    local $/ = undef;
    
    if ($self->{FH}) {
	my $chunk;
	$self->{Data} = '';
	CORE::binmode($self->{FH}) if $self->binmode;
	while (read($self->{FH}, $chunk, 1024)) {$self->{Data} .= $chunk}
    }
    elsif ($self->{Path}) {
	open SLURP, $self->{Path} or croak "$self->{Path}()   ϴ: $!";
	CORE::binmode(SLURP) if $self->binmode;
	$self->{Data} = <SLURP>;
	close SLURP;
    }
}

sub sign {
    my $self = shift;
    my %params = @_;

    @_ or $params{Path} = "$ENV{HOME}/.signature";

    defined($self->{Data}) or $self->read_now;

    my $sig;
    if (!defined($sig = $params{Data})) {
	local $/ = undef;
	open SIG, $params{Path} or croak "$params{Path}()   ϴ: $!";
		$sig = <SIG>;
	close SIG;
    }    
    $sig = join('',@$sig) if (ref($sig) and (ref($sig) eq 'ARRAY'));

    $self->{Data} .= "\n-- \n$sig";

    $self->get_length;
    1;
}

sub print {
    my ($self, $out) = @_;

    $out = wrap CH::Lite::IO_Handle $out;

    $self->print_header($out);
    $out->print("\n");

    if ($self->attr('content-type') !~ m{^multipart/}i) {	
	$self->print_body($out); 
    }
    else { 
	my $boundary = $self->attr('content-type.boundary');

	$out->print("̰ multi-part ޽ MIME Դϴ.\n");
	
	my $part;
	foreach $part (@{$self->{Parts}}) {
	    $out->print("\n--$boundary\n");
	    $part->print($out);
	}
	$out->print("\n--$boundary--\n\n");
    }
    1;
}

sub print_body {
    my ($self, $out) = @_;

    $out = wrap CH::Lite::IO_Handle $out;

    my $encoding = uc($self->attr('content-transfer-encoding'));

    if (defined($self->{Data})) {
      DATA: 
	{ $_ = $encoding;

	  /^BINARY$/ and do {
	      $out->print($self->{Data}); 
	      last DATA;
	  };
	  /^8BIT$/ and do {
	      $out->print(encode_8bit($self->{Data})); 
	      last DATA;
	  };
	  /^7BIT$/ and do {
	      $out->print(encode_7bit($self->{Data})); 
	      last DATA;
	  };
	  /^QUOTED-PRINTABLE$/ and do {
	      while ($self->{Data}=~ m{^.*[\r\n]*}mg) {
		  $out->print(encode_qp($&));
	      }
	      last DATA;	 
	  };
	  /^BASE64/ and do {
	      $out->print(encode_base64($self->{Data})); 
	      last DATA;
	  };
	  croak " ʴ ڵ Դϴ: `$_'";
        }
    }

    elsif (defined($self->{Path}) || defined($self->{FH})) {
	no strict 'refs';
	my $DATA;
	
	if (defined($self->{Path})) {
	    $DATA = new FileHandle || croak "ο ڵ   ϴ!";
	    $DATA->open("$self->{Path}") or croak "$self->{Path}()   ϴ: $!";
	}
	else {
	    $DATA=$self->{FH};
	}
	CORE::binmode($DATA) if $self->binmode;
		
      PATH: 
	{   $_ = $encoding;
	    
	    /^BINARY$/ and do {
		$out->print($_)                while read($DATA, $_, 2048); 
		last PATH;
	    };      
	    /^8BIT$/ and do {
		$out->print(encode_8bit($_))   while (<$DATA>); 
		last PATH;
	    };
	    /^7BIT$/ and do {
		$out->print(encode_7bit($_))   while (<$DATA>); 
		last PATH;
	    };
	    /^QUOTED-PRINTABLE$/ and do {
		$out->print(encode_qp($_))     while (<$DATA>); 
		last PATH;
	    };
	    /^BASE64$/ and do {
		$out->print(encode_base64($_)) while (read($DATA, $_, 45));
		last PATH;
	    };
	    croak " ʴ ڵ Դϴ: `$_'";
	}
	
	close $DATA if defined($self->{Path});
    }
    
    else {
	croak " Ͱ ϴ!";
    }
    1;
}

sub print_header {
    my ($self, $out) = @_;

    $out = wrap CH::Lite::IO_Handle $out;
    $out->print($self->header_as_string);
    1;
}

sub as_string {
    my $self = shift;
    my $str = "";
    my $io = (wrap CH::Lite::IO_Scalar \$str);
    $self->print($io);
    $str;
}
*stringify = \&as_string;

sub body_as_string {
    my $self = shift;
    my $str = "";
    my $io = (wrap CH::Lite::IO_Scalar \$str);
    $self->print_body($io);
    $str;
}
*stringify_body = \&body_as_string;

sub header_as_string {
    my $self = shift;
    my $str = '';
    foreach (@{$self->fields}) {
	my ($tag, $value) = @$_;
	$tag =~ s/\b([a-z])/uc($1)/ge;
	$tag =~ s/^mime-/MIME-/ig; 
	$str .= "$tag: $value\n";
    }
    $str;
}
*stringify_header = \&header_as_string;

sub send {
    my $self = shift;
    if (ref($self)) {
	my $method = "send_by_$Sender";
	my @args   = @{$SenderArgs{$Sender} || []};
	return $self->$method(@args);
    }
    else { 
	$Sender = shift;
	$SenderArgs{$Sender} = [@_];
	return 1;
    }
}

sub send_by_sendmail {
    my ($self, $sendmailcmd) = @_;

    my $pid;
    open SENDMAIL, "|$sendmailcmd" or croak "|$sendmailcmd()   : $!";
    $self->print(\*SENDMAIL);
    close SENDMAIL;
    return (($? >> 8) ? undef : 1);
}

sub send_by_smtp {
    my ($self, @args) = @_;

    my $hdr = $self->fields();   
    my $from = $self->get('From');
    my @to   = $self->get('To');

    require Net::SMTP;
    my $smtp = CH::Lite::SMTP->new(@args)
        or croak "    ϴ: $!";
    $smtp->mail($from)
        or croak "SMTP MAIL ɾ ߸Ǿϴ: $!";
    $smtp->to(@to)
        or croak "SMTP RCPT ɾ ߸Ǿϴ: $!";
    $smtp->data()
        or croak "SMTP DATA ɾ ߸Ǿϴ: $!";

    $self->print($smtp);
    $smtp->dataend();
    $smtp->quit;
    1;
}

sub send_by_sub {
    my ($self, $subref, @args) = @_;
    &$subref($self, @args);
}

sub sendmail {
    my $self = shift;
    $self->send('sendmail', join(' ', @_));
}

sub quiet {
    my $class = shift;
    $QUIET = shift if @_;
    $QUIET;
}

#-------------------------------------------------------------------
package CH::Lite::SMTP;

use strict;
use vars qw( @ISA );
@ISA = qw(Net::SMTP);

sub print { shift->datasend(@_) }

#-------------------------------------------------------------------
package CH::Lite::IO_Handle;

sub wrap {
    my ($class, $fh) = @_;
    no strict 'refs';

    $fh or $fh = select;
    ref($fh) or $fh = \*$fh;
    
    return $fh if (ref($fh) and (ref($fh) ne 'GLOB'));

    bless \$fh, $class; 
}

sub print {
    my $self = shift;
    print {$$self} @_;
}

#-------------------------------------------------------------------
package CH::Lite::IO_Scalar;

sub wrap {
    my ($class, $scalarref) = @_;
    defined($scalarref) or $scalarref = \"";
    bless $scalarref, $class;
}

sub print {
    my $self = shift;
    $$self .= join('', @_);
    1;
}
#-------------------------------------------------------------------
1;
