package Plugins::Announce;

use strict;
use Setup qw/$CONFIG $VARS/;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/;

sub new {
	bless my $self = {};

	$self->{TEMPLATE} = DB->load_template("announcement.html");
	$self->{TEMPLATE}->param(DB->style_vars(" б"));
	$self->_init(@_);
	$self->{TEMPLATE}->output;
}

sub _init {
	my $self = shift;
	my $html_output = "";
	my $data = DB->get_data("$CONFIG->{data_directory}/announcements.cgi");
	my @idx = keys %$data;
	my $number = scalar @idx;
	
	$html_output = qq|<br><table $VARS->{s_table}><tr><td>
		<$VARS->{font}> ֱ   <b>$number</b> Դϴ.<br>
		  ǳ ñ  <<a href="mailto:$CONFIG->{admin_email}"></a>>
		 ֽʽÿ.</font>
		</td></tr></table><br>|;
	foreach (sort {$b <=> $a} keys %$data) {
		$html_output .= qq|$VARS->{table_top}
			<table $VARS->{table}>
			<tr $VARS->{bg_header}>
				<td colspan="2"><$VARS->{header_font}><b>No. $number</b></font>
				</td>
			</tr>
			<tr $VARS->{msgbox_color}>
				<td width="20%"><$VARS->{font}><b>:</b></font>
				</td><td width="80%"><$VARS->{font}><b>$data->{$_}->{subject}</b></font>
				</td>
			</tr>
			<tr $VARS->{msgbox_color}>
				<td><$VARS->{font}><b>¥:</b></font>
				</td><td><$VARS->{font}>$data->{$_}->{date}</font>
				</td>
			</tr>
			<tr $VARS->{forum_bgcolor}>
				<td colspan="2" class="messagebody">
					<$VARS->{font}><blockquote>$data->{$_}->{body}</blockquote></font>
				</td>
			</tr>
			$VARS->{table_bottom}
			$VARS->{table_bottom}<br>|;
			$number--;
	}

	$self->{TEMPLATE}->param( 
			nav_bar		=> $self->navigation_bar(" "),
			announcements  	=> $html_output
			);
}

