package Plugins::Help;

use strict;
use Setup qw($CONFIG $VARS);
use CH::Getform;
use CH::DBUtil;
use vars qw(@ISA);

@ISA = qw(Board);

sub new {
	bless my $self = {};
	
	$self->{tpl} = DB->load_template("help.html");
	$self->{tpl}->param(DB->style_vars(""));
	
	$self->_init();
	$self->{tpl}->output;
}

sub _init() {
	my $self = shift;
	my ($output);
	my %subject = (
		'1'	=> 'CHBoard ̼ Ͽ',
		'2'	=> '̶ ΰ?',
		'3'	=> '۷ ΰ?',
		'4'	=> 'ȸ з ',
		'5'	=> ' з  ',
	);
	
	my %help = ();
	$help{'1'} = qq|<b>CHBoard</b>  ۷ Ʈν <<a href="mailto:chna\@koinweb.co.kr">âȣ</a>> 
		Ͽϴ.<br>
		   ν Ӱ Ͻ  ֽϴ.<br>
		ҽ ڵ带 ̳ ȯ濡 ° Ƿ Ͻ  ֽϴ. ,  ڵ Ǵ Ͻ 
		ڵ带   ü Ǵ Ϻθ Ͽ ȵ˴ϴ.<br>
		񿵸  CHBoard     ̶,  Ǵ ߻縦 Ͽ մϴ.<br>
		 ȭ ϴ κ Ǵ  ġ "Powered by CHBoard Version" ݵ Ͽ
		ֽʽÿ.|;
	
	$help{'2'} = qq|<b></b>     ϴ Դϴ.<br>
		 óȭ(۷ ) Ư  ̸ Ŭϸ    Ÿϴ.
		ο   ų  Ͽ ϴ  Ŭ , Ӱ  
		ǰ Խ  ֽϴ.|;
	$help{'3'} = qq|<b>۷</b>    鸸     Դϴ. , 
		۷  <b>α׷</b>̶  ۷ <b>Perl, Java, C/C++</b>   
		  ֽϴ.|;
	$help{'4'} = qq|   ȸ ׷ ֽϴ.</li>
		<ol><li><b>ȸ</b> - , ȸ   Ӱ аų   ֽϴ. ,  
		 аų   ִ  ϴ.</li>
		<li><b>ȸ</b> - , ȸ,    аų   ֽϴ.</li>
		<li><b></b> - ش  ڴ ڽ ϰ ִ   , , Խ, ̵,
		   ִ  ֽϴ.</li>
		<li><b></b> -  , , ȸ     ϴ.</li></ol>|;
	$help{'5'} = qq|     ֽϴ.
		<ol><li><b> </b> - ȸ Ͽ  Ӱ  а   ִ Դϴ.</li>
		<li><b>ȸ </b> - ȸ  аų   ϴ.</li>
		<li><b> </b> - ȸ, , ڸ   ִ Դϴ.</li>
		<li><b> </b> <img src="$CONFIG->{images_url}/mod.gif" align="absmiddle">
		-  Խϸ ش   Ǵ ڰ о ̻  
		 Խϰ ˴ϴ.    Ǵ ڰ   Ǵ   ֽϴ.</ol>|;

	
	if (defined $IN->{idx}) {
		$output .= qq~$VARS->{table_top}
		<table $VARS->{table}>
		<tr $VARS->{bg_header}>
			<td>
			<$VARS->{header_font}><b>$subject{$IN->{idx}}</b></font>
			</td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
			<td class="messagebody"><blockquote><$VARS->{font}>
			$help{$IN->{idx}}</font>
			</td>
		</tr>
		$VARS->{table_bottom}
		$VARS->{table_bottom}<BR>~;
	}
	
	$output .= qq~$VARS->{table_top}
		<table $VARS->{table}>
		<tr $VARS->{bg_header}>
			<td>
			<$VARS->{header_font}><b> </b></font>
			</td>
		</tr>
		<tr $VARS->{msgbox_color}>
			<td class="messagebody"><blockquote><ol><$VARS->{font}>~;
	
	foreach (sort keys %subject) {
		if ($IN->{idx} eq $_) {
			$output .= qq~<li><font color="red">$subject{$_}</font></li>~;
		}
		else {
			$output .= qq~<li><a href="index.cgi?ch=Forum&do=Help&idx=$_">$subject{$_}</a></li>~;
		}
	}
	
	$output .= qq~</font></ol></blockquote>
		$VARS->{table_bottom}
		$VARS->{table_bottom}~;
	
	$self->{tpl}->param(
		nav_bar	=> $self->navigation_bar(""),
		help => $output
	);
}
