package Plugins::Home;

use strict;
use Setup qw($CONFIG $VARS);
use CH::DBUtil;
use CH::Getform;
use vars qw(@ISA);

@ISA = qw(Board);

#----------------------------------------------------------------------
#
#
sub new {
	bless my $self = {};
	
	$self->{CAT} = DB->get_data($CONFIG->{cat_file});
	$self->{cat_only} = ($CONFIG->{conferences_only} and ! defined($IN->{cid}));
	$self->{total_topic} = 0;
	$self->{total_posts} = 0;

	if (defined $IN->{cid}) {
		$self->{CID} = [ $IN->{cid} ];
		$self->{single} = 1;
	}
	else {
		my @cat_list;
		
		LINE: foreach (keys %{$self->{CAT}}) {
			next LINE unless (@{$self->{CAT}->{$_}->{ForumList}});
			push @cat_list, $_;
		}
		
		$self->{CID} = [ @cat_list ];
	}

	$self->{TEMPLATE} = DB->load_template('home.html');
	$self->{TEMPLATE}->param(DB->style_vars('ȯմϴ.'));
	$self->init(@_);
	$self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
#
#
sub init {
	my $self = shift;
	my ($CAT, $forum, $output);

	if ($self->{cat_only}) {
		$output .= qq|
		$VARS->{table_top}
		<table $VARS->{table}>
			<tr $VARS->{bg_header}>
			<td><font $VARS->{header_font}><b>۷</b></font>
		$VARS->{table_bottom}
		$VARS->{table_bottom}
		$VARS->{spacer}
		<table $VARS->{s_table}>
		<tr bgcolor="$CONFIG->{forum_bgcolor}"><td valign="top" width="50%">|;
	} 
	else {
		if ($self->{single}) {
			my $dir = "<IMG SRC=\"$CONFIG->{images_url}/arrow.gif\" ALIGN=\"ABSMIDDLE\">";
			$output .= qq|
			$VARS->{table_top}
			<table $VARS->{table}>
			<tr><td $VARS->{msgbox_color}>
			<$VARS->{font}>
			<a href="index.cgi">ó</a> $dir $self->{CAT}->{$IN->{cid}}->{Name} ۷</font>
			</td></tr>
			</table>
			$VARS->{table_bottom}$VARS->{spacer}|;
		}
		
		$output .= qq|
		$VARS->{table_top}
		<table $VARS->{table}>
		<tr $VARS->{bg_header}>
		<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
		<td>
			<$VARS->{header_font}><b> </b></font>
		</td>
		<td align="center" nowrap>
			<$VARS->{header_font}><b> </b></font>
		</td>
		<td align="center">
			<$VARS->{header_font}><b>б</b></font>
		</td>
		<td align="center">
			<$VARS->{header_font}><b> б</b></font>
		</td>
		<td align="center" nowrap>
			<$VARS->{header_font}><b></b></font>
		</td>
   		</tr>|;
	}
	
	my $break = int( ($#{$self->{CID}}+1) / 2 ) + ( (($#{$self->{CID}}+1) % 2) ? 1 : 0 );
	my ($forum_num, %forum_list);
	my $idx = 0;
	my $folder = "<img src=\"$CONFIG->{images_url}/folder.gif\" align=\"absmiddle\">";
	my $onoff = "<img src=\"$CONFIG->{images_url}/off.gif\" align=\"absmiddle\">";
	my $unread = '';
	
	CATEGORY: 
	foreach $CAT (sort @{$self->{CID}}) {
		next CATEGORY if ${$self->{CAT}->{$CAT}}{Status} eq "Off";
		
		if ($self->{cat_only}) {
			($idx and ($idx % $break)) or ($idx != 0) and 
			$output .= "</td><td>&nbsp;</td><td valign=\"top\" width=\"50%\">";
			
			$forum_num = scalar @{$self->{CAT}->{$CAT}->{ForumList}};
			
			FORUM:
			foreach my $i (@{$self->{CAT}->{$CAT}->{ForumList}}) {
				$forum = DB->forum_data($i);
				next FORUM if $forum->{Status} eq "Off";
				next FORUM if ($forum->{Type} == 9 and $CONFIG->{hidden_private} and $MEMBER->LEVEL < 2);
				
				if ($MEMBER->login_name()) {
					$unread = $self->_newfile($i);
					if ($unread > 0) {
						$unread = " (<img src=\"$CONFIG->{images_url}/new.gif\"> $unread)";
						$onoff = "<img src=\"$CONFIG->{images_url}/on.gif\" align=\"absmiddle\">";
					}
					else { $unread = ''; }
				}
				
				if ($forum->{ModerationB} eq "On") {
					$folder = "<img src=\"$CONFIG->{images_url}/mod.gif\" align=\"absmiddle\">";
				}

				$i = "$folder <$VARS->{font}><a href=\"index.cgi?ch=Forum&do=PostList&cid=$CAT&b=$i\">$forum->{Name}</a>$unread</font>";
				push @{$forum_list{$CAT}}, $i;
			}
			next CATEGORY unless defined @{$forum_list{$CAT}};

			$output .= qq|
			<table width="100%" border="0" cellpadding="0" cellspacing="0">
			<tr><td bgcolor="$CONFIG->{table_border_color}">	
			<table $VARS->{table}>
			<tr $VARS->{bg_color2}>
			<td>
			$onoff <$VARS->{font}><b>
			<a href="index.cgi?ch=Forum&cid=$CAT">${$self->{CAT}->{$CAT}}{Name} ۷</a></b> 
			(: $forum_num)</font>
			</td></tr>
			<tr><td $VARS->{bg_color1}>
			<$VARS->{font}>${$self->{CAT}->{$CAT}}{Desc}</font><br>|;
			
			$output .= join (", ", @{$forum_list{$CAT}}) if defined @{$forum_list{$CAT}};
			$output .= $VARS->{table_bottom} . $VARS->{table_bottom};
			$output .= $VARS->{spacer};
			$idx++;
		}
		else {
			$output .= $self->_forumlist(
					$CAT, 
					$self->{CAT}->{$CAT}->{Name}, 
					@{$self->{CAT}->{$CAT}->{ForumList}} 
			);
		}
	}

	if ($self->{cat_only}) {
		$output .= qq|$VARS->{table_bottom}
		$VARS->{table_top}
		<table $VARS->{table}>
		<tr $VARS->{bg_header}><td colspan="3">&nbsp;$VARS->{table_bottom}
		$VARS->{table_bottom}|;
	} 
	else { $output .= "</table>"; }

	$output .= $VARS->{table_bottom} unless $self->{cat_only};
	
	my $util = '';

	#----------------------------------------------------------------------
	# ȸ   .
	#----------------------------------------------------------------------
	
	if ($CONFIG->{display_member_total}) {
		open (FH, "$CONFIG->{member_directory}/total.txt") or die "error: $!\n";
			flock(FH, 1);
			my $member_total = <FH>;
		close FH;
		$util .= "ȸ  <b>$member_total</b> .<br>";
	}
	
	#----------------------------------------------------------------------
	# ű ȸ  .
	#----------------------------------------------------------------------
	
	open (FH, "$CONFIG->{member_directory}/new_member.txt") or die "error: $!\n";
		flock(FH, 1);
		my $new_member = <FH>;
	close FH;
	
	my $user = $self->member_data($new_member);
	my $name = $user->{MEMBER_ID};
	$util .= "<a href=\"index.cgi?ch=Member&do=member_profile&ID=$new_member\"><b>$name</b></a>" .
		"  űȸ ϼ̽ϴ.<br>";
	
	#----------------------------------------------------------------------
	#   .
	#----------------------------------------------------------------------
	my $announce = DB->get_data("$CONFIG->{data_directory}/announcements.cgi");
	if (keys %$announce > 0) {
		my $last_announce;
		my $icon = "<img src=\"$CONFIG->{images_url}/announcement.gif\" align=\"absmiddle\">";
		
		foreach (sort {$b <=> $a} keys %$announce) {
			$last_announce = $announce->{$_}->{date} and
			$last_announce .= " - " . $announce->{$_}->{subject} and last;
		}
		$util .= qq|<a href="index.cgi?ch=Forum&do=Announce">$last_announce</a>&nbsp;$icon<br>|;
	}
	
	#----------------------------------------------------------------------
	#  б  .
	#----------------------------------------------------------------------
	
	my $total_posts = '';
	$total_posts = qq| : <b>$self->{total_topic}</b>,
			ü б: <b>$self->{total_posts}</b>
			( īװ    .)| if $self->{single} or !$CONFIG->{conferences_only};
	
	#----------------------------------------------------------------------
	# øƮ .
	#----------------------------------------------------------------------
	
	$self->{TEMPLATE}->param( 
			util		=> $util,
			total_posts	=> $total_posts,
			forum_list 	=> $output,
			welcome 	=> $self->login_msg
			);
	
}

sub _newfile {
	my $self = shift;
	my $forum = shift;
	my $sfile = DB->get_data("$CONFIG->{session_path}/" . $SESSION->SESSION());
	my $count = 0;
	my %tmp = ();
	
	if (exists $sfile->{$forum}) {
		for (@{$sfile->{$forum}}) {
			$tmp{$_} = 1;
		}
	}
	
	open (FH, "<$CONFIG->{forum_path}/$forum/topic.db");
		flock(FH, 1);
		LINE: while (<FH>) {
			chomp;
			$_ =  shift @{ [ DB->data_split($_) ] };
			
			(! exists $tmp{$_}) ? $count++ : next LINE;
		}
	close FH;
		
	return $count;
}

sub _forumlist {
	my ($self, $cid, $c_name, @forumlist) = @_;
	my ($output, $unread, $onoff, $cat, $forum, $forum_type, $Moderator, $LastTopic);
	my $found = 0;
	
	FORUM:
	foreach my $i (@forumlist) {
		$forum = DB->forum_data($i);
		next FORUM if $forum->{Status} eq "Off";
		next FORUM if ($forum->{Type} == 9 and $CONFIG->{hidden_private} and $MEMBER->LEVEL < 2);

		$forum_type = $self->forum_type($forum->{Type});
		
		if ($forum->{ModerationB} eq "On") {
			$onoff = "<img src=\"$CONFIG->{images_url}/mod.gif\" align=\"absmiddle\">";
		}
		else {
			if ($MEMBER->login_name()) {
				$unread = $self->_newfile($i);
				if ($unread > 0) {
					$unread = "(<img src=\"$CONFIG->{images_url}/new.gif\"> $unread)";
					$onoff = "<img src=\"$CONFIG->{images_url}/on.gif\" align=\"absmiddle\">";
				}
				else { 
					$unread = ''; 
					$onoff = "<img src=\"$CONFIG->{images_url}/off.gif\" align=\"absmiddle\">";
				}
			}
			else {
				$onoff = "<img src=\"$CONFIG->{images_url}/off.gif\" align=\"absmiddle\">";
			}
		}

		$output .= qq|
		<tr>
		<td $VARS->{bg_color1} align="center" valign="top">$onoff<br></td>
		<td $VARS->{bg_color1} valign="top"><font $VARS->{font}>
		<a href="index.cgi?ch=Forum&do=PostList&cid=$cid&b=$i"><b>$forum->{Name}</b></a>
		<br>$forum->{Description}<br>|;
		
		if ($CONFIG->{display_last_topic}) {
			if ($forum->{LastTopic}) {
			my $subject = DB->trim_text($forum->{LastTopic},"30");
			$LastTopic = "<img src=\"$CONFIG->{images_url}/icons/$forum->{MessageIcon}.gif\" 
				align=\"absmiddle\"> <a href=\"index.cgi?ch=Forum&do=ReadPost
				&cid=$cid&b=$i&t=$forum->{LastTopicNo}\">$subject</a>" .
				" ($forum->{LastAuthor})";
			}
			else { 
				$LastTopic = "ϱ ";
			}
		}
		
		$output .= qq|</font>
		</td>
		<td $VARS->{bg_color2} align="center" valign="top">
			<$VARS->{font}>$forum_type<br>$unread</font>
		</td>
		<td $VARS->{bg_color1} valign="top" nowrap align="center">
			<$VARS->{font}>: $forum->{TotalTopic}
			<BR>б: $forum->{Threads}</font>
		</td>
		<td $VARS->{bg_color2} valign="top" align="center" nowrap>
			<$VARS->{font}>$forum->{LastTopicDate}</font>
			<$VARS->{font_time}>$forum->{LastTopicTime}</font><br>
			<$VARS->{font}>$LastTopic</font><br>
		</td>
		<td $VARS->{bg_color1} align="center" valign="top" nowrap>
			<$VARS->{font}>|;
			
		my @moderator_arr;
			foreach (@{$forum->{Moderator}}) {
				my $user = $self->member_data($_);
				my $name = $user->{MEMBER_ID};
				$_ = "<a href=\"index.cgi?ch=Member&do=member_profile&ID=$_\">$name</a>";
				push @moderator_arr, $_; 
			}
			$Moderator = @moderator_arr ? join ("<br>", @moderator_arr) : '';
			$output .= "$Moderator</font>\n</td></tr>";
		
		$self->{total_topic} += $forum->{TotalTopic};
		$self->{total_posts} += $forum->{Threads};
		$found = 1;
	}
	
	if ($found) {
		$cat = qq|
		<tr $VARS->{bg_header}>
		<td colspan="6">
			<$VARS->{header_font}><b>$c_name ۷</b></font>
		</td>
		</tr>|;
	}
	
	$cat .= $output;
}

#----------------------------------------------------------------------
