package Plugins::MoveTopic;

use strict;
use Setup qw($CONFIG);
use CH::Getform;
use CH::DBUtil;
use vars qw(@ISA);

@ISA = qw(Board);

#----------------------------------------------------------------------
#
#
sub new {
	bless my $self = {};

	if ($self->edit_permission($IN->{b})) {
		$self->{TEMPLATE} = DB->load_template("move_topic.html");
		$self->{TEMPLATE}->param( DB->style_vars("б ̵") );
		$IN->{action} eq "save" ? $self->move_topic(@_) : $self->move_form(@_);
		
		$self->{TEMPLATE}->output;
	}

	else { $SESSION->member_login(); }
}

sub move_topic {
	eval { 
		require File::Copy;
	};

	my $self = shift;
	my $target_forum = $IN->{target_forum};
	my ($html_output, $data_row);
	my $target_id = "$CONFIG->{forum_path}/$target_forum/topic_id.txt";
	my $target_db = "$CONFIG->{forum_path}/$target_forum/topic.db";
	my $old_db = "$CONFIG->{forum_path}/$IN->{b}/topic.db";
	
	DB->_lock($target_id);
	open (ID, "<$target_id");
		my $num = <ID> + 1;
	close ID;
	
	open (ID, ">$target_id");
		print ID $num;
	close ID;
	
	open (DATA, "<$old_db");
		while (<DATA>) {
			chomp;
			/^$IN->{t}/ and $data_row = $_ and last;
		}
	close DATA;
	DB->_unlock($target_id);
	
	$num = sprintf("%6d", $num);
	$num =~ tr/ /0/;
	
	my @tmp = DB->data_split($data_row);
	@tmp[0] = $num;
	my $data_line = join $CONFIG->{db_delim}, @tmp;
	
	DB->append_data($target_db, $data_line);
	
	if (!$@) {
		File::Copy::copy ("$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi", 
				"$CONFIG->{forum_path}/$IN->{target_forum}/$num.cgi")
				or $self->error_msg(" ̵ !", " ̵ Ͽϴ. $!");
	}
	else {
		open (BAK, "<$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi");
		open (NEW, ">$CONFIG->{forum_path}/$IN->{target_forum}/$num.cgi");
			while (<BAK>) {
				print NEW;
			}
		close NEW;
		close BAK;
	}
			
	if ($IN->{delete} eq "yes") {
		unlink "$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi";
		
		my $update = '';
		
		DB->_lock($old_db);
		open (DATA, "<$old_db");
			LINE: while (<DATA>) {
				chomp;
				if (/^$IN->{t}/) { 
					next LINE;
				}
				else { 
					$update .= $_ . "\n";
				}
			}
		close DATA;
		
		open (DATA, ">$old_db");
			print DATA $update;
		close DATA;
		DB->_unlock($old_db);
	}

	$html_output = "<P><$VARS->{font}><b>б  Űϴ.</b></font></P>";

	$self->{TEMPLATE}->param( 
		nav_bar		=> $self->navigation_bar( __PACKAGE__, $IN->{cid}, $IN->{b}) . "б ̵ Ϸ!",
		move_topic	=> $html_output, 
		);
}


sub move_form {
	my $self = shift;
	my ($forum, $forum_type);
	my $cat = DB->get_data($CONFIG->{cat_file});
	my $html_output = qq|$VARS->{table_top}
		<form method="post">
		<input type="hidden" name="ch" value="Forum">
		<input type="hidden" name="do" value="MoveTopic">
		<input type="hidden" name="cid" value="$IN->{cid}">
		<input type="hidden" name="b" value="$IN->{b}">
		<input type="hidden" name="t" value="$IN->{t}">
		<input type="hidden" name="action" value="save">

		<table $VARS->{table}>
		<tr $VARS->{bg_header}>
			<td colspan="2"><$VARS->{header_font}><b>  ̵</b></font>
			</td>
		</tr>
		<tr $VARS->{msgbox_color}>
			<td width="50%" align="right"><$VARS->{font}><b>  ̵ Űڽϱ?</b></font>
			</td>
			<td width="50%"><select name="target_forum">|;
	
	foreach (keys %$cat) {
		foreach (@{$cat->{$_}->{ForumList}}) {
			unless ($_ eq $IN->{b}) {
				$forum = DB->forum_data($_);
				$forum_type = $self->forum_type($forum->{Type});
				$html_output .= "<option value=\"$_\">" . $forum->{Name} . " ($forum_type)";
			}
		}
	}
	$html_output .= qq|
		<tr $VARS->{msgbox_color}>
			<td align="right"><$VARS->{font}><b> ̵     ϰڽϱ?</b></font>
			</td>
			<td><$VARS->{font}><input type="radio" name="delete" value="yes" checked>Ѵ
			<input type="radio" name="delete" value="no">Ѵ</font>
			</td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
			<td align="center" colspan="2"><input type="submit" value=" ̵">
		$VARS->{table_bottom}
		$VARS->{table_bottom}</form>|;

	$self->{TEMPLATE}->param( 
		nav_bar		=> $self->navigation_bar( __PACKAGE__, $IN->{cid}, $IN->{b}) . "б ̵",
		move_topic	=> $html_output, 
		);
}

