package Plugins::Pds;

use strict;
use Setup qw($CONFIG $VARS);
use CH::DBUtil;
use CH::Getform;
use vars qw(@ISA);

@ISA = qw/Board/;

sub new {
	bless my $self = {};

	$self->{TEMPLATE} = DB->load_template("pds.html");
	$self->{TEMPLATE}->param( DB->style_vars("ڷ") );
		
	$self->{TMPDIR} = "$CONFIG->{public_directory}/pds/tmp";
	$self->{UPLOAD} = "$CONFIG->{public_directory}/pds/$IN->{b}";
	$self->{INFO} = "$self->{TMPDIR}/" . $MEMBER->USER_ID() . ".info";
	$self->{SELECTED} = undef;
	
	if ($IN->{action} eq "upload") { $self->upload(); }
	elsif ($IN->{action} eq "delete") { $self->delete(); }
	elsif ($IN->{action} eq "deletefile") { $self->deletefile(); }
	elsif ($IN->{action} eq "save") { $self->save(); }
	elsif ($IN->{action} eq "attach") { $self->attach(); }
	else { $self->main(); }
		
	return $self->{TEMPLATE}->output;
}

sub main {
	my $self = shift;
	my ($forum, $forum_type, $html_output, $list, @listkey);
	
	$forum = DB->forum_data($IN->{b});
	$forum_type = $self->forum_type($forum->{Type});
	$list = DB->get_data("$CONFIG->{data_directory}/pds/$IN->{b}/list.db");
	@listkey = keys %$list;
	
	if ($IN->{a}) {
		$html_output .= $self->download($IN->{b}, $IN->{a});
		$self->{SELECTED} = $IN->{a};
	}
	
	$html_output .= $VARS->{table_top};
	
	my $empty = qq~
		<table $VARS->{table}>
		<tr $VARS->{forum_bgcolor}>
		<td colspan="6"><$VARS->{font}><b>
		<img src="$CONFIG->{images_url}/disk.gif" align="absmiddle">
		<a href="index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}&action=attach">ڷ</a></b> (ȸ)<font>
		</td>
		</tr>
		<tr $VARS->{bg_header}>
			<td align="center"><$VARS->{header_font}><b> ڷ !</b></font>
			</td>
		</tr></table>~;
	
	if (@listkey) {
		$html_output .= qq|<form method="post">
		<input type="hidden" name="ch" value="Forum">
		<input type="hidden" name="do" value="Pds">
		<input type="hidden" name="action" value="deletefile">
		<input type="hidden" name="cid" value="$IN->{cid}">
		<input type="hidden" name="b" value="$IN->{b}">| if $self->edit_permission($IN->{b});
	
		$html_output .= $self->table_title();
	
		foreach (sort { $b <=> $a } @listkey) {
			$html_output .= $self->data_rows($IN->{b}, $_);
		}
	
		$html_output .= "<tr $VARS->{bg_header}><td colspan=6>&nbsp;";
		$html_output .= qq|<input type="submit" value=" ڷ ">| if $self->edit_permission($IN->{b});
		$html_output .= "</td></tr></form></table>";
	}
	else { $html_output .= $empty; }
	
	$html_output .= $VARS->{table_bottom};
	
	$self->{TEMPLATE}->param(
		nav_bar	=> $self->navigation_bar( __PACKAGE__, $IN->{cid}, ,$IN->{b}) . 'ڷ',
		jscript	=> $self->js_goforum,
		go_forum => $self->goforum(),
		pds	=> $html_output
	);
}

sub deletefile {
	my $self = shift;
	my @deletelist = ();
	my $file;
	
	foreach (keys %$IN) {
		$IN->{$_} eq "delete" and push @deletelist, $_;
	}
	my $db_file = "$CONFIG->{data_directory}/pds/$IN->{b}/list.db";
	my $list = DB->get_data($db_file);
	
	foreach (@deletelist) {
		my $d_file = "$CONFIG->{data_directory}/pds/$IN->{b}/$_.cgi";
		my $data = DB->get_data($d_file);		
		
		foreach (@{$data->{UPLOAD}}) {
			$file ="$CONFIG->{public_directory}/pds/$IN->{b}/$_.file";
			if (-e $file) {
				unlink $file;
			}
		}
		
		unlink $d_file;
		delete $list->{$_};
	}
	DB->_dumper($db_file, $list);
	
	$self->redirect("index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}");
}

sub download {
	my ($self, $forum, $data) = @_;
	my ($db, $uid, $user, $filesize, $output, $attach, $total_size);
	my $count = 1;

	$db = DB->get_data("$CONFIG->{data_directory}/pds/$forum/$data.cgi");
	$uid = $self->member_data($db->{UID});
	$user = $uid->{MEMBER_ID};
	$user = "<a href=\"index.cgi?ch=Member&do=member_profile&ID=$db->{UID}\">$user</a>";
	
	$attach .= qq~<tr $VARS->{bg_color1}><td colspan="2"><blockquote><$VARS->{font}>~;
	
	foreach my $tmp (@{$db->{UPLOAD}}) {
		foreach (keys %$tmp) {
			$total_size += $tmp->{$_}->{filesize};
			$filesize = $self->filesize($tmp->{$_}->{filesize});
			
			$attach .= qq~$count. 
			<b><a href="index.cgi?ch=Forum&do=AttachFile&b=$IN->{b}&ID=$_&f=$tmp->{$_}->{filename}&d=pds">
			$tmp->{$_}->{filename}</b></a>, 
			$filesize Bytes,
			$tmp->{$_}->{filetype}~;
			
			$count++;
			$attach .= "<br>" if $count > 1;
		}
	}

	$attach .= "</font></blockquote></td></tr>";

	$total_size = $self->filesize($total_size);
	
	$output = qq~$VARS->{table_top}
		<table $VARS->{table}>
		<tr $VARS->{bg_header}>
			<td colspan="2"><$VARS->{header_font}><b>ڷ ٿε</b></font>
			</td>
		</tr>
		<tr>
			<td $VARS->{bg_color2}><$VARS->{font}><b>ڷ ȣ</b></font>
			</td>
			<td $VARS->{bg_color1}><$VARS->{font}><b>$data</b> - $db->{DATE}</font>
			</td>
		</tr>
		<tr>
			<td $VARS->{bg_color2}><$VARS->{font}><b>ڷ </b></font>
			</td>
			<td $VARS->{bg_color1}><$VARS->{font}>$db->{SUBJECT}</font>
			</td>
		</tr>
		<tr>
			<td $VARS->{bg_color2}><$VARS->{font}><b> ũ</b></font>
			</td>
			<td $VARS->{bg_color1}><$VARS->{font}>$total_size Bytes</font>
			</td>
		</tr>
		<tr>
			<td $VARS->{bg_color2}><$VARS->{font}><b>ڷ </b></font>
			</td>
			<td $VARS->{bg_color1}><$VARS->{font}>$db->{DESC}</font>
			</td>
		</tr>~;

	$output .= $attach;
	$output .= "</table>$VARS->{table_bottom}<br>";
}

sub data_rows {
	my ($self, $forum, $data) = @_;
	my ($db, $uid, $user, $filesize, $total);
	
	$db = DB->get_data("$CONFIG->{data_directory}/pds/$forum/$data.cgi");
	$uid = $self->member_data($db->{UID});
	$user = $uid->{MEMBER_ID};
	$user = "<a href=\"index.cgi?ch=Member&do=member_profile&ID=$db->{UID}\">$user</a>";
	
	foreach my $tmp (@{$db->{UPLOAD}}) {
		foreach (keys %$tmp) {
			$filesize += $tmp->{$_}->{filesize};
			$total++;
		}
	}

	$filesize = $self->filesize($filesize);
	
	my $output = qq~
		<tr $VARS->{bg_header}>
			<td align="center" $VARS->{bg_color1}><$VARS->{font}>$data</font>
			</td>
			<td $VARS->{bg_color1}><$VARS->{font}>~;
			
			if ($self->edit_permission($IN->{b})) {
				$output .= qq~<input type="checkbox" name="$data" value="delete">~;
			}
			
			if ($self->{SELECTED} == $data) {
				$output .= "<b><font color=red>$db->{SUBJECT}</font></b>";
			}
			else { $output .= qq~
				<a href="index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}&a=$data">
				<b>$db->{SUBJECT}</b></a>~;
			}
			
			$output .= qq~</font>
			</td>
			<td align="center" $VARS->{bg_color2}><$VARS->{font}>$user</font>
			</td>
			<td align="center" $VARS->{bg_color1}><$VARS->{font}>$filesize ($total)</font>
			</td>
			<td align="center" $VARS->{bg_color2}><$VARS->{font}>$db->{DOWNLOAD}</font>
			</td>
			<td align="center" $VARS->{bg_color1}><$VARS->{font}>$db->{DATE}</font>
			</td>
		</tr>~;

}

sub filesize {
	$_[1] = reverse $_[1];
	$_[1] =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
	$_[1] = scalar reverse $_[1];
}

sub table_title {
	 qq~
		<table $VARS->{table}>
		<tr $VARS->{forum_bgcolor}>
		<td colspan="6"><$VARS->{font}><b>
		<img src="$CONFIG->{images_url}/disk.gif" align="absmiddle">
		<a href="index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}&action=attach">ڷ</a></b> (ȸ)</font>
		</td>
		</tr>
		<tr $VARS->{bg_header}>
			<td align="center"><$VARS->{header_font}><b>No</b></font>
			</td>
			<td align="center"><$VARS->{header_font}><b>ڷ </b></font>
			</td>
			<td align="center"><$VARS->{header_font}><b>ø</b></font>
			</td>
			<td align="center"><$VARS->{header_font}><b>ũ(Bytes)</b></font>
			</td>
			<td align="center"><$VARS->{header_font}><b>ٿε</b></font>
			</td>
			<td align="center"><$VARS->{header_font}><b>ø</b></font>
			</td>
		</tr>
	~;
}

sub attach {
	my $self = shift;
	my $html_output = '';
	my $filename;
	my ($found, @tmpfile);
	my $id = $MEMBER->USER_ID() || $self->error_msg("ڷ  !", "մ ڷḦ ø  ϴ");
	
	opendir (DIR, $self->{TMPDIR});
		while ( defined ($filename = readdir(DIR)) ) {
			$filename =~ /^($id.\d+).file$/ and push @tmpfile, $1 and $found = 1;
		}
	closedir DIR;
	
	my $total = 0;
	
	$html_output .= qq~$VARS->{stable_top}
		<table $VARS->{itable}>
		<tr $VARS->{bg_header}>
		<td colspan="2"><$VARS->{header_font}><b>ڷ </b></font>
		</td>
		</tr>
		<tr $VARS->{forum_bgcolor}>
		<td colspan="2"><$VARS->{font}><b>1 ܰ</b> - ÷  "ãƺ..." ư ̿Ͽ 
		 "" ư Ŭմϴ.<br>  ϰ     ݺմϴ.
		̹    ġ ʴ  Ͽ մϴ.
		<p><b>2 ܰ</b> - 1 ܰ迡  ڷῡ    ϰ Էմϴ.<br>
		 "ڷ " ư Ŭմϴ.</font><br><br>
		<tr $VARS->{bg_header2}>
		<td colspan="2"><$VARS->{font}><b>1 ܰ</b></font>
		</td>
		</tr>~;
	
	my $count = 0;
	if ($found) {
		my $attachinfo = DB->get_data($self->{INFO});
		
		$html_output .= qq~
		<form method="post" enctype="multipart/form-data">
		<input type="hidden" name="ch" value="Forum">
		<input type="hidden" name="do" value="Pds">
		<input type="hidden" name="cid" value="$IN->{cid}">
		<input type="hidden" name="b" value="$IN->{b}">
		<input type="hidden" name="action" value="delete">~;

		my ($filesize, $bgcolor);
		
		foreach (@tmpfile) {
			$bgcolor = DB->color($count);
			$total += $attachinfo->{$_}->{filesize};
			$filesize = $self->filesize($attachinfo->{$_}->{filesize});
			$count++;

			$html_output .= "<tr $bgcolor><td colspan=\"2\"><$VARS->{font}><b>$count.</b>&nbsp;";
			$html_output .= qq|<input type="checkbox" name="$_" value="delete">|;
			$html_output .= "<b>$attachinfo->{$_}->{filename}</b>";
			$html_output .= ", $filesize bytes";
			$html_output .= ", " . $attachinfo->{$_}->{filetype};
			$html_output .= "</font></td></tr>";
		}
		$total = $self->filesize($total);
		
		$html_output .= qq~</td></tr>
			<tr $VARS->{msgbox_color}>
			<td colspan="2"><$VARS->{font}> ũ հ: <b>$total</b> Bytes</font>
			</td></tr>
			<tr $VARS->{msgbox_color}>
			<td colspan="2"><input type="submit" value="  "></form>~;
	}
	
	my $uid = $MEMBER->MEMBER_ID();
	
	$html_output .= qq~
	<tr $VARS->{msgbox_color}>
		<td><$VARS->{font}><b> ÷:</b></font>
		</td>
		<td>
		~;
	$html_output .= $self->_upload_form();
	
	$html_output .= qq~
		<form method="post">
		<input type="hidden" name="ch" value="Forum">
		<input type="hidden" name="do" value="Pds">
		<input type="hidden" name="cid" value="$IN->{cid}">
		<input type="hidden" name="b" value="$IN->{b}">
		<input type="hidden" name="action" value="save">
	
	</td></tr>
	<tr $VARS->{bg_header2}>
		<td colspan="2"><$VARS->{font}><b>2 ܰ</b></font>
		</td>
	</tr>
	<tr $VARS->{msgbox_color}>
		<td><$VARS->{font}><b>:</b></font>
		</td>
		<td><$VARS->{font}>$uid</font>
		</td>
	</tr>
	<tr $VARS->{msgbox_color}>
		<td><$VARS->{font}><b>ڷ ̸:</b></font>
		</td>
		<td><input type="text" name="subject" size="50">
		</td>
	</tr>
	<tr $VARS->{msgbox_color}>
		<td><$VARS->{font}><b>ڷ :</b></font>
		</td>
		<td><textarea name="desc" cols="50" rows="7" wrap="virtual"></textarea></td>
	</tr>
	<tr $VARS->{msgbox_color}><td>&nbsp;</td><td>
			<input type="submit" value="ڷ  ($count)">
			<input type="reset" value="ڷ  ٽۼ">
			</form></td></tr>
	</table>$VARS->{table_bottom}~;
	
	my $dir = "<IMG SRC=\"$CONFIG->{images_url}/arrow.gif\" ALIGN=\"ABSMIDDLE\">";
	my $nav_upload = qq~<a href="index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}">ڷ</a> $dir ڷ~;
	
	$self->{TEMPLATE}->param(
		nav_bar	=> $self->navigation_bar( __PACKAGE__, $IN->{cid}, ,$IN->{b}) . $nav_upload,
		jscript	=> $self->js_goforum,
		go_forum => $self->goforum(),
		pds	=> $html_output
	);
}

sub save {
	eval { require File::Copy; };

	my $self = shift;
	my ($savefile, $filename, $found, $id, @tmpfile);
	my $id = $MEMBER->USER_ID();
	my $fileid = "$CONFIG->{data_directory}/pds/$IN->{b}/id.txt";
	my $idx = 1;
	my $attach = {};
	my $list = {};
	
	$IN->{subject} or $self->error_msg("Է !", " Է ʾҽϴ.");
	$IN->{desc}  or $self->error_msg("Է !", "ڷ  Է ʾҽϴ.");
	
	opendir (DIR, $self->{TMPDIR});
		while ( defined ($filename = readdir(DIR)) ) {
			push @tmpfile, grep { /^$id.\d+.file$/ } $filename and $found = 1;
		}
	closedir DIR;
	
	unless (-e $fileid) {
		open (ID, ">$fileid");
			flock (ID, 2);
			print ID $idx;
		close ID;
		chmod 0666, $fileid;
	}
	else {
		open (ID, $fileid);
			flock (ID, 1);
			$idx = <ID> + 1;
		close ID;
		open (ID, ">$fileid");
			flock (ID, 2);
			print ID $idx;
		close ID;
	}
	
	if ($found) {
		if (!@$) {
			foreach (@tmpfile) {
				m,^(\d+)(.+)$, and
				File::Copy::move( "$self->{TMPDIR}/$_", "$self->{UPLOAD}/$idx$2");
			}
		}
		$attach->{UID} = $id;
		$attach->{DATE} = DB->current_date();
		$attach->{SUBJECT} = $IN->{subject};
		$attach->{DESC} = DB->message_check($IN->{desc});
		$attach->{DOWNLOAD} = 0;
		
		my $tmp = DB->get_data($self->{INFO});
		my %insert = ();
		
		foreach (keys %$tmp) {
			m,^(\d+)(.+)$, and $insert{ $idx.$2 } = $tmp->{$_};
		}
			
		$attach->{UPLOAD} = [ \%insert ];
		
		my $dbfile = "$CONFIG->{data_directory}/pds/$IN->{b}/list.db";

		if (! -e $dbfile) {		
			$list->{$idx} = DB->sort_time();
			DB->_dumper($dbfile, $list);
		}
		else {
			$list = DB->get_data($dbfile);
			$list->{$idx} = DB->sort_time();
			DB->_dumper($dbfile, $list);
		}
		
		DB->_dumper("$CONFIG->{data_directory}/pds/$IN->{b}/$idx.cgi", $attach);
		unlink "$self->{TMPDIR}/$id.info", "$self->{TMPDIR}/$id.tmp";

	}
	else { $self->error_msg("ڷ  ", "÷  ϴ."); }
	
	$self->redirect("index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}");
}

sub delete {
	my $self = shift;
	my @delete = ();
	my $tmp = DB->get_data($self->{INFO});
	
	foreach (%$IN) {
		$IN->{$_} eq "delete" and push @delete, $_;
	}

	foreach (@delete) {
		unlink "$self->{TMPDIR}/$_.file";
		delete $tmp->{$_};
	}
	
	DB->_dumper($self->{INFO}, $tmp);
	
	$self->redirect("index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}&action=attach");
}


sub upload {
	my $self = shift;
	my $id_file = "$self->{TMPDIR}/" . $MEMBER->USER_ID() . ".tmp";
	my $file_id = 1;
	
	if (! -e $id_file) {
		open (ID, ">$id_file");
			flock(ID, 2);
			print ID 1;
		close ID;
	}
	else {
		open (ID, $id_file);
			flock(ID, 1);
			$file_id = <ID> + 1;
		close ID;
		open (ID, ">$id_file");
			flock(ID, 2);
			print ID $file_id;
		close ID;
	}

	if ($IN->{AttachFile}) {
		my $tmp = {};
		if (-e $self->{INFO}) {
			$tmp = DB->get_data($self->{INFO});
		}
		
		my $filename = $MEMBER->USER_ID() . "-" . $file_id;
		my $attach = DB->pds($filename, $IN->{AttachFile});
		
		my %fileinfo = (
			filetype	=> $IN->{FileType},
			filename	=> $attach->{'filename'},
			filesize	=> $attach->{'filesize'}
		);

		$tmp->{ $filename } = \%fileinfo;
		
		DB->_dumper($self->{INFO}, $tmp);
	}

	$self->redirect("index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}&action=attach");
}

sub _upload_form {
		
	qq~<form method="post" enctype="multipart/form-data">
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="do" value="Pds">
	<input type="hidden" name="action" value="upload">
	<input type="hidden" name="cid" value="$IN->{cid}">
	<input type="hidden" name="b" value="$IN->{b}">
	<input type="file" name="AttachFile" size="37">
	<input type="submit" value="">
	</form>~;

}
