package Plugins::PostList;

#======================================================================

#----------------------------------------------------------------------
#  .
#
use strict;
use Setup qw/$CONFIG $VARS/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/;

#----------------------------------------------------------------------
#
#
sub new {
	bless my $self = {};
	
	if ( $self->private_permission($IN->{b}) ) {
		if ($IN->{op} eq "mark") {
			$MEMBER->login_name() ? $self->_mark() : $SESSION->member_login();
		} 
		else {
			if ($MEMBER->login_name()) {
				$self->{SESSION} = DB->get_data( "$CONFIG->{session_path}/" . $SESSION->SESSION() );
			}

		$self->{TEMPLATE} = DB->load_template("list.html");
		$self->{TEMPLATE}->param(DB->style_vars("۸ "));
		$self->init(@_);
		$self->{TEMPLATE}->output;
		}
	}
	else { 
		$self->error_msg(" !", "<b>   Դϴ.<br>      
			ϴ.<br>, ϱ Ͻø  Ǵ ڿ Ͽ ֽʽÿ.</b>");
	}
}

#----------------------------------------------------------------------
#
#
sub _mark {
	my $self = shift;
	my $file ="$CONFIG->{session_path}/" . $SESSION->SESSION();
	my $s = DB->get_data($file);
	
	$s->{$IN->{b}} = [];
	
	my $data = DB->read_file("$CONFIG->{forum_path}/$IN->{b}/topic.db");
		foreach (@$data) {
			chomp;
			push @{$s->{$IN->{b}}}, shift @{ [ DB->data_split($_) ] };
		}
	
	DB->_dumper($file, $s);
	
	$self->redirect("index.cgi?ch=Forum&do=PostList&cid=$IN->{cid}&b=$IN->{b}");
}
			

#----------------------------------------------------------------------
#
#
sub init {
	my $self = shift;
	my ($forum_type, $sort_image, $threads_list, $list, $number, $start, 
		$end, $total, $PrevNext, $forum, @mod_array);
	
	my $data_row = [];
	my $db_file = "topic.db";		# ش   ε  ִ DB.
	my $per_page = $CONFIG->{per_page}; 	#    .
	$per_page = 100 unless $per_page;

	#    ´.
	$forum = DB->forum_data($IN->{b});
	
	#  (, ȸ, ) ´.
	$forum_type = $self->forum_type($forum->{Type});
	
	#----------------------------------------------------------------------
	# Ư ¥  ϵ ۸ .
	#  ڽ , ȸ  ⺻ ´. ԽƮ 
	# ⺻ .
	#----------------------------------------------------------------------
	my $member = $self->read_member; 	#   ȸ  ´.
	my $view = 15;				# ⺻ 15 ı .
	my %threads_view = ();
	
	my @view_array = qw(1 3 7 15 30 60 90 180 365 1095); # ¥ ߰ϰų   ִ.
	foreach (@view_array) { $threads_view{$_}; }
	
	if (exists $IN->{view}) { 
		$threads_view{$IN->{view}} = " selected"; 
		$view = $IN->{view}; 
	
	} else {
		unless ($member) { 
			$threads_view{15} = " selected";
			
		} else {  
			$threads_view{ $member->{TOPIC_VIEW} } = " selected";
			$view = $member->{TOPIC_VIEW}
		}
	}

	my $view_topic = qq|
		<table $VARS->{s_table}>
		<tr><td align="right">
			<form action="index.cgi">
			<input type="hidden" name="ch" value="Forum">
			<input type="hidden" name="cid" value="$IN->{cid}">
			<input type="hidden" name="b" value="$IN->{b}">
			<input type="hidden" name="do" value="PostList">
			<select name="view">|;

	my $view_msg = "  ϵ ۸ ";
	
	foreach (@view_array) {
		$view_topic .= "<option value=\"$_\"$threads_view{$_}>$_$view_msg</option>\n";
	}
	
	$view_topic =~ s/1$view_msg/ ϵ ۸ /g;
	$view_topic =~ s/1095$view_msg/  /g;
		$view_topic .= qq|
		</select> <input type="submit" value="">
		</td></form></tr>
		</table>|;
	
	#----------------------------------------------------------------------
	# ˻  .
	#----------------------------------------------------------------------
	my $search = qq|<$VARS->{font}>
		<input type="hidden" name="ch" value="Forum">
		<input type="hidden" name="do" value="Search">
		<input type="hidden" name="forum" value="$IN->{b}">
		<input type="hidden" name="field" value="all">
		<input type="hidden" name="date" value="all">
		<input type="text" size="17" name="query">
		<input type="submit" value="˻">
		<a href="index.cgi?ch=Forum&do=SearchForm">ɼ</a></font>|;
	
	$self->{TEMPLATE}->param( search => $search );
	
	#----------------------------------------------------------------------
	#   .
	#----------------------------------------------------------------------
	my $field_name = $self->field_name();
	my $list = DB->read_data($IN->{sort}, $IN->{b}, $db_file, $view, $field_name);
	
	$number = $total = $#$list + 1;
	$IN->{page} = 1 unless $IN->{page};
	
	$start = (($IN->{page} -1 ) * $per_page) + 1;
	$end = $IN->{page} * $per_page;
	$end = $total if $total < $end;
	
	$number -= ($start - 1) if $IN->{page} > 1;
	
	#   .
	$self->{TEMPLATE}->param( 
			page => DB->span_page($start, $end, $total, $per_page, $IN) 
			);

	unless (@$list) { 
		$start = $end = 0;
	}
	else {
		$CONFIG->{threads_perpage} = 100 unless $CONFIG->{threads_perpage};
		my $count = 0;
		
		LINE: foreach my $idx ($start-1 .. $end-1) {
			my %list_row = %{$list->[$idx]};
			my $insert_topic_data = DB->insert_data($IN->{b}, $list_row{ID});
		
			while ( my ($key, $val) = each %{$insert_topic_data} ) {
				$list_row{$key} = $val;
			}
			
			#    ,  ʴ´. ڿ ش  ڴ   ֵ Ѵ.
			# ش  ڿ  ԽõǾ  Ѵ.
			next LINE if ($list_row{MODERATOR} and !$self->edit_permission($IN->{b}));
			
			%list_row = $self->topic_list(%list_row);
			
			$list_row{NUMBER} = "<$VARS->{font}>$number</font>";
			$list_row{BGCOLOR} = DB->color($count);

			$number--;
			$threads_list .= DB->insert_tpl(\%list_row, "threads_list.html");
			$count++;
		}
	}
	
	#----------------------------------------------------------------------
	#  ȳ ̺ .
	#----------------------------------------------------------------------
	my $icon_info = qq|
		<table $VARS->{table}>
		<tr>
			<td><IMG SRC="$CONFIG->{images_url}/disk.gif"><br></td>
			<td width="50%"><$VARS->{font}>÷</font>
			</td>
			<td><IMG SRC="$CONFIG->{images_url}/admin.gif"><br></td>
			<td width="50%"><$VARS->{font}></font>
			</td>
		</tr>
		<tr>
			<td><IMG SRC="$CONFIG->{images_url}/locked.gif"><br></td>
			<td><$VARS->{font}>б (亯   )</font>
			</td>
			<td><IMG SRC="$CONFIG->{images_url}/team.gif"><br></td>
			<td><$VARS->{font}></font>
			</td>
		</tr>
		<tr>
			<td><IMG SRC="$CONFIG->{images_url}/new_file.gif"><br></td>
			<td><$VARS->{font}> (ȸ)</font>
			</td>
			<td><IMG SRC="$CONFIG->{images_url}/hot.gif"><br></td>
			<td><$VARS->{font}>б $CONFIG->{hot_icon}  ̻  .</font>
		$VARS->{table_bottom}|;
	
	#    .
	$sort_image = $VARS->{sort_img};

	#  .
	my ($user, $name);
	foreach (@{$forum->{Moderator}}) {
			$user = $self->member_data($_);
			$name = $user->{MEMBER_ID};
			$_ = "<a href=\"index.cgi?ch=Member&do=member_profile&ID=$_\">$name</a>";
			push @mod_array, $_; 
		}
	
	my $folder = $forum->{ModerationB} eq "On" ? "mod" : "folder";
	$folder = qq~<img src="$CONFIG->{images_url}/$folder.gif" align="absmiddle">&nbsp;~;
	
	my $pds = DB->get_data("$CONFIG->{data_directory}/pds/$IN->{b}/list.db");
	my @attach_total = keys %$pds;
	my $files = scalar @attach_total;
	
	my $forum_name = qq~$folder$forum->{Name} ($forum_type ) 
		<img src="$CONFIG->{images_url}/disk.gif" align="absmiddle">
		<a href="index.cgi?ch=Forum&do=Pds&cid=$IN->{cid}&b=$IN->{b}">ڷ</a>($files)~;

	$self->{TEMPLATE}->param(
		threads_list 	=> $threads_list,
		sort_subject	=> "<A HREF=\"index.cgi?ch=Forum&do=PostList&cid=$IN->{cid}" .
				"&b=$IN->{b}&sort=subject\">$sort_image</A>",
		
		sort_date	=> "<A HREF=\"index.cgi?ch=Forum&do=PostList&cid=$IN->{cid}" .
				"&b=$IN->{b}&sort=date\">$sort_image</A>",
		
		moderator	=> @mod_array ? join(", ", @mod_array) : '',
		nav_bar		=> $self->navigation_bar( __PACKAGE__, $IN->{cid}, "$forum->{Name} ($forum_type)"),
		icon_info	=> $icon_info,
		view_topic	=> $view_topic,
		goforum		=> $self->goforum,
		jscript		=> $self->js_goforum,
		mark		=> "<IMG SRC=\"$CONFIG->{images_url}/open.gif\" align=\"absmiddle\">" .
				" <A HREF=\"index.cgi?ch=Forum&do=PostList&cid=$IN->{cid}&b=$IN->{b}&op=mark\">" .
				"ü  · ǥ()</A>",
		
		forum_name 	=> $forum_name,
	);
}

#----------------------------------------------------------------------
#
#----------------------------------------------------------------------
sub topic_list {
	my ($self, %list_row) = @_;
	my ($userid, $toolbar, $attach_file, $open_close, $t_page, $poster);
	
	$attach_file = ($list_row{ATTACH}) ? 
		"<A HREF=\"index.cgi?ch=Forum&do=AttachFile&ID=$IN->{b},$list_row{ID}&f=$list_row{ATTACH}\">" .
		"<IMG SRC=\"$CONFIG->{images_url}/disk.gif\" BORDER=\"0\"" . 
		" ALT=\"$list_row{ATTACH}, $list_row{ATTACH_TYPE}, $list_row{ATTACH_SIZE} Ʈ\"" .
		" ALIGN=\"ABSMIDDLE\"></A>" : 0;
			
	$list_row{SUBJECT} = DB->trim_text($list_row{SUBJECT}, $CONFIG->{subject_length});
	$list_row{SUBJECT} = "<$VARS->{font}>" .
		"<b><a href=\"index.cgi?ch=Forum&do=ReadPost&cid=$IN->{cid}&b=$IN->{b}&t=$list_row{ID}\">" .
		"$list_row{SUBJECT}</a></b></font>";
	$list_row{SUBJECT} .= "&nbsp;$attach_file" if $attach_file;

	#----------------------------------------------------------------------
	# 亯 .
	#----------------------------------------------------------------------
	if ( $list_row{REPLIES} > $CONFIG->{threads_perpage} ) {
		$t_page  = int($list_row{REPLIES} / $CONFIG->{threads_perpage}) + 1;
		$toolbar = "<img src=\"$CONFIG->{images_url}/posticon.gif\" align=\"absmiddle\">:&nbsp;";
		
		for (1..$t_page) {
		$toolbar .= "<a href=\"index.cgi?ch=Forum&do=ReadPost&b=$IN->{b}&t=$list_row{ID}&page=$_\">$_</a> ";
		}
		
		$toolbar .= "[<a href=\"index.cgi?ch=Forum&do=ReadPost&b=$IN->{b}&t=$list_row{ID}&page=all\">" .
			"κ</a>]";
		$list_row{SUBJECT} .= "&nbsp;$toolbar";
	}
		
	#----------------------------------------------------------------------
	# hot icon .
	#----------------------------------------------------------------------
	$list_row{SUBJECT} .= "&nbsp;<IMG SRC=\"$CONFIG->{images_url}/hot.gif\" align=\"absmiddle\">" 
		if ($list_row{REPLIES} >= $CONFIG->{hot_icon});
			
	#----------------------------------------------------------------------
	# ȸ  ȸ ũŰ ڿ    .
	#----------------------------------------------------------------------
	if ($list_row{USER_ID} ne "guest") {
		$poster = $self->member_data($list_row{USER_ID});
		$userid = $poster->{USER_ID};
		$list_row{AUTHOR} = "<$VARS->{font}>" .
			"<a href=index.cgi?ch=Member&do=member_profile&ID=$userid>" .
			"$list_row{AUTHOR}</a></font>";
				
		if ($poster->{MEMBER_LEVEL} > 2) {
			$list_row{AUTHOR} .= $self->member_icon($poster->{MEMBER_LEVEL});
		}
	}
	else { $list_row{AUTHOR} = "<$VARS->{font}>$list_row{AUTHOR}</font>"; }

	#----------------------------------------------------------------------
	# б Խ Ǵ   .
	#----------------------------------------------------------------------
	if ($list_row{CLOSE}) {
		$open_close = "locked";
	}
	else {
		if (exists $self->{SESSION}->{$IN->{b}}) {
			my $found = 0;
				
			foreach (@{$self->{SESSION}->{$IN->{b}}}) {
				$_ eq $list_row{ID} and $found = 1 and last;
			}
				
			$open_close = ($found) ? "open" : "new_file";
		}
		elsif (! $MEMBER->login_name()) {
			$open_close = "open";
		}
		else {
			$open_close = "new_file";
		}
	}

	$list_row{file_icon} = "<img src=\"$CONFIG->{images_url}/$open_close.gif\"><BR>";

	return %list_row;
}
#----------------------------------------------------------------------
