package Plugins::PrevNext;

use strict;
use Setup qw($CONFIG);
use CH::Getform;
use vars qw(@ISA);

@ISA = qw(Board);

sub new {
	bless my $self = {};
	
	my (@threads, @data_row, @unsorted, $go_topic);
	
	open (FH, "$CONFIG->{forum_path}/$IN->{b}/topic.db");
		flock(FH, 1);
		while (<FH>) {
			@data_row = split/\Q$CONFIG->{db_delim}\E/;
			push @unsorted, [ shift @data_row, shift @data_row ];
		}
	close FH;

	@threads = 	map { $_->[1] }
			sort { $a->[0] <=> $b->[0] }
			map { [ $unsorted[$_][1], $unsorted[$_][0] ] } 0..$#unsorted;
	
	my $idx = -1;
	LINE: for ( 0..$#threads ) {
		$idx++;
		last LINE if $IN->{t} == $threads[$_];
	}
	
	if ($IN->{what} eq "prev") {
		$go_topic = ($idx == 0) ? $threads[0] : $threads[$idx - 1];
	}
	else {
		$go_topic = ($idx == $#threads) ? $threads[$idx] : $threads[$idx + 1];
	}
	
	$self->redirect("index.cgi?ch=Forum&do=ReadPost&cid=$IN->{cid}&b=$IN->{b}&t=$go_topic");
	
}

#----------------------------------------------------------------------
