package Plugins::ReadPost;

use strict;
use Setup qw($CONFIG $VARS);
use CH::Getform;
use CH::DBUtil;
use vars qw(@ISA);

@ISA = qw(Board);

#----------------------------------------------------------------------
#
#
sub new {
	bless my $self = {};
	
	if ( $self->forum_permission($IN->{b}) ) {
		$self->{TPL} = {
			print	=> "print.html",
			default => "read_post.html",
			type2	=> "read_post.html" };
		
		my $tpl = (defined $IN->{op}) ? $self->{TPL}->{$IN->{op}} : $self->{TPL}->{default};
		
		$self->{acl} = $self->edit_permission($IN->{b});
		$self->{TEMPLATE} = DB->load_template($tpl);
		$self->{TEMPLATE}->param( DB->style_vars("б б") );
		$self->view();
		$self->init(@_);
		$self->{TEMPLATE}->output;
	}
	else { $SESSION->member_login(); }
}

sub view {
	my $self = shift;
	my ($data_line, $data_rows);
	my $found = 0;
	my $output = [];
	my $thread_file = "$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi";
	
	open (FH, "<$thread_file");
		flock(FH, 1);
		while (<FH>) {
			chomp;
			if (/^TOPIC/) {
				my @value = DB->data_split($_);
				$value[8]++;
				$self->{VIEW} = $value[8];
				$self->{TOPIC} = $value[1];
				$self->{CLOSE} = $value[13];
				$self->{MODERATOR} = $value[14];
				$data_line = join $CONFIG->{db_delim}, @value;
				$data_rows .= $data_line . "\n";
				$found = 1;
			}
			else { $data_rows .= $_ . "\n"; }
	}
	close FH;
	
	if ($self->{MODERATOR} and !$self->edit_permission($IN->{b})) {
		$self->error_msg(" б ", "  ڰ   Դϴ.<br>
			     ֽϴ.");
	}
	
	if ($found) {
		DB->_lock($thread_file);
		open (FH, ">$thread_file");
			print FH $data_rows;
		close FH;
		DB->_unlock($thread_file);
	} 
	else { 
		$self->error_msg(" īƮ !", " ȸ   ϴ."); 
	}
	
	#  ũ .
	if ($MEMBER->login_name()) {
		my $file = "$CONFIG->{session_path}/" . $SESSION->SESSION();
		my $s = DB->get_data($file);
		my $found = 0;
		
		if (exists $s->{$IN->{b}}) {
			foreach (@{$s->{$IN->{b}}}) {
				$IN->{t} eq $_ and $found = 1 and last;
			}
		}
	
		unless ($found) {
			push @{$s->{$IN->{b}}}, $IN->{t};
			DB->_dumper($file, $s);
		}
	}
}

sub init {
	my $self = shift;
	my ($list, $threads_total, $start, $end, $forum, $thread, $per_page, $view);
	my ($author, $date, $time);
	my $field_name = $self->readpost_field();
	
	$thread = $IN->{t};
	$list = DB->read_threads($IN->{b}, "$thread.cgi", $field_name);
	$forum = DB->forum_data($IN->{b});
	$per_page = $CONFIG->{threads_perpage};
	$per_page = 100 unless $per_page;
	$threads_total = @$list;
	$IN->{page} = 1 unless $IN->{page};
	
	if ($IN->{page} eq 'all') { 
		$start = 1;
		$end = $threads_total; 
		$view = "<a href=\"index.cgi?ch=Forum&do=ReadPost&b=$IN->{b}&t=$IN->{t}&page=1\">" .
			"<b>$CONFIG->{threads_perpage}</b>  </a>";
	} 
	else {
		$start = ($IN->{page} - 1) * $per_page + 1;
		$end = $IN->{page} * $per_page;
		
		if ($threads_total <= $end) {
			$end = $threads_total;
			$view = '';
		} 
		else {
			$view = "(<a href=\"index.cgi?ch=Forum&do=ReadPost" .
				"&b=$IN->{b}&t=$IN->{t}&page=all\">κ</a>)"; 
		}
		
		$self->{TEMPLATE}->param( 'page', DB->span_page($start, $end, $threads_total, $per_page, $IN) );
	}
	$self->{TEMPLATE}->param( 'view', "<$VARS->{font}>$view</font>");
	
	#----------------------------------------------------------------------
	# , .
	#----------------------------------------------------------------------

	my $prev_target = "< <a href=\"index.cgi?ch=Forum&do=PrevNext&cid=$IN->{cid}" .
			"&b=$IN->{b}&t=$IN->{t}&what=prev\"></a>";
	my $next_target = "<a href=\"index.cgi?ch=Forum&do=PrevNext&cid=$IN->{cid}" .
			"&b=$IN->{b}&t=$IN->{t}&what=next\"></a> >";

	$self->{TEMPLATE}->param( prev_next => "$prev_target | $next_target" );
	
	#----------------------------------------------------------------------
	#  .
	#----------------------------------------------------------------------

	my $html_output = "";
	my $tpl = ($IN->{op} eq "print") ? "threads_print.html" : "threads.html";
	foreach ($start-1..$end-1) {
		my %result = %{$list->[$_]};
		
		# ȸ .
		if ($result{USER_ID} eq 'guest') {
			$result{MEMBER_LEVEL} = $self->member_level(0);
			$result{MEMBER_INFO} = '';
		}
		else {	# ȸ .
			my $member = $self->member_data($result{USER_ID});

			$result{PICTURE} =  "<img src=\"$member->{PICTURE}\">" if $member->{PICTURE};
			$result{MEMBER_LEVEL}	= $self->member_level($member->{MEMBER_LEVEL});
			$result{SIGNATURE} = $member->{SIGNATURE};
			$result{MEMBER_INFO} = " | : $member->{POST} | : $member->{CREATE_DATE} |";
			$result{AUTHOR} = "<A HREF=\"index.cgi?ch=Member&do=member_profile" .
					"&ID=$result{USER_ID}\">$result{AUTHOR}</A>";
		}
	
		$result{BGCOLOR} = DB->color($_);
		$result{THREADS_MENU} .= "[<A HREF=\"index.cgi?ch=Forum&do=NewReply&cid=$IN->{cid}" .
				"&b=$IN->{b}&t=$thread&omm=$result{THREADNO}&c=$self->{CLOSE}\">亯</A>]" .
		
		"[<A HREF=\"index.cgi?ch=Forum&do=NewReply&cid=$IN->{cid}&b=$IN->{b}" .
				"&t=$thread&omm=$result{THREADNO}&what=quote\">亯ο</A>]" .
		
		"[<A HREF=\"index.cgi?ch=Forum&do=EditPost" .
				"&cid=$IN->{cid}&b=$IN->{b}&t=$thread&omm=$result{THREADNO}\"></A>]";
		
		if ($self->{acl}) {
		$result{THREADS_MENU} .= "[<A HREF=\"index.cgi?ch=Forum&do=RemoveThreads" .
				"&cid=$IN->{cid}&b=$IN->{b}&t=$thread&omm=$result{THREADNO}\"></A>]";
		}

		$result{THREADS_MENU} .= ($result{USER_ID} ne 'guest') ? 
			"[<A HREF=\"index.cgi?ch=Forum&do=Sendmail&ID=$result{'USER_ID'}\"></A>]" : "";

		$result{MSG_ICON} = "$CONFIG->{images_url}/icons/$result{MSG_ICON}";
		
		if (defined $result{ATTACH} and $result{ATTACH_SIZE} > 0) {
			$result{ATTACH} = "<BR><img src=\"$CONFIG->{images_url}/disk.gif\" align=\"absmiddle\">" .
				"&nbsp;<A HREF=\"index.cgi?ch=Forum&do=AttachFile" .
				"&ID=$result{FILENAME}&f=$result{ATTACH}\">$result{ATTACH}</A><BR>" .
				"$result{ATTACH_SIZE} Ʈ<BR>" .
				"$result{ATTACH_TYPE}<BR>";
		}
		
		if ($result{THREADNO} == 0) {
			$author = $result{AUTHOR} . "($result{MEMBER_LEVEL})"; 
			$date = $result{DATE}; 
			$time = $result{TIME};
		}
		
		if (defined($IN->{term})) {
			$result{MESSAGE} = DB->search_text($result{MESSAGE}, $IN->{term}); 
			$result{SUBJECT} = DB->search_text($result{SUBJECT}, $IN->{term}); 
			$result{AUTHOR}  = DB->search_text($result{AUTHOR}, $IN->{term}); 
		}
		
		#----------------------------------------------------------------------
		# Ʈ .
		#----------------------------------------------------------------------

		$result{AUTHOR} 	= "<$VARS->{font}>$result{AUTHOR}</font>";
		$result{MEMBER_LEVEL} 	= "<$VARS->{font}>$result{MEMBER_LEVEL}</font>";
		$result{DATE} 		= "<$VARS->{font}>$result{DATE}</font>";
		$result{TIME} 		= "<$VARS->{font_time}>$result{TIME}</font>";
		$result{IP} 		= "<$VARS->{font}>IP: $result{IP}</font>";
		$result{MEMBER_INFO} 	= "<$VARS->{font}>$result{MEMBER_INFO}</font>";
		$result{SUBJECT} 	= "<$VARS->{font}>$result{SUBJECT}</font>";
		$result{MESSAGE} 	= "<$VARS->{font}>$result{MESSAGE}</font>";
		$result{ATTACH} 	= "<$VARS->{font}>$result{ATTACH}</font>";
		$result{THREADS_MENU} 	= "<$VARS->{font}>$result{THREADS_MENU}</font>";
		
		$html_output .= DB->insert_tpl(\%result, $tpl);
	}
	
	my $util_menu = qq|
	<IMG SRC="$CONFIG->{images_url}/print.gif" BORDER="0">
	<A HREF="index.cgi?ch=Forum&do=ReadPost&b=$IN->{b}&t=$IN->{t}&op=print&page=all" TARGET="_blank">
	б μ .</A><BR>
	<IMG SRC="$CONFIG->{images_url}/email_to_friend.gif" BORDER="0">
	<A HREF="index.cgi?ch=Forum&do=EmailToFriend&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}">
	б Ϸ մϴ.</A>|;

	my $reply_total = $threads_total - 1;

	my $topic_info = qq|
	  <B>$author</B>  $date, <$VARS->{font_time}>$time</FONT> Ͽ  
	<B>$reply_total</B>  亯 ԵǾ ֽϴ.<br>
	 б   Ǵ  ׸  ۼ ȸ ϸ մ  
	  ϴ.<br>
	 , , Խ, ̵  ڿ ڸ   ֽϴ.<BR>|;
	
	my $mod_util = '';
	
	if ($self->{acl}) {
		my $remove_topic = "[<A HREF=\"index.cgi?ch=Forum&do=RemoveThreads" .
				"&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}&omm=0\"></A>]";
		my $close_open = "[<A HREF=\"index.cgi?ch=Forum&do=CloseOpen" .
				"&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}&action=close\"></A>]";
		
		if ($self->{CLOSE}) {
			$close_open = "[<A HREF=\"index.cgi?ch=Forum&do=CloseOpen" .
				"&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}&action=open\">Խ</A>]";
		}
		
		my $move_threads = "[<A HREF=\"index.cgi?ch=Forum&do=MoveTopic" .
				"&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}\">̵</A>]";
		my $msg_q = '';
		
		if ($self->{MODERATOR}) {
			$msg_q = "[<A HREF=\"index.cgi?ch=Forum&do=MessageQ" .
				"&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}\"></A>]";
		}
		
		$mod_util = qq|$VARS->{table_top}
			<table $VARS->{table}>
			<tr><td $VARS->{forum_bgcolor}><$VARS->{font}>
				 : $remove_topic$close_open$move_threads$msg_q</font>
			</td></tr>
			$VARS->{table_bottom}
			$VARS->{table_bottom}
			$VARS->{spacer}|;
	}

	$self->{'TEMPLATE'}->param(
		nav_bar		=> $self->navigation_bar( __PACKAGE__, $IN->{cid}, $IN->{b}) . $self->{TOPIC},
		threads		=> $html_output,
		hit		=> $self->{VIEW},
		mod_util	=> $mod_util,
		util_menu 	=> $util_menu,
		goforum		=> $self->goforum,
		jscript		=> $self->js_goforum,
		topic_info 	=> $topic_info );
}

#----------------------------------------------------------------------
