package Plugins::RemoveSuccess;
#======================================================================

use strict;
use Setup qw/$CONFIG $LANG/;
use CH::DBUtil;
use CH::Getform;
use vars qw/@ISA/;

@ISA = qw/Board/;

sub new {
	my $self = bless {};
	
	if ($IN->{'confirm'} eq $LANG->{'REMOVE_NO_BUTTON'}) {
		$self->redirect($IN->{'target'});
	} else {
		$self->{'TEMPLATE'} = DB()->load_template("remove_success.html");
		$self->{'TEMPLATE'}->param( DB()->style_vars("б  Ϸ!") );
		$self->_init(@_);
		$self->{'TEMPLATE'}->output;
	}
}

sub _init {
	my $self = shift;
	my $forum = DB->get_data("$CONFIG->{forum_path}/$IN->{b}.info");
	
	
	my ($output, %topic_row, %thread_row, $msg);
	$topic_row{$IN->{t}} = 1;
	$thread_row{$IN->{omm}} = 1;
	
	#----------------------------------------------------------------------
	#   .

	my $target_file = "$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi";

	if ($IN->{omm} == 0) {
		my $file = "$CONFIG->{forum_path}/$IN->{b}/topic.db";
		
		DB->_lock($file);
		open (FH, $file) or
			$self->error_msg(" !", "$file    ϴ. : $!");
			LINE: while (<FH>) {
				chomp;
				my @data = DB->data_split($_);
				($topic_row{$data[0]}) ? ($topic_row{$data[0]} = 0) : ($output .= "$_\n");
			}
		close FH;

		open (FH, ">$file") or
			$self->error_msg(" !", "$file    ϴ. : $!");
			print FH $output;
		close FH;
		DB->_unlock($file);

		if ($topic_row{$IN->{t}}) {
			$msg = "   Ͽϴ.";
		}
		else {
			unlink $target_file;
			$msg = "   Ͽϴ."
		}
	}
	
	#----------------------------------------------------------------------
	# 亯 .
	else {
		open (FH, $target_file) or
			$self->error_msg(" !", "$target_file    ϴ. : $!");
			flock(FH, 1);
			LINE: while (<FH>) {
				chomp;
				my @data = DB->data_split($_);		
				if (/^TOPIC/) {
					$data[6]--;
					my $data_line = join $CONFIG->{db_delim}, @data;
					$output .= "$data_line\n";
				}
				elsif ($thread_row{$data[1]}) { $thread_row{$data[1]} = 0; }
				else { $output .= "$_\n"; }
			}
		close FH;

		open (FH, ">$target_file") or
			$self->error_msg(" !", "$IN->{b}/topic.db    ϴ. : $!");
			flock(FH, 2);
			print FH $output;
		close FH;
		
		if ($thread_row{$IN->{t}}) {
			$msg = "б  Ͽϴ.";
		}
		else {	
			$msg = "б  Ͽϴ."
		}
	}
	
	$self->{'TEMPLATE'}->param(
		nav_bar		=> $self->navigation_bar(__PACKAGE__, $IN->{cid}, $IN->{b}) . 'б  Ϸ!',
		result		=> $msg
		);

}

#----------------------------------------------------------------------
