package Plugins::RemoveThreads;
#======================================================================

use strict;
use Setup qw($CONFIG $LANG $VARS);
use CH::DBUtil;
use CH::Getform;
use vars qw(@ISA);

@ISA = qw(Board);

sub new {
	bless my $self = {};
	
	$self->{forum} = DB->forum_data($IN->{b});
	
	if ( $MEMBER->login_name() ) {
		my $moderator = 0;
		LINE: foreach ( @{$self->{forum}->{Moderator}} ) {
			$moderator = 1 if ($MEMBER->USER_ID == $_);
			last LINE;
		}
		
		if ($MEMBER->LEVEL == 9 || $moderator) {
			$self->{'TEMPLATE'} = DB->load_template("remove_threads.html");
			$self->{'TEMPLATE'}->param( DB->style_vars("б ") );
			$self->_init(@_);
			$self->{'TEMPLATE'}->output;
		}
		else { $self->error_msg(" !", "    ϴ."); }
	
	} else { $SESSION->member_login }
}

sub _init {
	my $self = shift;
	my @row_data = ();
	my $delete_thread = "";
	
	open (FH, "<$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi") or 
		$self->error_msg("  !", "$IN->{b}/$IN->{t}    ϴ. :$!");
		flock(FH, 1);
		LINE: while(<FH>) {
			chomp;
			/^TOPIC/ and next LINE;
			@row_data = DB->data_split($_);
			($row_data[1] == $IN->{omm}) ? 
			($delete_thread = $row_data[2] and last LINE) : 
			next LINE;
		}
	close FH;
	
	my $target = $self->target();
	my $confirm = <<END_OF_HIDDEN;
		
		<FORM ACTION="index.cgi" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="do" VALUE="RemoveSuccess">
		<INPUT TYPE="HIDDEN" NAME="cid" VALUE="$IN->{cid}">
		<INPUT TYPE="HIDDEN" NAME="b" VALUE="$IN->{b}">
		<INPUT TYPE="HIDDEN" NAME="t" VALUE="$IN->{t}">
		<INPUT TYPE="HIDDEN" NAME="omm" VALUE="$IN->{omm}">
		<INPUT TYPE="HIDDEN" NAME="target" VALUE="$target">
		$VARS->{table_top}
		<TABLE $VARS->{table}>
		<TR $VARS->{bg_header}>
			<TD><FONT $VARS->{header_font}><B>б  Ȯ ($delete_thread)</B></FONT>
			</TD>
		</TR>
		<TR $VARS->{msgbox_color}>
			<TD align="center"><FONT $VARS->{font}><BR>
			      ϴ.<BR>
			÷    ϵ ˴ϴ.<P>
			,    ԵǾ ִ  亯 ˴ϴ.</FONT>
			<P>
				<$VARS->{font}><B> ϰڽϱ?</B></FONT>
			<P>
				<INPUT TYPE="SUBMIT" NAME="confirm" VALUE="$LANG->{'REMOVE_YES_BUTTON'}"> 
				<INPUT TYPE="SUBMIT" NAME="confirm" VALUE="$LANG->{'REMOVE_NO_BUTTON'}">
			<P></font>
		$VARS->{table_bottom}
		$VARS->{table_bottom}
		</FORM>
END_OF_HIDDEN
	
	$self->{'TEMPLATE'}->param(
		nav_bar		=> $self->navigation_bar(__PACKAGE__, $IN->{cid}, $IN->{b}) . 'б ',
		confirm		=> $confirm,
		);
	
}

#----------------------------------------------------------------------
