package Plugins::SearchForm;

#======================================================================

#----------------------------------------------------------------------
#  .
#
use strict;
use Setup qw/$CONFIG/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/;

#----------------------------------------------------------------------
#
#
sub new {
	bless my $self = {};
	
	$self->{TEMPLATE} = DB->load_template("search.html");
	$self->{TEMPLATE}->param(DB->style_vars(" ˻"));
	$self->_init(@_);
	$self->{TEMPLATE}->output;
}

sub _init {
	my $self = shift;
	my $list = DB->get_data($CONFIG->{cat_file});
	my ($forum, $forum_list);
	
	$forum_list = "<select name=forum>\n";
	for (keys %$list) {
		for (@{$list->{$_}->{ForumList}}) {
			$forum = DB->forum_data($_);
			$forum_list .= "<option value=$_>$forum->{Name} (" 
					. $self->forum_type($forum->{Type}) 
					. ")\n";
		}
	}

	$forum_list .= "<option value=all selected> ";
	$forum_list .= "</select>";
	
	my $hidden_tag = qq|
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="do" value="Search">|;
	
	$self->{TEMPLATE}->param ( 
			hidden_tag => $hidden_tag,
			forum_list => $forum_list
		);
}
