package Plugins::Sentmail;

use strict;
use Setup qw/$CONFIG/;
use CH::Getform;
use CH::DBUtil;
use CH::Mailer;
use vars qw/@ISA/;

@ISA = qw/Board/;

sub new {
	bless my $self = {};

	if (@_) {
		$self->{TEMPLATE} = DB()->load_template("sentmail.html");
		$self->{TEMPLATE}->param( DB()->style_vars("ȸ   Ϸ!") );
		$self->_init(@_);
		$self->{TEMPLATE}->output;
	} else { return 0; }
}

sub _init {
	my $self = shift;
	my $check = FormCheck->new;
	$check->verify_multi(
			[
				{ 
					-name		=> 'subject',
				  	-msg_name	=> '',
				  	-value		=> $IN->{subject},
				  	-type		=> 'subject'
				},
				{	-name		=> 'body',
					-msg_name	=> '',
					-value		=> $IN->{body},
					-type		=> 'body'
				},
				{	-name		=> 'from',
					-msg_name	=> '',
					-value		=> $IN->{from},
					-type		=> 'from'
				},
				{	-name		=> 'email',
					-msg_name	=> ' ּ',
					-value		=> $IN->{from_email},
					-type		=> 'email'
				}
			]
		);

	if ($check->errors) {
		$self->error_msg(" Է !", $check->errors);
	}

	my $mailer = new CH::Mailer (
			From		=> "$IN->{from} <$IN->{from_email}>",
			To		=> "$IN->{to_name} <$IN->{to_email}>",
			Cc		=> $IN->{cc},
			Bcc		=> $IN->{bcc},
			Encoding	=> 'Base64',
			Subject		=> $IN->{subject},
			Data		=> $IN->{body},
			Type		=> uc $IN->{mailtype},
		) or $self->error_msg("  ", "CH::Mailer !");
	
	my $random = time . $$ . int(rand(1000));
	my ($attachfile, $filesize, $filename, $attach, $sentfile);
	
	if ($IN->{'AttachFile'}) {
		$filename = "$random.tmp";
		($attach) = DB->attach_file($filename, $IN->{'AttachFile'});
		$attachfile = $attach->{'filename'};
		$filesize = reverse $attach->{'filesize'}; 
		$filesize =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
		$filesize = scalar reverse $filesize;
	
		if ((-e "$CONFIG->{upload}/$filename.file") and
		(-s "$CONFIG->{upload}/$filename.file" > 0)) {
		$mailer->file_attachment (
			Type		=> $IN->{'FileType'},
			Path		=> "$CONFIG->{upload}/$filename.file",
			Filename	=> $attachfile,
			);
		$sentfile = "̸: $attachfile<BR>: $IN->{'FileType'}<BR>ũ: $filesize Ʈ<BR>";

		} else { }
	
	} else { $sentfile = ""; }
	
	$mailer->send() or $self->error_msg("  ", "CH::Mailer !");
	
	my $nav = ("ȸ  ");
	$self->{TEMPLATE}->param(
			nav_bar => $self->navigation_bar($nav),
			to	=> $IN->{to},
			from	=> "$IN->{from} - $IN->{from_email}",
			cc	=> ($IN->{cc}) ? $IN->{cc} : "",
			bcc	=> ($IN->{bcc}) ? $IN->{bcc} : "",
			subject => $IN->{subject},
			body	=> DB->message_check($IN->{body}),
			attach	=> $sentfile
	);

	opendir (TMP, $CONFIG->{upload}) or $self->error_msg("ý ", " 丮   ϴ.");
		my @tmp_files = grep(/.tmp.file/, readdir(TMP));
	closedir TMP;
	
	foreach (@tmp_files) {
		if (-M "$CONFIG->{upload}/$_") {
			unlink ("$CONFIG->{upload}/$_");
		}
	}
}

#----------------------------------------------------------------------
