package Plugins::WriteEdit;

#======================================================================
#
use strict;
use Setup qw/$CONFIG $VARS/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/;

#----------------------------------------------------------------------	
#
#
sub new {
	bless my $self = {};
	
	if (@_) {
		if ($IN->{Action} eq "̸") {
			$self->preview(@_) if $self->_check;
		}
		else {
			if ($self->_check) {
				$self->{date} = '';
				$self->{time} = '';
				$self->{icon} = '';
				$self->save(@_);
			}
		}
	}
	else { return 0; }
}

#----------------------------------------------------------------------	
#
#
sub preview {
	my $self = shift;
	my $forum = DB->get_data("$CONFIG->{forum_path}/$IN->{b}.info");

	my $hidden_tag = qq|
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="do" value="WriteEdit">
	<input type="hidden" name="cid" value="$IN->{cid}">
	<input type="hidden" name="b" value="$IN->{b}">
	<input type="hidden" name="t" value="$IN->{t}">
	<input type="hidden" name="omm" value="$IN->{omm}">
	<input type="hidden" name="Author" value="$IN->{Author}">
	<input type="hidden" name="UserID" value="$IN->{UserID}">
	<input type="hidden" name="target" value="$IN->{target}">|;
	
	my $html_use = "On"; 
	my $ch_code = "Off";
	
	if ($CONFIG->{use_chcode}) { $html_use = "Off"; $ch_code = "On"; }
	my $use_tag = "HTML ± : $html_use<br>CH ڵ : $ch_code<br>";

	my $content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\">";
	
	if ($CONFIG->{attach}) {
		$content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">";
	}
	my $mailer = '<BR><INPUT TYPE="CHECKBOX" NAME="Mailer" VALUE="1" CHECKED> - 亯 ϵǸ 
			  ðڽϱ?';
	my $subject = DB->text_trim($IN->{Subject});
	my $author  = DB->text_trim($IN->{Author});
	my $message = DB->message_check($IN->{Message});
	my $msg_icon = "<img src=\"$CONFIG->{images_url}/icons/$IN->{icon}.gif\" align=\"absmiddle\">";
	
	my $review = qq|
	<table $VARS->{table}>
	<tr $VARS->{bg_header}>
		<td colspan="2"><$VARS->{header_font}><b>ۼϽ   ϴ.</b></font>
		</td>
	</tr>
	<tr $VARS->{bg_color1}>
		<td width="20%"><$VARS->{font}><b>۾:</b></font>
		</td>
		<td width="80%"><$VARS->{font}>$author</font>
		</td>
	</tr>
	<tr $VARS->{bg_color2}>
		<td><$VARS->{font}><b>:</b></font>
		</td>
		<td>$msg_icon <$VARS->{font}>$subject</font>
		</td>
	</tr>
	<tr $VARS->{bg_color1}>
		<td colspan="2" class="messagebody"><br>
		<blockquote><$VARS->{font}>$message</font></blockquote>
		</td>
	</tr></table>|;
	
	$self->{TEMPLATE} = DB()->load_template("preview.html");
	$self->{TEMPLATE}->param( DB()->style_vars("̸") );

	$self->{TEMPLATE}->param(
		nav_bar		=> $self->navigation_bar(__PACKAGE__, $IN->{cid}, $IN->{b}) . "  ̸",
		hidden_tag	=> $hidden_tag,
		author		=> $IN->{Author},
		forum_name	=> $forum->{Name},
		use_tag		=> $use_tag,
		message_icons	=> DB->message_icon("gif"),
		jscript		=> DB()->JSEmotion_CHCode,
		emotion_chcode	=> DB()->emotion_chcode,
		content_type	=> $content_type,
		subject		=> $IN->{Subject},
		message		=> $IN->{Message},
		mailer		=> $mailer,
		review		=> $review
	);
	
	return $self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
#
#
sub save {
	my $self = shift;
	my ($threads_data, $data_line, $thread_file);
	
	$IN->{Message} = DB->message_check($IN->{Message}); 	# ޽  üũ.
	$IN->{Subject} = DB->text_trim($IN->{Subject});		#  üũ.
	$IN->{Author} = DB->text_trim($IN->{Author});		# ̸ üũ.

	$threads_data = $self->threads_def($IN);	# DB ׸ ´.
	$threads_data->{'TR'}[1] = "REPLY";		# ù ׸ "REPLY"  .
	
	$self->{date} = $threads_data->{DATE}[1];
	$self->{time} = $threads_data->{TIME}[1];
	$self->{icon} = $threads_data->{MSG_ICON}[1];
	
	# ȸ, 亯 , ۸,  ׸ Ѵ.
	# 亯 DB ׸񿡴  ׸ ߰ ʴ´.
	
	for ( qw!VIEW REPLIES CLOSED MODERATOR MAIL! ) { delete $threads_data->{$_} }

	#----------------------------------------------------------------------
	# ش   Ѵ.
	my $tmpfile = substr(time, -4) . int(rand(10000)); # ӽ ̸ .
	$thread_file = "$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi"; #    ´.
	
	unless (-w $thread_file) { # ش    尡 ƴϸ ۹̼ .
		chmod 0666, $thread_file or $self->error_msg("۾  ", " ۹̼  !");
	}
	
	# ε     εϰ ̸, ũ,  ´.
	if ($IN->{AttachFile}) {
		my ($attach) = DB->attach_file("$IN->{b},$IN->{t}-$tmpfile", $IN->{'AttachFile'});
		# ũ⸦ б  3ڸ ޸ ´.
		my $filesize = reverse $attach->{'filesize'}; 
		$filesize =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
		$threads_data->{FILENAME}[1] = "$IN->{b},$IN->{t}-$tmpfile";
		$threads_data->{ATTACH}[1] = $attach->{'filename'};
		$threads_data->{ATTACH_TYPE}[1] = $IN->{FileType};
		$threads_data->{ATTACH_SIZE}[1] = scalar reverse $filesize;
	}
	
	my $output; my $found_thread = 0;

	# ش  Ѵ.
	open (FILE, "<$thread_file") or $self->error_msg("  ", "   ϴ. $!");
		flock(FILE, 1);
		LINE: while (<FILE>) {
			/^\s*$/ and next LINE;
			chomp;
			my @rowdata = split /\Q$CONFIG->{db_delim}\E/;
			
			if ($rowdata[0] eq "TOPIC") { # TOPIC  .
				$rowdata[1] = $IN->{Subject} if $IN->{omm} eq "0";
				$rowdata[3] = $threads_data->{DATE}[1];
				$rowdata[4] = $threads_data->{TIME}[1];
				$rowdata[5] = $IN->{icon} if $IN->{omm} eq "0";
				$self->{subject} = $rowdata[1];
				$self->{starter} = $rowdata[2];
				my $data_line = join $CONFIG->{db_delim}, @rowdata;
				$output .= "$data_line\n";
			}
			elsif ($IN->{omm} eq $rowdata[1]) {
				$rowdata[2] = $IN->{Subject};
				$rowdata[3] = "<FONT COLOR=\"RED\">  $IN->{Author}  " .
					"$threads_data->{DATE}[1], $threads_data->{TIME}[1]  Ͽϴ." .
					"</FONT><BR>" . $IN->{Message};

				$rowdata[5] = $threads_data->{DATE}[1];
				$rowdata[6] = $threads_data->{TIME}[1];
				$rowdata[8] = $IN->{icon};
				my $new_data = join $CONFIG->{db_delim}, @rowdata;
				$output .= "$new_data\n";
				$found_thread = 1;
			}
			else { $output .= "$_\n"; }
		}
	close FILE;
	
	if ($found_thread) {
		open (NEW, ">$thread_file") or 
			$self->error_msg("  ", "   ϴ. $!");
			flock(NEW, 2);
			print NEW $output;
		close NEW;
	}
	else {
		$self->error_msg("  !", "   ϴ.");
	}

	#----------------------------------------------------------------------
	# topic.db  Ѵ.
	#----------------------------------------------------------------------

	my $topic_file = "$CONFIG->{forum_path}/$IN->{b}/topic.db";
	
	unless (-w $topic_file) { 
		chmod 0666, $topic_file or die " ۹̼  : $!\n"; 
	}

	my $found = 0; 
	my $output_db;
	open (FH, "<$topic_file");
		flock(FH, 1);
		LINE: while(<FH>) {
			/^\s*$/ and next LINE;
			chomp;
			my @tmp = split /\Q$CONFIG->{db_delim}\E/;
			if ($IN->{t} eq $tmp[0]) { 
				$tmp[1] = DB()->sort_time;
				$tmp[2] = $IN->{Subject} if $IN->{omm} eq "0";
				my $data_line = join $CONFIG->{db_delim}, @tmp;
				$output_db .= "$data_line\n";
				$found = 1;
			}
			else { $output_db .= "$_\n"; }
		}
	close FH;
	
	if ($found) {
		open (FH, ">$topic_file");
			flock(FH, 2);
			print FH $output_db;
		close FH;
		$self->forum_update();
	}
	else {
		$self->error_msg(" ", "topic.db    ϴ.");
	}
}

#----------------------------------------------------------------------	
#  .
sub forum_update {
	my $self = shift;
	my $file = "$CONFIG->{forum_path}/$IN->{b}.info";
	my $forum_info = DB->get_data($file);

	$forum_info->{Threads} 		+= 1;
	$forum_info->{LastTopic}	= $self->{subject};
	$forum_info->{LastAuthor}	= $self->{starter};
	$forum_info->{LastTopicDate} 	= $self->{date};
	$forum_info->{LastTopicTime}	= $self->{time};
	$forum_info->{LastTopicNo}	= $IN->{t};
	$forum_info->{MessageIcon}	= $self->{icon};
	
	DB->_dumper($file, $forum_info);
	
	my $html_output = qq~
	<$VARS->{font}><b>
		  Ǿϴ.<br>
		    ּż մϴ.<p>
		 ٸø ۼϽ ۷ ưϴ. մϴ.<p></b>
		
		<img src="$CONFIG->{images_url}/anim1.gif"><P>
		
		<a href="index.cgi?ch=Forum&do=PostList&cid=$IN->{cid}&b=$IN->{b}">۸</a> |
		<a href="index.cgi?ch=Forum&do=ReadPost&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}">ۼ б</a>
	</font>~;
	
	$self->{TEMPLATE} = DB->load_template("edit_success.html");
	$self->{TEMPLATE}->param( DB->style_vars("  Ϸ!") );
	$self->{TEMPLATE}->param( 
			target	=> "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; URL=$IN->{target}\">",
			html_output => $html_output );
	
	return $self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
