package Plugins::WritePost;

#======================================================================
#
use strict;
use Setup qw/$CONFIG $VARS/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/;

#----------------------------------------------------------------------	
#
#
sub new {
	bless my $self = {};
	if (@_) {
		if ($IN->{Action} eq "̸") {
			$self->preview(@_) if $self->_check;
		}
		else {
			$self->save(@_) if $self->_check;
		}
	}
	else { return 0; }
}

#----------------------------------------------------------------------	
#
#
sub preview {
	my $self = shift;
	my $forum = DB->get_data("$CONFIG->{forum_path}/$IN->{b}.info");
	my $uid	= $MEMBER->USER_ID();
	my $name = $MEMBER->login_name();

	my $hidden_tag = qq|
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="do" value="WritePost">
	<input type="hidden" name="cid" value="$IN->{cid}">
	<input type="hidden" name="b" value="$IN->{b}">
	<input type="hidden" name="target" value="$IN->{target}">
	|;
	
	if ($name) { 
		$hidden_tag .= qq|
		<input type="hidden" name="Author" value="$IN->{Author}">
		<input type="hidden" name="UserID" value="$IN->{UserID}">
		|;
	
	} else {
		$name = "<input type=\"text\" onfocus=\"WritePost.Author.value=''\" name=\"Author\" value=\"$IN->{Author}\">";
		$hidden_tag .= '<input type="hidden" name="UserID" value="guest">';
	}

	my $html_use = "On"; 
	my $ch_code = "Off";
	
	if ($CONFIG->{use_chcode}) { $html_use = "Off"; $ch_code = "On"; }
	my $use_tag = "HTML ± : $html_use<br>CH ڵ : $ch_code<br>";

	my $content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\">";
	
	if ($CONFIG->{attach}) {
		$content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">";
	}
	my $mailer = ($uid) ? "<BR><INPUT TYPE=CHECKBOX NAME=Mailer VALUE=1 CHECKED> - 亯 ϵǸ 
			  ðڽϱ?" : '';
	
	my $subject = DB->text_trim($IN->{Subject});
	my $author  = DB->text_trim($IN->{Author});
	my $message = DB->message_check($IN->{Message});
	my $msg_icon = "<img src=\"$CONFIG->{images_url}/icons/$IN->{icon}.gif\" align=\"absmiddle\">";
	
	my $review = qq|
	<table $VARS->{table}>
	<tr $VARS->{bg_header}>
		<td colspan="2"><$VARS->{header_font}><b>ۼϽ   ϴ.</b></font>
		</td>
	</tr>
	<tr $VARS->{bg_color1}>
		<td width="20%"><$VARS->{font}><b>۾:</b></font>
		</td>
		<td width="80%"><$VARS->{font}>$author</font>
		</td>
	</tr>
	<tr $VARS->{bg_color2}>
		<td width="20%"><$VARS->{font}><b>:</b></font>
		</td>
		<td width="80%">$msg_icon <$VARS->{font}>$subject</font>
		</td>
	</tr>
	<tr $VARS->{bg_color1}>
		<td colspan="2" class="messagebody"><br>
		<blockquote><$VARS->{font}>$message</font></blockquote>
		</td>
	</tr>
	</table>|;
	
	$self->{TEMPLATE} = DB()->load_template("preview.html");
	$self->{TEMPLATE}->param( DB()->style_vars("̸") );
	$self->{TEMPLATE}->param(
		nav_bar		=> $self->navigation_bar(__PACKAGE__, $IN->{cid}, $IN->{b}) . "̸" . " ($IN->{Subject})",
		hidden_tag	=> $hidden_tag,
		author		=> $name,
		forum_name	=> $forum->{Name},
		use_tag		=> $use_tag,
		message_icons	=> DB->message_icon("gif"),
		jscript		=> DB()->JSEmotion_CHCode,
		emotion_chcode	=> DB()->emotion_chcode,
		content_type	=> $content_type,
		subject		=> $IN->{Subject},
		message		=> $IN->{Message},
		mailer		=> $mailer,
		review		=> $review );
	
	return $self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
#
#
sub save {
	my $self = shift;
	my $forum_info = DB->get_data("$CONFIG->{forum_path}/$IN->{b}.info");
	
	$IN->{Subject} = DB->text_trim($IN->{Subject});
	$IN->{Author}  = DB->text_trim($IN->{Author});
	$IN->{Message} = DB->message_check($IN->{Message});
	
	my $topic_data = $self->topic_def($IN->{Subject});
	my $file = "$CONFIG->{forum_path}/$IN->{b}/topic_id.txt";
	
	unless (-w $file) {
		chmod (0666, $file) or 
			die(" ۹̼   ϴ: $!\n");
	}
	
	if (-e $file) {
		DB->_lock($file);
		open (ID, $file);
			$topic_data->{ID}[1] = <ID> + 1;
		close ID;

		open (ID, ">$file");
			print ID $topic_data->{ID}[1];
		close ID;
		DB->_unlock($file);
		
		$topic_data->{ID}[1] = sprintf("%6d", $topic_data->{ID}[1]);
		$topic_data->{ID}[1] =~ tr/ /0/;
	} 
	
	my ($structure) = DB->data_rows($topic_data);
	my $data_line = join ($CONFIG->{db_delim}, @{$structure});
	my $data_file = "$CONFIG->{forum_path}/$IN->{b}/topic.db";
	
	unless (-w $data_file) {
		chmod(0666, $data_file) or 
			die("۹̼   ϴ: $!\n");
	}

	DB->append_data($data_file, $data_line);
	
	my $top_thread = $self->threads_def($IN);
	my $topic_line = $self->threads_def($IN);
	
	#----------------------------------------------------------------------
	# ÷     ÷ϰ ̸ ũ .
	#----------------------------------------------------------------------

	if ($IN->{AttachFile}) {
		my $filename = "$IN->{b},$topic_data->{ID}[1]";
		my ($attach) = DB->attach_file($filename, $IN->{'AttachFile'});
		
		my $filesize = reverse $attach->{'filesize'}; 
		$filesize =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
		$topic_line->{ATTACH}[1] = $top_thread->{ATTACH}[1] = $attach->{'filename'};
		$topic_line->{ATTACH_SIZE}[1] = $top_thread->{ATTACH_SIZE}[1] = scalar reverse $filesize;
		$topic_line->{FILENAME}[1] = $filename;
		$topic_line->{ATTACH_TYPE}[1] = $top_thread->{ATTACH_TYPE}[1] = $IN->{FileType};
	}

	$topic_line->{'TR'}[1] = 'REPLY';
	
	for ( qw!VIEW REPLIES CLOSED MODERATOR MAIL! ) { delete $topic_line->{$_} }
	
	my $thread_data = DB->data_rows($topic_line);
	my $mail_body = $top_thread->{MESSAGE}[1];
	
	for ( qw!THREADNO MESSAGE IP! ) { delete $top_thread->{$_} }

	#    MODERATOR ׸  True.
	if ($forum_info->{ModerationB} eq "On" and !$self->edit_permission($IN->{b})) {
		$top_thread->{MODERATOR}[1] = 1;
	}
	
	$top_thread->{'TR'}[1] = 'TOPIC';
	
	my $topic_header_line = DB->data_rows($top_thread);
	my $t_file = "$CONFIG->{forum_path}/$IN->{b}/$topic_data->{ID}[1].cgi";
	
	DB->_lock($t_file);
	open (FH, ">$t_file");
		print FH join ($CONFIG->{db_delim}, @{$topic_header_line}) . "\n";
		print FH join ($CONFIG->{db_delim}, @{$thread_data}) . "\n";
	close FH;
	chmod (0666, $t_file);
	DB->_unlock($t_file);
	
	#----------------------------------------------------------------------
	# α  ȸ  ȸ  ۼ   Ѵ.
	#----------------------------------------------------------------------
	
	if ($IN->{UserID} ne "guest") {
		my $file = "$CONFIG->{member_directory}/$IN->{UserID}.cgi";
		my $member = DB->get_data($file);
		
		$member->{POST} += 1;
		
		DB->_dumper($file, $member);
	}

	#----------------------------------------------------------------------
	#   Ѵ.
	#----------------------------------------------------------------------
	
	$forum_info->{TotalTopic} 	+= 1;
	$forum_info->{Threads}		+= 1;
	$forum_info->{LastTopic}	= $topic_line->{SUBJECT}[1];
	$forum_info->{LastAuthor} 	= $topic_line->{AUTHOR}[1];
	$forum_info->{LastTopicDate} 	= $topic_line->{DATE}[1];
	$forum_info->{LastTopicTime}	= $topic_line->{TIME}[1];
	$forum_info->{LastTopicNo} 	= $topic_data->{ID}[1];
	$forum_info->{MessageIcon} 	= $topic_line->{MSG_ICON}[1];
	
	my $f_file = "$CONFIG->{forum_path}/$IN->{b}.info";
	unless (-e $f_file) {
		return ("$f_file   ʽϴ.");
	}
	unless (-w $f_file) {
		chmod(0666, $f_file) or die(" ۹̼   ϴ: $!\n");
	}

	DB->_dumper($f_file, $forum_info);
	
	#----------------------------------------------------------------------
	#  Ǵ ڿ ϱۿ   .
	# ⺻ HTML   , ÷   ʴ´.
	#----------------------------------------------------------------------	
	
	my $to_mail = 0; my $to = '';
	if ($CONFIG->{mailto_admin}) {
		$to = " <$CONFIG->{admin_email}>";
		$to_mail = 1;
	}
	
	if ($CONFIG->{mailto_mod}) {
		$to = " <$CONFIG->{admin_email}>";
		$to_mail = 1;
	}
	
	if ($to_mail) {
		my ($to_name, $from, $subject, $message, $forum_name, $date);
		$to_name	= $to;
		$from		= "$CONFIG->{title} <$CONFIG->{admin_email}>";
		$subject	= $topic_line->{SUBJECT}[1];
		$forum_name	= $forum_info->{Name};
		$date		= "$topic_line->{DATE}[1], $topic_line->{TIME}[1]";
		
		$message	= qq~
<FONT SIZE="2">
  б ϵǾϴ.<BR>
=====================================================<BR>
۾: $topic_line->{AUTHOR}[1]<BR>
: $topic_line->{SUBJECT}[1]<BR>
¥: $date<P>
۳:<BR>
-----------------------------------------------------<BR>
$mail_body
</FONT>
~;
		require CH::Mailer; #  ε.
		my $mailer = new CH::Mailer (
				From		=> $from,
				To		=> $to_name,
				Subject		=> $subject,
				Data		=> $message,
				Type		=> uc $CONFIG->{mail_type},
				) or die("CH::Mailer !\n");
		$mailer->send or die("CH::Mailer !\n");
	} # .
	
	#----------------------------------------------------------------------
	#  ޽ .
	#----------------------------------------------------------------------
	
	my $new_topic = $topic_data->{ID}[1];
	
	my $msg = qq~
		<$VARS->{font}><b>
		ۼϽ   ϵǾϴ!<br>
		    ּż մϴ.<p>
		 ٸø   ưϴ. մϴ.<p></b>~;

	if ($forum_info->{ModerationB} eq "On" and !$self->edit_permission($IN->{b})) {
		$msg = qq~
		<$VARS->{font}><b>
		ۼϽ   ϵǾϴ!<p>
		ڰ ۼϽ   Ȯ   Խ Դϴ.<br>
		   ݰ   ,  Ǵ   ֽϴ.<br> 
		    ּż մϴ.<p>
		 ٸø   ưϴ. մϴ.<p></b>~;
	}

	my $html_output = $msg .  qq~
		<img src="$CONFIG->{images_url}/anim1.gif"><P>
		<a href="index.cgi?ch=Forum&do=PostList&cid=$IN->{cid}&b=$IN->{b}">۸</a> |
		<a href="index.cgi?ch=Forum&do=ReadPost&cid=$IN->{cid}&b=$IN->{b}&t=$new_topic">ۼ б</a>
		</font><p>~;

	$self->{TEMPLATE} = DB->load_template("post_success.html");
	$self->{TEMPLATE}->param( DB->style_vars(" ۾ Ϸ!") );
	$self->{TEMPLATE}->param( 
			target	=> "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5; URL=$IN->{target}\">",
			html_output => $html_output
			);
	
	$self->{TEMPLATE}->output;
}
#----------------------------------------------------------------------
# end of source code.
