package Plugins::WriteReply;

#======================================================================
#
use strict;
use Setup qw/$CONFIG $VARS/;
use CH::Getform;
use CH::DBUtil;
use vars qw/@ISA/;

@ISA = qw/Board/;

#----------------------------------------------------------------------	
#
#
sub new {
	bless my $self = {};
	if (@_) {
		if ($IN->{Action} eq "̸") {
			$self->preview(@_) if $self->_check;
		}
		else {
			$self->save(@_) if $self->_check;
		}
	}
	else { return 0; }
}

#----------------------------------------------------------------------	
#
#
sub preview {
	my $self = shift;
	my $forum = DB->get_data("$CONFIG->{forum_path}/$IN->{b}.info");
	my $uid	= $MEMBER->USER_ID();
	my $name = $MEMBER->login_name();

	my $hidden_tag = qq|
	<input type="hidden" name="ch" value="Forum">
	<input type="hidden" name="do" value="WriteReply">
	<input type="hidden" name="b" value="$IN->{b}">
	<input type="hidden" name="cid" value="$IN->{cid}">
	<input type="hidden" name="t" value="$IN->{t}">
	<input type="hidden" name="omm" value="$IN->{omm}">
	<input type="hidden" name="target" value="$IN->{target}">|;
	
	if ($name) { 
		$hidden_tag .= qq|
		<input type="hidden" name="Author" value="$name">
		<input type="hidden" name="UserID" value="$uid">|;
	
	} else {
		$name = "<input type=\"text\" onfocus=\"WritePost.Author.value=''\" name=\"Author\" value=\"$IN->{Author}\">";
		$hidden_tag .= '<input type="hidden" name="UserID" value="guest">';
	}

	my $html_use = "On"; 
	my $ch_code = "Off";
	
	if ($CONFIG->{use_chcode}) { $html_use = "Off"; $ch_code = "On"; }
	my $use_tag = "HTML ± : $html_use<br>CH ڵ : $ch_code<br>";
	my $content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\">";
	
	if ($CONFIG->{attach}) {
		$content_type = "<FORM ACTION=\"index.cgi\" NAME=\"WritePost\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">";
	}
	
	my $subject = DB->text_trim($IN->{Subject});
	my $author  = DB->text_trim($IN->{Author});
	my $message = DB->message_check($IN->{Message});
	my $msg_icon = "<img src=\"$CONFIG->{images_url}/icons/$IN->{icon}.gif\" align=\"absmiddle\">";
	
	my $review = qq|
	<table $VARS->{table}>
	<tr $VARS->{bg_header}>
		<td colspan="2"><$VARS->{header_font}><b>ۼϽ   ϴ.</b></font>
		</td>
	</tr>
	<tr $VARS->{bg_color1}>
		<td width="20%"><$VARS->{font}><b>۾:</b></font>
		</td>
		<td width="80%"><$VARS->{font}>$author</font>
		</td>
	</tr>
	<tr $VARS->{bg_color2}>
		<td><$VARS->{font}><b>:</b></font>
		</td>
		<td>$msg_icon <$VARS->{font}>$subject</font>
		</td>
	</tr>
	<tr $VARS->{bg_color1}>
		<td colspan="2" class="messagebody"><br>
		<blockquote><$VARS->{font}>$message</font></blockquote>
		</td>
	</tr>
	</table>|;
	
	my @data_line = ();
	my $data = DB->read_file("$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi");
		
	foreach (@$data) {
		chomp;
		/^REPLY.$IN->{omm}/ and @data_line = split /\Q$CONFIG->{db_delim}\E/ and last;
	}
	
	$self->{TEMPLATE} = DB->load_template("preview_reply.html");
	$self->{TEMPLATE}->param( DB->style_vars("亯 ̸") );
	$self->{TEMPLATE}->param(
		nav_bar		=> $self->navigation_bar(__PACKAGE__, $IN->{cid}, $IN->{b}) . "亯 ̸" . " ($IN->{Subject})",
		hidden_tag	=> $hidden_tag,
		author		=> $name,
		forum_name	=> $forum->{Name},
		use_tag		=> $use_tag,
		message_icons	=> DB->message_icon("gif"),
		jscript		=> DB->JSEmotion_CHCode(),
		emotion_chcode	=> DB->emotion_chcode(),
		content_type	=> $content_type,
		subject		=> $IN->{Subject},
		message		=> $IN->{Message},
		review		=> $review,
		old_subject	=> $data_line[2], 		#.
		q_message	=> $data_line[3], 		#ο ޽
		poster		=> $data_line[4], 		#۾
		date		=> $data_line[5], 		#¥
		time		=> $data_line[6], 		#ð
		msg_icon	=> "<img src=\"$CONFIG->{images_url}/icons/$data_line[8].gif\" align=\"absmiddle\">" );
	
	return $self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
#
#
sub save {
	my $self = shift;
	my ($topic_subject, $topic_starter, $forum_info, $threads_data, $data_line, $thread_file);

	$forum_info = DB->get_data("$CONFIG->{forum_path}/$IN->{b}.info");

	$IN->{Message} = DB->message_check($IN->{Message});
	$IN->{Subject} = DB->text_trim($IN->{Subject});
	$IN->{Author} = DB->text_trim($IN->{Author});

	$threads_data = $self->threads_def($IN);
	$threads_data->{'TR'}[1] = "REPLY";
	
	for ( qw!VIEW REPLIES CLOSED MODERATOR MAIL! ) { delete $threads_data->{$_} }

	#----------------------------------------------------------------------
	# ش   ϰ,  亯 ߰Ѵ.
	#----------------------------------------------------------------------
	
	$thread_file = "$CONFIG->{forum_path}/$IN->{b}/$IN->{t}.cgi";
	unless (-w $thread_file) {
		chmod 0666, $thread_file or die " ۹̼  .: $!\n";
	}
	
	# ε   .
	if ($IN->{AttachFile}) {
		my $filename = substr(time, -4) . int(rand(10000));
		my ($attach) = DB->attach_file("$IN->{b},$IN->{t}-$filename", $IN->{'AttachFile'});
			my $filesize = reverse $attach->{'filesize'}; 
			$filesize =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
			$threads_data->{FILENAME}[1] = "$IN->{b},$IN->{t}-$filename";
			$threads_data->{ATTACH}[1] = $attach->{'filename'};
			$threads_data->{ATTACH_TYPE}[1] = $IN->{FileType};
			$threads_data->{ATTACH_SIZE}[1] = scalar reverse $filesize;
	}
	
	my ($output, $data_line);
	my @val = ();
	my $count = 0;
	my $mailer = 0;
	my $starter_id = undef;
	
	DB->_lock($thread_file);
	open (FH, "<$thread_file") or $self->error_msg(" !", "   ϴ: $!");
		LINE: while (<FH>) {
			chomp;
			if (/^TOPIC/) {
				@val = split /\Q$CONFIG->{db_delim}\E/;
				$mailer = pop @val;
				$starter_id = $val[7] if defined $mailer;
				push @val, $mailer;
				$val[3] = $threads_data->{DATE}[1];
				$val[4] = $threads_data->{TIME}[1];
				$val[6]++;
				$topic_subject = $val[1];
				$topic_starter = $val[2];
				$data_line = join $CONFIG->{db_delim}, @val;
				$output .= $data_line . "\n";
			}
			else { 
				$output .= $_ . "\n";
			}
			$count++;
		}

		$threads_data->{'THREADNO'}[1] = $count - 1;
		my $threads_array = DB->data_rows($threads_data);
		
		$data_line = join $CONFIG->{db_delim}, @{$threads_array};
		$output .= "$data_line\n";
	close FH;
	
	open (FH, ">$thread_file") or $self->error_msg("  !", "   ϴ: $!");
		print FH $output;
	close FH;
	DB->_unlock($thread_file);
	
	#----------------------------------------------------------------------
	# 亯 ϵǸ  , Ϸ 뺸Ѵ.
	#----------------------------------------------------------------------

	if ($mailer and $starter_id) {
		my $user = $self->member_data($starter_id);
		my $subject = "$CONFIG->{title} $user->{MEMBER_ID} Կ   亯 ϵǾϴ.";
		my $msg = <<MESSAGE;
 $subject
 -------------------------------------------------------------
  湮Ͽ 亯 о ñ ٶϴ.

  URL: 
 $CONFIG->{script_url}/index.cgi?ch=Forum&do=ReadPost&cid=$IN->{cid}&b=$IN->{b}&t=$IN->{t}
 
 ۾: $IN->{Author}
 : $IN->{Subject}
    湮Ͽ б ٶϴ.

 մϴ.
 -------------------------------------------------------------
 $CONFIG->{site_title}.
 $CONFIG->{site_url}
MESSAGE

		require CH::Mailer;
		my $email = new CH::Mailer(
				From	=> "  <$CONFIG->{admin_email}>",
				To	=> "$user->{MEMBER_ID} <$user->{EMAIL}>",
				Subject => $subject,
				Data	=> $msg,
				Encoding=> 'Base64',
				Type	=> "TEXT"
			) or $self->error_msg("  ", "CH::Mailer !");
		
		$email->send or $self->error_msg("  ", "CH::Mailer !");
	}	

	#----------------------------------------------------------------------
	# topic.db  Ѵ.
	#----------------------------------------------------------------------
	
	my $topic_file = "$CONFIG->{forum_path}/$IN->{b}/topic.db";
	
	unless (-w $topic_file) { 
		chmod 0666, $topic_file or die " ۹̼  : $!\n"; 
	}

	my $output_file;
	
	DB->_lock($topic_file);
	open (FH, "<$topic_file");
		LINE: while(<FH>) {
			/^\s*$/ and next LINE;
			chomp;
			my @array = split /\Q$CONFIG->{db_delim}\E/;
			
			if ($IN->{t} == $array[0]) {
				my @tmp = split /\Q$CONFIG->{db_delim}\E/;
				$tmp[1] = DB->sort_time();
				my $data_line = join $CONFIG->{db_delim}, @tmp;
				$output_file .= "$data_line\n";
			}
			else { $output_file .= "$_\n"; }
		}
	close FH or die "$topic_file    ϴ: $!\n";
	
	open (FH, ">$topic_file");
		print FH $output_file;
	close FH;
	DB->_unlock($topic_file);
	
	#----------------------------------------------------------------------
	# α  ȸ  ȸ  ۼ   Ѵ.
	#----------------------------------------------------------------------
	
	unless ($IN->{UserID} eq "guest") {
		my $file = "$CONFIG->{member_directory}/$IN->{UserID}.cgi";
		my $member = DB->get_data($file);
		
		$member->{POST} += 1;
		
		DB->_dumper($file, $member);
	}

	#----------------------------------------------------------------------
	#   Ѵ.
	#----------------------------------------------------------------------
	
	$forum_info->{Threads} 		+= 1;
	$forum_info->{LastTopic}	= $topic_subject;
	$forum_info->{LastAuthor}	= $topic_starter;
	$forum_info->{LastTopicDate} 	= $threads_data->{DATE}[1];
	$forum_info->{LastTopicTime}	= $threads_data->{TIME}[1];
	$forum_info->{LastTopicNo}	= $IN->{t};
	$forum_info->{MessageIcon}	= $threads_data->{MSG_ICON}[1];
	
	DB->_dumper("$CONFIG->{forum_path}/$IN->{b}.info", $forum_info);
	
	my $html_output = qq~
	<font size="2"><b>
		亯   ϵǾϴ.<br>
		    ּż մϴ.<p>
		 ٸø   ưϴ. մϴ.<p></b>
		
		<img src="$CONFIG->{images_url}/anim1.gif"><P>
		
		<a href="index.cgi?ch=Forum&cid=$IN->{cid}&do=PostList&b=$IN->{b}">۸</a> |
		<a href="index.cgi?ch=Forum&cid=$IN->{cid}&do=ReadPost&b=$IN->{b}&t=$IN->{t}">ۼ б</a>
	</font>~;

	$self->{TEMPLATE} = DB->load_template("reply_success.html");
	$self->{TEMPLATE}->param( DB->style_vars() );
	$self->{TEMPLATE}->param(
			target	=> "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"2; URL=$IN->{target}\">",
			html_output => $html_output );
	
	$self->{TEMPLATE}->output;
}

#----------------------------------------------------------------------
